      SUBROUTINE BCOUT
*.
*...BCOUT    Called once at the end of event and clustering.......
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : 
*. CALLS     : 
*. CALLED    : GUOUT
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 22-May-1995
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
*.
*.*********************************************************************
*.     +------------------------+                                     *
*.     | Bank Name  :  MCB?CLUS |                                     *
*.     +------------------------+                                     *
*.                                                                    *
*.     Contents    : List of Barrel Calorimeter hits on tracks which  *
*.                   the JIM generated.                               *
*.     Record Type : 1-dim. variable length segment                   *
*.     Version     : Release 1.0  1995-Apr-21                         *
*.                                                                    *
*.*********************************************************************
*.
*.(1) Contents in the Master Segment
*.----------------------------------
*.
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. IDATA(1)      # of clusters
*. IDATA(2)      # of charged cluster ( Not Available )
*. IDATA(3)      # of neutral cluster ( Not Available )
*. IDATA(4)      ID of clustering program
*. RDATA(5)      Total Energy of All clusters
*. RDATA(6-11)   Clustering parameters
*.----------------------------------------------------------------------
*.
*.(Note)
*.   Master segment = segment # 0
*.
*.
*.(2) Contents in the Data Segment
*.--------------------------------
*. # of Data Segment = # of clusters + 1(master segment)
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. RDATA(1)      Energy of the cluster
*. RDATA(2)      Ex/E
*. RDATA(3)      Ey/E
*. RDATA(4)      Ez/E
*. IDATA(5)      # hit cell ( N cells )
*. IDATA(6)      # of matched CDC tracks ( M tracks )
*. IDATA(7)    |
*.    -        + Contributed cell ID#
*. IDATA(6+N)  |
*. IDATA(7+N)  |
*.    -        + Contributed CDC Track ID
*. IDATA(6+N+M)|
*.----------------------------------------------------------------------
*. Length of Data Segment = 6+N+M
*.**********************************************************************
      
      IMPLICIT NONE

#include "bcgeo.inc"

      REAL CLSPBC(5,2)

      INTEGER NMXDT,LNGBKE
      PARAMETER(NMXDT  = 5000)
      PARAMETER(LNGBKE = 100)
      INTEGER NDTH(2),NDPH(2)
      INTEGER NHTDAT,BNKIDX(NMXDT)
      INTEGER NCLSPT(2,NMXDT),CLSIDX(NMXDT)
      REAL BNKDAT(LNGBKE,NMXDT),RHDAT(3,NMXDT),ISRTKY(NMXDT)
      REAL CLSPS1(3),CLSPS3(3),VECT(6)
      INTEGER ITRDAT(NMXDT)

      INTEGER NDATA
      REAL    RDATA(LNGBKE)
      INTEGER IDATA(LNGBKE)
      EQUIVALENCE(IDATA(1),RDATA(1))

      CHARACTER*32 CIBNK(2),COBNK(2)
      DATA CIBNK/ 'MCBEHIT ' , 'MCBHHIT ' /
      DATA COBNK/ 'MCBECLUS' , 'MCBHCLUS' /

      INTEGER ID,NSEG,ISEG,NSSEG,IT,I,NUMCLS,IER,NCEL,NCTRAK,IVECT
      INTEGER ICTR,NCTR,NCT,ISTART
      REAL ESUM


      NDTH(1) = NDTHBC*2
      NDTH(2) = NDTHBC
      NDPH(1) = NDPHBC*2
      NDPH(2) = NDPHBC

      DO 1000 ID=1,2

*-- Start  ID = 1:EM 2:HAD

*-- 1. GET Master Segment DATA of Bank MCBEHIT
         CALL KZNSEG(CIBNK(ID),NSEG)
         CALL KZGET(CIBNK(ID),0,NDATA,IDATA)

*-- 2. Get Secondary Segment DATA of Bank MCBEHIT
         NHTDAT = IDATA(1)
         DO 10 ISEG = 1,NHTDAT
            CALL KZGET(CIBNK(ID),ISEG,NSSEG,RDATA)
            IF(ID.EQ.1) THEN
               ISRTKY(ISEG)   = RDATA(2)
               BNKDAT(1,ISEG) = FLOAT(IDATA(1))
               BNKDAT(2,ISEG) = RDATA(2)
               BNKDAT(3,ISEG) = RDATA(3)
               BNKDAT(4,ISEG) = FLOAT(IDATA(4))
               DO 11 IT = 1,IDATA(4)
                  BNKDAT(4+IT,ISEG) = IDATA(3*IT+2)
 11            CONTINUE
            ELSE IF(ID.EQ.2) THEN
               ISRTKY(ISEG)   = RDATA(2)+RDATA(3)
               BNKDAT(1,ISEG) = FLOAT(IDATA(1))
               BNKDAT(2,ISEG) = RDATA(2)+RDATA(3)
               BNKDAT(3,ISEG) = RDATA(4)
               BNKDAT(4,ISEG) = FLOAT(IDATA(5))
               DO 12 IT=1,IDATA(5)
                  BNKDAT(4+IT,ISEG) = IDATA(4*IT+2)
 12            CONTINUE
            ENDIF
 10      CONTINUE

*-- 3. Sort DATA according to Energy
         CALL SORTZV(ISRTKY,BNKIDX,NHTDAT,1,1,0)
         DO 20 I=1,NHTDAT
            RHDAT(1,I) = BNKDAT(1,BNKIDX(I))
            RHDAT(2,I) = BNKDAT(2,BNKIDX(I))
            RHDAT(3,I) = BNKDAT(3,BNKIDX(I))
 20      CONTINUE

*-- 4. Main Clustring Routine (using JADE argorithm)
         CALL BCCLSR(RHDAT,NHTDAT,NDTH(ID),NDPH(ID),CLSPBC(1,ID),
     +        NMXDT,NUMCLS,NCLSPT,CLSIDX)

*-- 5. Create Bank ( 1-dim Free Format Type. )
         CALL KZBCR0(COBNK(ID),IER)
         
*-- 6.Fill Master Segment
         ESUM = 0.
         IDATA(1)  = NUMCLS
         IDATA(2)  = NUMCLS
         IDATA(3)  = NUMCLS
         IDATA(4)  = 0
         CALL KZREP0(COBNK(ID),0,'I',4,IDATA)
         DO 30 ISEG=1,NUMCLS
            NCEL     = 0
            NCTRAK   = 0
            RDATA(1) = 0.
            CALL VZERO(CLSPS1,3)
            IDATA(5) = NCLSPT(2,ISEG)-NCLSPT(1,ISEG)+1
            DO 31 I=NCLSPT(1,ISEG),NCLSPT(2,ISEG)
               ESUM = ESUM + RHDAT(2,I)
               NCEL = NCEL + 1
               RDATA(1) = RDATA(1) + RHDAT(2,I)
               IDATA(5+NCEL)=INT(RHDAT(1,I))

*-- 7.Energy Weighted Cluster Position
               CALL BCGPS(ID,IDATA(5+NCEL),VECT,IER)
               
               DO 32 IVECT = 1,3
                  CLSPS1(IVECT) = CLSPS1(IVECT) 
     &                 + VECT(IVECT)*RHDAT(2,I)**CLSPBC(5,ID)
 32            CONTINUE

*-- 8. Store Contributed Trak ID
               ICTR = BNKIDX(CLSIDX(I))
               NCTR = BNKDAT(4,ICTR)
               DO 33 IT=1,NCTR
                  NCTRAK=NCTRAK+1
                  ITRDAT(NCTRAK) = BNKDAT(4+IT,ICTR)
 33            CONTINUE
 31         CONTINUE

*--  Remove Duplicated Charged Track ID # 
            NCT = 0
            ISTART=0
 35         CONTINUE
            ISTART = ISTART +1
            NCT = NCT + 1
            IF(ISTART.GT.NCTRAK) THEN
               NCT = NCT - 1
               GOTO 36
            END IF
            IF(ITRDAT(ISTART).EQ.0) THEN
               NCT = NCT -1
               GOTO 35
            END IF
            DO 34 IT = ISTART+1,NCTRAK
               IF(ITRDAT(IT).EQ.ITRDAT(ISTART)) ITRDAT(IT)=0
 34         CONTINUE
            ITRDAT(NCT) = ITRDAT(ISTART)
            GOTO 35
 36         CONTINUE

*-- Fill Particle to Detector Pointer
            CALL VUNIT(CLSPS1,CLSPS3,3)
            RDATA(2)      = CLSPS3(1)
            RDATA(3)      = CLSPS3(2)
            RDATA(4)      = CLSPS3(3)
            IDATA(6+NCEL) = NCT
            CALL KZREP0(COBNK(ID),ISEG,'F',4,RDATA(1))
            CALL KZREP0(COBNK(ID),ISEG,'I',1,NCEL)
            CALL KZREP0(COBNK(ID),ISEG,'I',1,NCT)
            CALL KZREP0(COBNK(ID),ISEG,'I',NCEL,IDATA(6))
            CALL KZREP0(COBNK(ID),ISEG,'I',NCT,ITRDAT(1))

 30      CONTINUE

         RDATA(1)  = ESUM
         RDATA(2)  = CLSPBC(1,ID)
         RDATA(3)  = CLSPBC(2,ID)
         RDATA(4)  = CLSPBC(3,ID)
         RDATA(5)  = CLSPBC(4,ID)
         RDATA(6)  = CLSPBC(5,ID)
         CALL KZREP0(COBNK(ID),0,'F',6,RDATA)
         
 1000 CONTINUE
      
      RETURN
      END
