      SUBROUTINE CTHSIM
*.
*...CTHSIM   create CT hits for each layer from information of
*.           'MCCTHITINF' which gives information at entering/exiting
*.           points to super layer cells
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : J.Kanzaki
*. VERSION   : 1.00
*. CREATED   : 06-Mar-1999
*.
*.**********************************************************************

      IMPLICIT NONE
      
#include "jlcnst.inc"
#include "buffer.inc"
#include "ctgeo.inc"      

      INTEGER NHIT,IHIT
      INTEGER NHTOT,NHANO

      INTEGER NWMAST,LSEGM
      PARAMETER (NWMAST=1,LSEGM=7)
      CHARACTER*32 CFORMM,CFORMS
      PARAMETER (CFORMM='1I',CFORMS='3I 4F')
      INTEGER IDATA(LSEGM)
      REAL RDATA(LSEGM)
      EQUIVALENCE (IDATA(1),RDATA(1))

      INTEGER ILAY,IPHI,IWIRE
      REAL XI,YI,ZI
      REAL PXI,PYI
      REAL XO,YO,ZO
      REAL XC,YC,RC
      REAL RADI0,RADI1,PHIIC
      REAL RADO0,RADO1,PHIOC
      REAL DMIN,RMIN
      REAL TOFI,TOFO

      REAL SIGXY
C      PARAMETER (SIGXY=0.)
      PARAMETER (SIGXY=0.010)

      INTEGER IANO
      
      REAL PHI0,DPHI,PHI
      REAL DZ
      REAL XX,YY,ZZ
      REAL TOF

      REAL ALPHA
      PARAMETER (ALPHA=15.)
      
      REAL DRALPH,RHIT,DR
      REAL DHITI,DHITO

      REAL D,DD

      INTEGER LVEC
      PARAMETER (LVEC=3)
      REAL RVEC(LVEC)

      REAL GMPHI2

      INTEGER IERR

c      real ri,ro


      CALL KZGET('MCCTHITINF',0, NBUFF,IBUFF)
*-- Total number of hits in MCCTHITINF bank
      NHIT = IBUFF(1)

*-- Create MCCTHIT bank
      CALL KZBCR1('MCCTHIT',NWMAST,CFORMM,NANOCT*NHIT,LSEGM,CFORMS,IERR)

      NHTOT = 0
      DO 100 IHIT=1,NHIT
         
         CALL KZGET('MCCTHITINF',IHIT,NBUFF,IBUFF)

         ILAY  = IBUFF(2)/IALYCT
         IPHI  = MOD(IBUFF(2),IALYCT)/IAPHCT
         IWIRE = MOD(IBUFF(2),IAPHCT)/IAWRCT

         XI = RBUFF(3)
         YI = RBUFF(4)
         ZI = RBUFF(5)
c         ri = sqrt(xi**2+yi**2)

         PXI = RBUFF(6)
         PYI = RBUFF(7)

         TOFI = RBUFF(9)

         XO = RBUFF(10)
         YO = RBUFF(11)
         ZO = RBUFF(12)
c         ro = sqrt(xo**2+yo**2)

         TOFO = RBUFF(16)

         CALL GMCIR2(XI,YI,PXI,PYI,XO,YO,XC,YC,RC,IERR)

         PHI0 = ATAN2(YI-YC,XI-XC)
         DPHI = GMPHI2(XC,YC,XI,YI,XO,YO)

         IF (IAXSCT(ILAY).EQ.0) THEN

            IF(NPLYCT(ILAY).GT.0) THEN

               PHIIC = FLOAT(IPHI-1)*X2PI/FLOAT(NPLYCT(ILAY))

            ENDIF

            RADI0 = RILYCT(ILAY)
            RADI1 = RILYCT(ILAY)+RLSCCT
c            print *,'cthsim;xi,yi,zi,ri = ',xi,yi,zi,ri
c            print *,'      ;xo,yo,zo,ro = ',xo,yo,zo,ro
c            print *,'      ; rc = ',rc

c            print *,'      ;radi0,radi1 = ',radi0,radi1

         ELSE

            CALL CTZCEL(ZI,ILAY,IPHI,RADI0,RADI1,PHIIC)

         ENDIF

         DMIN = AMAX1(XI**2+YI**2-(XI*COS(PHIIC)+YI*SIN(PHIIC))**2,
     &        0.)
         DMIN = SQRT(DMIN)
         DRALPH = SIGN(DMIN*TAN(ALPHA*XDG2RD),
     &        COS(PHIIC)*YI-SIN(PHIIC)*XI) 
         RMIN = XI*COS(PHIIC)+YI*SIN(PHIIC)
         RHIT = RMIN + DRALPH
         DR = (RADI1-RADI0)/FLOAT(NANOCT)

         IF (DR.NE.0.) THEN
            DHITI = (RHIT-RADI0)/DR
         ELSE
         ENDIF

         IF (IAXSCT(ILAY).EQ.0) THEN

            PHIOC = FLOAT(IPHI-1)*X2PI/FLOAT(NPLYCT(ILAY))

            RADO0 = RILYCT(ILAY)
            RADO1 = RILYCT(ILAY)+RLSCCT

c            print *,'      ;rado0,rado1 = ',rado0,rado1

         ELSE
         
            CALL CTZCEL(ZO,ILAY,IPHI,RADO0,RADO1,PHIOC)

         ENDIF
         
         DMIN = AMAX1(XO**2+YO**2-(XO*COS(PHIOC)+YO*SIN(PHIOC))**2,
     &        0.)
         DMIN = SQRT(DMIN)
         DRALPH = SIGN(DMIN*TAN(ALPHA*XDG2RD),
     &        COS(PHIOC)*YO-SIN(PHIOC)*XO) 
         RMIN = XO*COS(PHIOC)+YO*SIN(PHIOC)
         RHIT = RMIN + DRALPH
         DR = (RADO1-RADO0)/FLOAT(NANOCT)

         IF (DR.NE.0.) THEN
            DHITO = (RHIT-RADO0)/DR
         ELSE
         ENDIF

         NHANO = 0
         DO 110 IANO=1,NANOCT
            D = FLOAT(IANO-1)+0.5
            IF (DHITO.NE.DHITI) THEN
               DD = (D-DHITI)/(DHITO-DHITI)
            ELSE
            ENDIF
            IF (DD.GT.0. .AND. DD.LT.1.) THEN
               NHANO = NHANO+1
               PHI = PHI0+DD*DPHI
               XX = XC+RC*COS(PHI)
               YY = YC+RC*SIN(PHI)
               ZZ = ZI+DD*(ZO-ZI)
               TOF = TOFI+DD*(TOFO-TOFI)
               IDATA(1) = IBUFF(1)
               IDATA(2) = IALYCT*ILAY+IAPHCT*IPHI+IAWRCT*IANO
               IDATA(3) = IHIT
               CALL RNORM(RVEC,LVEC)
               IF (IAXSCT(ILAY).EQ.0) THEN
                  RDATA(4) = XX+SIGXY*RVEC(1)
                  RDATA(5) = YY+SIGXY*RVEC(2)
                  RDATA(6) = ZZ
               ELSE
                  RDATA(4) = XX+SIGXY*RVEC(1)
                  RDATA(5) = YY+SIGXY*RVEC(2)
                  RDATA(6) = ZZ+SIGXY/TAN(SANGCT(ILAY)*XDG2RD)*RVEC(3)
               ENDIF
               RDATA(7) = TOF
               CALL KZREP1('MCCTHIT',NHTOT+NHANO,LSEGM,IDATA)
c               IF (IAXSCT(ILAY).EQ.0) THEN
c                  print *,'      ;xx,yy,zz,r = ',
c     &                 xx,yy,zz,sqrt(xx**2+yy**2)
c                  xx = xc+rc*cos(phi0)
c                  yy = yc+rc*sin(phi0)
c                  zz = zi
c                  print *,'      ;xi,yi,zi = ',xx,yy,zz
c                  xx = xc+rc*cos(phi0+dphi)
c                  yy = yc+rc*sin(phi0+dphi)
c                  zz = zi+(zo-zi)
c                  print *,'      ;xo,yo,zo = ',xx,yy,zz
c               endif
            ENDIF
 110     CONTINUE

         IF (NHANO.GT.0) THEN
            IDATA(1) = NHANO
            IDATA(2) = NHTOT
            CALL KZPUT1('MCCTHITINF',IHIT,17,2,IDATA)
            NHTOT = NHTOT+NHANO
         ENDIF
         
 100  CONTINUE 
c      print *,'cthsim;nhtot = ',nhtot
      
      IDATA(1) = NHTOT
      CALL KZREP1('MCCTHIT',0,NWMAST,IDATA)

      RETURN
      END
