*.    CALPOS
*.
*...CALPOS   CALORIMETER CELL INFORMATIONS
*.
*.   NBETHE : Cell id in BE THETA 
*.   NBEPHI : Cell id in BE PHI   
*.   BCEPOS(6,NBETHE,NBEPHI) : Barrel ECAL position
*.                             (1=X, 2=Y, 3=Z, 
*.                              4=R: distance, 5=THETA, 6=PHI)
*.   BEFACT(4,NBETHE) : BE Calibration factor
*.                      (1=constant for e+/e-/gamma
*.                       2=constant for hadrons
*.                       3=with THETA dependence for e+/e-/gamma
*.                       4=with THETA dependence for hadrons)
*.
*.   NBHTHE : Cell id in BH THETA
*.   NBHPHI : Cell id in BH PHI  
*.   BCHPOS(6,NBHTHE,NBHPHI) : Barrel HCAL position
*.   BHFACT(4,NBETHE) : BH Calibration factor
*.
*.   NEERAD : Cell id in EE RADIUS
*.   NEEPHI : Cell id in EE PHI 
*.   IFORB  : Forward(=1) or Backward(=2)  
*.   ECEPOS(6,NEERAD,NEEPHI,IFORB) : Endcap ECAL position
*.   EEFACT(4,NEERAD) : EE Calibration factor
*.
*.   NEHRAD : Cell id in EH RADIUS
*.   NEHPHI : Cell id in EH PHI  
*.   IFORB  : Forward(=1) or Backward(=2)  
*.   ECHPOS(6,NEHRAD,NEHPHI,IFORB) : Endcap HCAL position
*.   EHFACT(4,NEHRAD) : EH Calibration factor
*.
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : K.Ishii
*. VERSION   : 1.00
*. CREATED   : 06-Mar-1999
*. LAST MOD  : 06-Mar-1999
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
      INTEGER NBETHE,NBEPHI,NBHTHE,NBHPHI
      PARAMETER (NBETHE=100, NBEPHI=200, NBHTHE=50, NBHPHI=100)
      INTEGER NEERAD,NEEPHI,NEHRAD,NEHPHI
      PARAMETER (NEERAD=40, NEEPHI=200, NEHRAD=20, NEHPHI=100)     
      REAL BCEPOS(6,NBETHE,NBEPHI),BCHPOS(6,NBHTHE,NBHPHI)
      REAL ECEPOS(6,NEERAD,NEEPHI,2),ECHPOS(6,NEHRAD,NEHPHI,2)
      REAL BEFACT(4,NBETHE),BHFACT(4,NBHTHE)
      REAL EEFACT(4,NEERAD),EHFACT(4,NEHRAD)
      COMMON /CALPOS/ 
     &      BCEPOS,BCHPOS,ECEPOS,ECHPOS,
     &      BEFACT,BHFACT,EEFACT,EHFACT
      SAVE /CALPOS/

