      SUBROUTINE AMDIGI
*.
*...AMDIGI   Compute and store DIGIts for Active Mask
*.
*. INPUT     : non
*. OUTPUT    : non
*.
*. SEQUENCE  :
*. COMMON    : AMGEO  GCNUM
*. CALLS     : GFHITS KZBCR1 KZPUT1 JGP2LP
*. CALLED    : GUDIGI
*.
*. BANKS L   : MCAMHIT
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : J.Kanzaki
*. VERSION   : 1.00
*. CREATED   : 24-Jan-1999
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.
*. Bank Data Structure ;
*. name = MCAMHIT
*.        Master Segment  
*.                        #1  total number of hits
*.
*.        Data Segment   
*.                        #1  track number responsible to this hit
*.                        #2  F/B
*.                        #3  Layer#
*.                        #4  Phi#
*.                        #5  Radial#
*.                        #6  Particle ID (PDG code)
*.                        #7  x coordinate of this hit [cm]
*.                        #8  y coordinate of this hit [cm]
*.                        #9  z coordinate of this hit [cm]
*.                        #10  p of particle generated this hit [GeV]
*.                        #11 Px of particle [GeV]
*.                        #12 Py of particle [GeV]
*.                        #13 Pz of particle [GeV]
*.                        #14 energy deposit to this pad [keV]
*.
*.**********************************************************************
      IMPLICIT NONE

*-- Common
#include "geant321/gcnum.inc" 
#include "amgeo.inc"
#include "amhit.inc"
#include "amsmdt.inc"
#include "jmdet.inc"
     
      INTEGER NDATMX
      PARAMETER (NDATMX=14)
      INTEGER NUMVS(NDSVAM),NUMBV(NDSVAM,NHMXAM),ITRA(NHMXAM)
      REAL    HITS(NDHTAM,NHMXAM)

      INTEGER   IDATA(NDATMX)
      REAL      RDATA(NDATMX)
      EQUIVALENCE (IDATA(1), RDATA(1))
      CHARACTER*32 CFMAMH,CFSAMH
      INTEGER NWMAMH,NWPAMH
*-- Parameter for bank
      PARAMETER (NWMAMH=1)
      PARAMETER (CFMAMH='1I')
      PARAMETER (CFSAMH='6I 8F')
      PARAMETER (NWPAMH=0)
      
      INTEGER NUMHIT
      INTEGER NHITS,NHITSH,IHIT,IHT

      INTEGER ILPC

      CHARACTER*80 CMSG
      INTEGER LNBLNK

      INTEGER I,J,IERR


*-- Initialize
      DO 10 I=1,NDSVAM
         NUMVS(I)=0
 10   CONTINUE
*
*-- check skip frag
      IF (ISIMJD(IDETAM).EQ.ISKPJD) THEN 
         GOTO 999
      ELSE IF (ISIMJD(IDETAM).EQ.ISMRJD) THEN 
         GOTO 998
      ENDIF
      
      NUMHIT=0
      DO 20 I=1,NLAYAM

         CALL GFHITS('AM  ',VNAMAM(I),NDSVAM,NDHTAM,NHMXAM,0,NUMVS,
     &        ITRA,NUMBV,HITS,NHITS)
         IF (NHITS.GT.NHMXAM) THEN
            WRITE(CMSG,'(''Nhits overflow for layer '',I1)') I
            CALL MSGOUT('AMDIGI',CMSG(1:LNBLNK(CMSG)),NHMXAM)
            NHITS = NHITS-1
         ENDIF    
         NUMHIT = NUMHIT+NHITS

 20   CONTINUE

*-- Create new ZBS bank with the 1-dim. fixed length segment.
      CALL KZBCR1('MCAMHIT',NWMAMH,CFMAMH,NUMHIT,NDATMX,CFSAMH, IERR)
      
*-- Retrieve HITS produced by tracks
      
      IHIT = 0
      DO 100 I=1,NLAYAM
         
         CALL GFHITS('AM  ',VNAMAM(I),NDSVAM,NDHTAM,NHMXAM,0,NUMVS,
     &        ITRA,NUMBV,HITS,NHITS)
         IF (NHITS.GT.NHMXAM) THEN
            NHITS = NHMXAM
         ENDIF    

*-- Loop of hit in this detector name
         DO 110 IHT=1,NHITS
            IHIT = IHIT+1
            IDATA(1) = ITRA(IHT)
            IDATA(2) = NUMBV(1,IHT)
            IDATA(3) = NUMBV(2,IHT)
            IDATA(4) = NUMBV(3,IHT)
            IDATA(5) = NUMBV(4,IHT)
            
            CALL JGP2LP(NINT(HITS(1,IHT)), ILPC,IERR)
            IF (IERR.EQ.0) THEN
               IDATA(6) = ILPC
            ELSE
               IDATA(6) = 9999
            ENDIF
            DO 120 J=7,NDATMX
               RDATA(J) = HITS(J-5,IHT)
 120        CONTINUE
         
*-- Put data words into the given segment of the bank
            CALL KZPUT1('MCAMHIT',IHIT,NWPAMH,NDATMX,IDATA)

 110     CONTINUE

 100  CONTINUE

*-- Put data words into the master segment of the bank
      IDATA(1) = NUMHIT
      CALL KZPUT1('MCAMHIT',0,0,NWMAMH,IDATA)
* done
      GOTO 999
*
*-- in the case smearing
 998  IF (ISIMJD(IDETAM).EQ.ISMRJD) THEN 
         
*-- Create new ZBS bank with the 1-dim. fixed length segment.
         CALL KZBCR1('MCAMSMHT',1,'1I',NAMSMH,9,'2I 7F',IERR)
*-- KZPUT master segment
         IDATA(1) = NAMSMH
         CALL KZPUT1('MCAMSMHT',0,0,1,IDATA)
*-- loop over contributed tracks
         DO 200 I=1,NAMSMH
*-- copy buffer data to array           
            CALL UCOPY(IAMSMH(1,I),IDATA(1),2)
            CALL UCOPY(RAMSMH(1,I),IDATA(3),7)
*-- KZPUT data segment            
            CALL KZPUT1('MCAMSMHT',I,0,9,IDATA)
*            WRITE (*,'(3I5,7F10.3)') I,(IDATA(J),J=1,2),(RDATA(J),J=3,9)
*            
 200     CONTINUE 
      ENDIF
      
 999  CONTINUE 
      RETURN
      END
