      SUBROUTINE BMHITS
*.
*...BMHITS   Store HITS for the beam profile monitor
*.
*. INPUT     : non
*. OUTPUT    : non
*.
*. SEQUENCE  :
*. COMMON    : GCSETS GCKINE GCTRAK
*. CALLS     : GSCHIT
*. CALLED    : GUSTEP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : T. Tauchi
*. VERSION   : 1.00
*. CREATED   : 29-Aug-1996
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*. 10-Feb-1997 T.Tauchi; add parameters of origin;IPAOLD,VERT(3),PVERT(3).
*. 28-Jan-1997 T.Tauchi; add Px,Py,Pz in hits.
*.
*.**********************************************************************
*
*--   HITS(1): Particle code
*--   HITS(2): X position
*--   HITS(3): Y position
*--   HITS(4): X position
*--   HITS(5): Momentum of the particle
*--   HITS(6): Deposited energy
*--   HITS(7): Px of the particles
*--   HITS(8): Py of the particles
*--   HITS(9): Pz of the particles
*--   HITS(10): Particle code of previous track
*--   HITS(11): VERT(1) of current track
*--   HITS(12): VERT(2) of current track
*--   HITS(13): VERT(3) of current track
*--   HITS(14): PVERT(1) of current track
*--   HITS(15): PVERT(2) of current track
*--   HITS(16): PVERT(3) of current track
      
      IMPLICIT NONE

*--   Common for GEANT
#include "geant321/gcsets.inc"
#include "geant321/gckine.inc"
#include "geant321/gctrak.inc"
#include "geant321/gctmed.inc"
#include "geant321/gcvolu.inc"
      
#include "bmhit.inc"
      
      INTEGER IHIT

      REAL HITS(NDHTBM)


*--   When track is exiting current volume, do this routine
C      IF (INWVOL.NE.2) GOTO 999
      IF (DESTEP.LE.0.) RETURN

      HITS(1)=IPART
      HITS(2)=VECT(1)
      HITS(3)=VECT(2)
      HITS(4)=VECT(3)
      HITS(5)=VECT(7)
*-- add      
      HITS(6)=VECT(7)*VECT(4)
      HITS(7)=VECT(7)*VECT(5)
      HITS(8)=VECT(7)*VECT(6)
*-- add informations of origin of current track
      HITS(9)=IPAOLD
      HITS(10)=VERT(1)
      HITS(11)=VERT(2)
      HITS(12)=VERT(3)
      HITS(13)=PVERT(1)
      HITS(14)=PVERT(2)
      HITS(15)=PVERT(3)
*-- for GSCHIT, place hit-elements for accumulation in the last.
      HITS(16)=DESTEP

C      CALL GSAHIT(ISET,IDET,ITRA,NUMBV,HITS,IHIT)
      CALL GSCHIT(ISET,IDET,ITRA,NUMBV,HITS,1,IHIT)

  999 CONTINUE
      RETURN
      END
