      SUBROUTINE BPGEOM
*.
*...BCGEOM   Geomtry of the Beam Pipe at IR. 
*.           Tube + Cone + Tube + Cone + Tube
*.           (Al)   (Al)   (Be)   (Al)   (Al)
*.       Modified: 05-Oct-1999
*.           (Al)   (Be)   (Be)   (Be)   (Al)
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : UCTMED
*. CALLS     : 
*. CALLED    : IRGEOM
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*. AUTHOR    : Yoshiaki Fujii
*. VERSION   : 1.00
*. CREATED   : 29-Aug-1996
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*. 05-Oct-1999 : T.Tauchi
*.               change material of "Cone" part
*. 05-Oct-1999 : T.Tauchi
*.               define connection between large and small 
*.               beam pipes
*.
*.**********************************************************************
      IMPLICIT NONE
      
#include "jmdet.inc"
#include "jmmed.inc"
#include "jmmat.inc"
#include "jmrot.inc"
#include "irgeo.inc"
      
      INTEGER IBERY,IALUM
      
      REAL PAR(11)
      REAL Z
      INTEGER IVOLU
      
      IBERY = NMEDJM*IDETIR+IDBPIR+1
      CALL GSTMED(IBERY,'BPBE', IMBERY, NOSENS, IFIELD, FIELDM,
     &     TMAXFD,STEMAX,DEEMAX,EPSIL,STMIN,UBUF,NWBUF )
      
      IALUM = NMEDJM*IDETIR+IDBPIR+2
      CALL GSTMED(IALUM,'BPAL', IMALUM, NOSENS, IFIELD, FIELDM,
     &     TMAXFD,STEMAX,DEEMAX,EPSIL,STMIN,UBUF,NWBUF )

*-- Central Part
      PAR(1) = RINBP(1)
      PAR(2) = RINBP(1) + THIKBP(1)
      PAR(3) = ZPOSBP(1)
      CALL GSVOLU('BPBE','TUBE',IBERY,PAR,3,IVOLU)
      CALL GSPOS('BPBE',1,'MAST',0.,0.,0.,0,'ONLY')
CKI      CALL GSPOS('BPBE',1,'MAST',0.,0.,0.,0,'MANY')

      PAR(1) = 0.
      PAR(2) = RINBP(1)
      PAR(3) = ZPOSBP(1)
      CALL GSVOLU('BPVA','TUBE',IVACJM,PAR,3,IVOLU)
      CALL GSPOS('BPVA',1,'MAST',0.,0.,0.,0,'ONLY')

*-- Define Geometry for Conical Part.
      PAR(1) = ( ZPOSBP(2) - ZPOSBP(1) ) / 2.0
      PAR(2) = RINBP(1)
      PAR(3) = RINBP(1) + THIKBP(1)
      PAR(4) = RINBP(2)
      PAR(5) = RINBP(2) + THIKBP(2)
      CALL GSVOLU('BPFW','CONE',IBERY,PAR,5,IVOLU)

      PAR(1) = ( ZPOSBP(2) - ZPOSBP(1) ) / 2.0
      PAR(2) = 0.
      PAR(3) = RINBP(1)
      PAR(4) = 0.
      PAR(5) = RINBP(2)
      CALL GSVOLU('BPFV','CONE',IVACJM,PAR,5,IVOLU)

c      PAR(1) = ( ZPOSBP(2) - ZPOSBP(1) ) / 2.0
c      PAR(2) = RINBP(2)
c      PAR(3) = RINBP(2) + THIKBP(2)
c      PAR(4) = RINBP(1)
c      PAR(5) = RINBP(1) + THIKBP(1)
c      CALL GSVOLU('BPBC','CONE',IALUM,PAR,5,IVOLU)

      Z = ( ZPOSBP(2) + ZPOSBP(1) ) / 2.0
CKI      CALL GSPOS ('BPFC',1,'MAST',0,0, Z,0,'MANY')
CKI      CALL GSPOS ('BPBC',1,'MAST',0,0,-Z,0,'MANY')

      CALL GSPOS ('BPFW',1,'MAST',0,0, Z,0,'ONLY')
      CALL GSPOS ('BPFW',2,'MAST',0,0,-Z,IRMIRR,'ONLY')

      CALL GSPOS ('BPFV',1,'MAST',0,0, Z,0,'ONLY')
      CALL GSPOS ('BPFV',2,'MAST',0,0,-Z,IRMIRR,'ONLY')

*-- Define Large Aparture Tube Part
      PAR(1) = RINBP(2)
      PAR(2) = RINBP(2) + THIKBP(2)
      PAR(3) = ( ZPOSBP(3) - ZPOSBP(2) ) / 2.0
      CALL GSVOLU('BPLA','TUBE',IALUM,PAR,3,IVOLU)
C      CALL GSVOLU('BPBA','TUBE',IALUM,PAR,3,IVOLU)

      PAR(1) = 0.
      PAR(2) = RINBP(2)
      PAR(3) = ( ZPOSBP(3) - ZPOSBP(2) ) / 2.0
      CALL GSVOLU('BPLV','TUBE',IVACJM,PAR,3,IVOLU)

      Z = ( ZPOSBP(3) + ZPOSBP(2) ) / 2.0
CKI      CALL GSPOS('BPFA',1,'MAST',0,0, Z,0,'MANY')
CKI      CALL GSPOS('BPBA',1,'MAST',0,0,-Z,0,'MANY')

      CALL GSPOS('BPLA',1,'MAST',0,0, Z,0,'ONLY')
      CALL GSPOS('BPLA',2,'MAST',0,0,-Z,IRMIRR,'ONLY')
C      CALL GSPOS('BPBA',1,'MAST',0,0,-Z,0,'ONLY')
      
      CALL GSPOS('BPLV',1,'MAST',0,0, Z,0,'ONLY')
      CALL GSPOS('BPLV',2,'MAST',0,0,-Z,IRMIRR,'ONLY')

*-- The following part is added by T.Tauchi in Oct.1999
      
*-- Define CONNECTION between large and small beam pipes
      PAR(1) = RINBP(3)
      PAR(2) = RINBP(3) + THIKBP(3)
      PAR(3) = ( ZPOSBP(4) - ZPOSBP(3) ) / 2.0
      CALL GSVOLU('BPFX','TUBE',IALUM,PAR,3,IVOLU)
      CALL GSVOLU('BPBX','TUBE',IALUM,PAR,3,IVOLU)
*-- VACCUM inside the beam pipe
      PAR(1) = 0.
      PAR(2) = RINBP(3)
      CALL GSVOLU('BPV5','TUBE',IVACJM,PAR,3,IVOLU)
      CALL GSVOLU('BPV6','TUBE',IVACJM,PAR,3,IVOLU)

      Z = ( ZPOSBP(4) + ZPOSBP(3) ) / 2.0
      CALL GSPOS('BPFX',1,'MAST',0,0, Z,0,'ONLY')
      CALL GSPOS('BPFX',2,'MAST',0,0,-Z,IRMIRR,'ONLY')
C      CALL GSPOS('BPBX',1,'MAST',0,0,-Z,0,'ONLY')
      CALL GSPOS('BPV5',1,'MAST',0,0, Z,0,'ONLY')
      CALL GSPOS('BPV5',2,'MAST',0,0,-Z,IRMIRR,'ONLY')
C      CALL GSPOS('BPV6',1,'MAST',0,0,-Z,0,'ONLY')
      
*-- Define small beam pipe after beam monitor
      PAR(1) = RINBP(3)
      PAR(2) = RINBP(3) + THIKBP(4)
      PAR(3) = ( ZPOSBP(5) - ZPOSBP(4) ) / 2.0
      CALL GSVOLU('BPFY','TUBE',IALUM,PAR,3,IVOLU)
      CALL GSVOLU('BPBY','TUBE',IALUM,PAR,3,IVOLU)
*-- VACCUM insede the beam pipe
      PAR(1) = 0.
      PAR(2) = RINBP(3)
      CALL GSVOLU('BPV7','TUBE',IVACJM,PAR,3,IVOLU)
      CALL GSVOLU('BPV8','TUBE',IVACJM,PAR,3,IVOLU)

      Z = ( ZPOSBP(5) + ZPOSBP(4) ) / 2.0
      CALL GSPOS('BPFY',1,'MAST',0,0, Z,0,'ONLY')
      CALL GSPOS('BPFY',2,'MAST',0,0,-Z,IRMIRR,'ONLY')
C      CALL GSPOS('BPBY',1,'MAST',0,0,-Z,0,'ONLY')
      CALL GSPOS('BPV7',1,'MAST',0,0, Z,0,'ONLY')
      CALL GSPOS('BPV7',2,'MAST',0,0,-Z,IRMIRR,'ONLY')
C      CALL GSPOS('BPV8',1,'MAST',0,0,-Z,0,'ONLY')

      RETURN
      END
      
