      SUBROUTINE CTDIGI
*.
*...CTDIGI   Compute and store DIGIts for central tracker
*.           Create bank
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : CTGEO  GCNUM
*. CALLS     : GFHITS KZBCR1 KZBCR0 KZPUT1 KZPUT0 JGP2LP
*. CALLED    : GUDIGI
*.
*. BANKS L   : MCCTHIT
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 14-Apr-1994
*. LAST MOD  :  2-Mar-1999
*.
*. MODIFICATION LOG
*. 21-Apr-1999 J.Kanzaki, detailed version which include Tauchi's
*.             extension of hit bank is available
*. 06-Mar-1999, J.Kanzaki changed bank structure and also bank name
*.              for recreation MCCTHIT bank later
*. 02-Mar-1999, Nakamura change Bank structure
*. 31-Aug-1996, Y.Fujii   ; Added dE and Drift time tp MCCTHIT.
*. 27-Aug-1996, T.Tauchi  ; Check whether NHIT<NHMAX or not.  
*. 13-Mar-1996, J.Kanzaki ; Added x,y to the bank 'MCCTHIT', 
*.                          and added a pointer bank 'MCCTHIT-TRACK'.
*. 29-JUL-1994 N.HOSODA, Use JGP2LP
*.**********************************************************************
*. 
*--  Bank structure of MCCTHITINF
*--  
*--  IDATA( 1) : Track number     10000*ISTAK + ITRA(kine bank)
*--  IDATA( 2) : Cell address
*--            : 10000*(super layer number in radius) 
*--            :  + 10*(cell number in phi) 
*--            :  +    (wire number within cell)
*--  RDATA( 3) : X position            (when the track enters)
*--  RDATA( 4) : Y position            (when the track enters)
*--  RDATA( 5) : Z position            (when the track enters)
*--  RDATA( 6) : Px                    (when the track enters)
*--  RDATA( 7) : Py                    (when the track enters)
*--  RDATA( 8) : Pz                    (when the track enters)
*--  RDATA( 9) : Time of fright (nsec) (when the track enters)
*--  RDATA(10) : X position            (when the track leaves)
*--  RDATA(11) : Y position            (when the track leaves)
*--  RDATA(12) : Z position            (when the track leaves)
*--  RDATA(13) : Px                    (when the track leaves)
*--  RDATA(14) : Py                    (when the track leaves)
*--  RDATA(15) : Pz                    (when the track leaves)
*--  RDATA(16) : Time of fright (nsec) (when the track leaves)
*--  RDATA(17) : Energy Deposit
*--  IDATA(18) : Number of MCCTHIT hits
*--  IDATA(19) : Starting address in MCCTHIT bank
*--
*--  21-Apr-1999:
*--  The following elements (20-26) are filled if 
*--             BSIZ 2
*--  is given in CT data cards
*-- 
*--  IDATA(20): Particle code of previous track
*--  IDATA(21): VERT(1) of current track
*--  IDATA(22): VERT(2) of current track
*--  IDATA(23): VERT(3) of current track
*--  IDATA(24): PVERT(1) of current track
*--  IDATA(25): PVERT(2) of current track
*--  IDATA(26): PVERT(3) of current track
*
      IMPLICIT NONE

*--   Common
#include "geant321/gcnum.inc"

#include "ctgeo.inc"
#include "ctsim.inc"
#include "cthit.inc"

      INTEGER NHMXTT
      PARAMETER (NHMXTT=500)
      INTEGER NUMVS(NDSVCT),NUMBV(NDSVCT,NHMXCT),
     &     ITRA(NHMXCT)
      REAL    HITS(NPHTCT,NHMXCT)
C      ,HITSTT(NPHTCT,NHMXTT)
      INTEGER NHITS

      INTEGER NDATMX
      PARAMETER (NDATMX=26)
      INTEGER   IDATA(NDATMX)
      REAL      RDATA(NDATMX)
      EQUIVALENCE (IDATA(1), RDATA(1))

      INTEGER NUMHIT,ISECTH,IHIT

*--   Parameter for bank 'MCCTHITINF'
      CHARACTER*32 FMSCTH,FSGCTH,FSSCTH,FLSCTH
      INTEGER NWMCTH,LSGCTH,LSSCTH,LLSCTH
      INTEGER NWPCTH,NDACTH,IERCTH
      PARAMETER (NWMCTH=1)
      PARAMETER (FMSCTH='1I')
      PARAMETER (LSSCTH=19, LLSCTH=26)
      PARAMETER (FSSCTH='2I 15F 2I')
      PARAMETER (FLSCTH='2I 15F 3I 6F')
      PARAMETER (NWPCTH=0)

*--   Parameter for the bank 'MCCTHIT-TRACK'
      INTEGER NWMCTT,NSMCTT,LSGCTT,IERCTT
      PARAMETER (NWMCTT=1, NSMCTT=1, LSGCTT=1)
      CHARACTER*32 FMSCTT,FSMCTT,FSGCTT
      PARAMETER (FMSCTT='1I')
      PARAMETER (FSMCTT='1I')
      PARAMETER (FSGCTT='1I')
      INTEGER IDTCTT(1)
      REAL    RDTCTT(1)
      EQUIVALENCE (IDTCTT(1),RDTCTT(1))

      INTEGER NTMAX
      PARAMETER (NTMAX=500)
      INTEGER NHTCTT(NTMAX)
      INTEGER IHTCTT(0:NHMXCT,NTMAX)

      INTEGER NMMHIT
      INTEGER ILPC

      CHARACTER*80 CMSG
      INTEGER LNBLNK

      INTEGER IDC
      INTEGER I,J,ITRACK,IHD,IHT,ID,IERR

      integer ndata


*--   Initialize (is really needed?)
      CALL VZERO(NUMVS,NDSVCT)
      
*-- First count the total number hits for bank creation
*-- Zero number of hits
      NUMHIT=0
*-- loop over layers
      DO 20 I=1,NSLYCT
*-- loop over wires
         DO 25 IDC=1,NANOCT
*-- Retrieve HITS produced by tracks
            CALL GFHITS('CT  ',VNAMCT(IDC,I),NDSVCT,NPHTCT,NHMXCT,0,
     &           NUMVS,ITRA,NUMBV,HITS,NHITS)
            IF (NHITS.GT.NHMXCT) THEN
               WRITE(CMSG,'(''Nhits overflow for Layer:'',I2,
     &              '', Anode:'',I2)') I,IDC
               CALL MSGOUT('CTDIGI',CMSG(1:LNBLNK(CMSG)),NHMXCT)
               NHITS = NHITS-1
            ENDIF
            NUMHIT = NUMHIT+NHITS
 25      CONTINUE
 20   CONTINUE
      
      IF (IBNKCT.EQ.ISBKCT) THEN
         LSGCTH = LSSCTH
         FSGCTH = FSSCTH
      ELSEIF (IBNKCT.EQ.ILBKCT) THEN
         LSGCTH = LLSCTH
         FSGCTH = FLSCTH
      ELSE
         CALL MSGOUT('CTDIGI','Wrong bank type',IBNKCT)
         STOP
      ENDIF

*--   Create new ZBS bank with the 1-dim. fixed length segment.
      CALL KZBCR1('MCCTHITINF',NWMCTH,FMSCTH,NUMHIT,LSGCTH,FSGCTH, IERR)

*-- Zero the number of contributed tracks
      DO 50 I=1,NTMAX
         IHTCTT(0,I) = 0
 50   CONTINUE

      IHIT = 0
*-- loop over super layers
      DO 100 I=1,NSLYCT
*-- loop over wires in the layer
C         DO 110 IDC=1,NANOCT
         DO 110 IDC=1,NAHTCT
*-- retrieve hits from JHITS bank
            CALL GFHITS('CT  ',VNAMCT(IDC,I),NDSVCT,NPHTCT,NHMXCT,0,
     &           NUMVS,ITRA,NUMBV,HITS,NHITS)
*-- check for boundary
            IF (NHITS.GT.NHMXCT) THEN
               NHITS = NHMXCT
               CALL MSGOUT('CTDIGI','NHITS overflow',NHITS)
            ENDIF    
*            IDET*1000+NINT(NUMBV(1)/2.)
            DO 120 IHT=1,NHITS
               IF (HITS(NDHTCT,IHT).GT.0.0) THEN
                  IHIT = IHIT+1
                  IDATA(1) = ITRA(IHT)
                  IDATA(2) = IALYCT*NUMBV(1,IHT) + IAPHCT*NUMBV(2,IHT)
     &                 + IAWRCT*NUMBV(3,IHT)
C               IDATA(2) = NUMBV(1,IHT)
C               IDATA(3) = NUMBV(2,IHT)
C               IDATA(4) = NUMBV(3,IHT)
                  CALL UCOPY(HITS(1,IHT),IDATA(3),14)
                  RDATA(17) = HITS(NDHTCT,IHT)
                  IDATA(18) = 0
                  IDATA(19) = 0

                  IF (IBNKCT.EQ.ILBKCT) THEN
*-- Convert geant p-code to LUND74 P-code
                     CALL JGP2LP(NINT(HITS(15,IHT)), ILPC,IERR)
                     IF (IERR .EQ. 0) THEN
                        IDATA(20) =ILPC
                     ELSE
                        IDATA(20) =9999
                     ENDIF
                     CALL UCOPY(HITS(16,IHT),IDATA(21),6)
                  ENDIF
                  
*--     Put data words into the given segment of the bank
                  CALL KZREP1('MCCTHITINF',IHIT,LSGCTH,IDATA)
*               WRITE (*,'(I5,I10,3I5,8F10.3)') IHIT,(IDATA(J),J=1,4),
*     +              (RDATA(J),J=5,7),(RDATA(J),J=11,14),RDATA(18)
                  
                  ITRACK=MOD(ITRA(IHT),ITSTAK)
                  IF (ITRACK.LE.NTMAX) THEN
                     IF (IHTCTT(0,ITRACK).LT.NHMXCT) THEN
                        IHTCTT(0,ITRACK) = IHTCTT(0,ITRACK)+1
                        IHTCTT(IHTCTT(0,ITRACK),ITRACK)=IHIT
                     ENDIF
                  ELSE
                     CALL MSGOUT('CTDIGI','Track# overflow',ITRACK)
                  ENDIF
               ENDIF
 120        CONTINUE
 110     CONTINUE
 100  CONTINUE      

      IDATA(1) = IHIT
      CALL KZREP1('MCCTHITINF',0,NWMCTH,IDATA)
      
*--   Create new ZBS bank with the 1-dim. fixed length segment.
      CALL KZBCR2('MCCTHIT-TRACK',NWMCTT,FMSCTT,
     &     NTRACK,NSMCTT,FSMCTT,LSGCTT,FSGCTT,IERR)
      
      IDTCTT(1) = NTRACK
      CALL KZREP2('MCCTHIT-TRACK',0,0,NWMCTT,IDTCTT)

      DO 200 I=1,NTRACK
         CALL KZREP2('MCCTHIT-TRACK',I,0,NSMCTT,IHTCTT(0,I))
         DO 210 J=1,IHTCTT(0,I)
            CALL KZREP2('MCCTHIT-TRACK',I,J,LSGCTT,IHTCTT(J,I))
 210     CONTINUE 
 200  CONTINUE
      
      RETURN
      END
