      SUBROUTINE CTSPAR
*.
*...CTSPAR   Saves Central Tracker Parameters into ZBS Bank.
*.           
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : 
*. CALLS     : 
*. CALLED    : JMSAVP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 3-AUG-1994
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.    2000.02.16  Add 14th parameter in master bank, which is number of
*.                simulated layers in a super layer     J.Kanzaki
*.
*.**********************************************************************
      IMPLICIT NONE

#include "ctgeo.inc"
#include "ctsim.inc"
      
      INTEGER NPDATA
      PARAMETER (NPDATA=20)
      INTEGER IDATA(NPDATA)
      REAL    RDATA(NPDATA)
      EQUIVALENCE (RDATA(1),IDATA(1))

      INTEGER NWMAST,NSEGM,LSEGM
      PARAMETER (NWMAST=20, LSEGM=7)
      CHARACTER*32 CFMAST, CFSEGM
      PARAMETER (CFMAST='2I 10F 2I', CFSEGM='2I 5F')

      INTEGER I,IERR

*-- Create ZBS Bank MCCTPAR
C     CALL KZBCR1('MCCTPAR',NPDATA,'2I 10F 50I 125F',0,0,' ',IERR)
      CALL KZBCR1('MCCTPAR',NWMAST,CFMAST,NPSLCT,LSEGM,CFSEGM,IERR)

*-- Store Data to given Segment of Bank MCCTPAR
      IDATA( 1) = NSLYCT 
      IDATA( 2) = NANOCT
      RDATA( 3) = ROMACT
      RDATA( 4) = RIMACT
      RDATA( 5) = ZMACT
      RDATA( 6) = EPX1CT
      RDATA( 7) = EPY1CT
      RDATA( 8) = PLSCCT
      RDATA( 9) = RLSCCT
      RDATA(10) = RLUNCT
      RDATA(11) = TCYLCT
      RDATA(12) = TENPCT
      IDATA(13) = IBNKCT
      
      IDATA(14) = NAHTCT

      CALL KZREP1('MCCTPAR',0,NWMAST,IDATA)

      DO 100 I=1,NPSLCT
         
         IDATA(1) = NPLYCT(I)
         IDATA(2) = IAXSCT(I)
         RDATA(3) = RILYCT(I)
         RDATA(4) = ZLLYCT(I)
         RDATA(5) = SANGCT(I)
         RDATA(6) = STWICT(I)
         RDATA(7) = XYLYCT(I)

         CALL KZREP1('MCCTPAR',I,LSEGM,IDATA)

 100  CONTINUE 

      RETURN
      END
