      SUBROUTINE ECFFRD
*.
*...ECFFRD   Read EC geometry data
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GEFILE ECGEO
*. CALLS     : FFSET  FFKEY  FFGO
*. CALLED    : UGINIT
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 25-May-1994
*. LAST MOD  : 23-Jul-1994 
*.
*. MODIFICATION LOG
*. 23-Jul-1994 Nakamura.I ,Add BLOCK DATA for Default value.
*. 11-May-1995 Nakamura.I ,Replace DYALLC with JUALLC
*. 25-Jul-1994 Nakamura Isamu Add DATA Cards.
*. 27-May-1994 N.Hosoda, Add find data file name part
*. 15-JUN-1994 N.Hosoda, Use GETDID
*. 28-Jun-1994 N.Hosoda, Use not OPEN but DYALLC
*.
*.**********************************************************************
*.
*. Fundamental Parameters
*.
*.      
*. DATA CARD | VARIAVLE |   
*.----------------------------------------------------------------
*.    ERI1   |  RI1EC   |  
*.    ERO1   |  RO1EC   |  
*.    ERI2   |  RI2EC   |  
*.    ERO2   |  RO2EC   |  
*.    EZI    |  ZIEC    |    Z Positoin of EC Front Face.
*.    EBL    |  BLEC    |    Block Length ( cm )
*.    EDEM   |  DEMEC   |    Depth of EM part ( cm )
*.    ETSE   |  TSCEEC  |    Tickness of Scintillator (EM)
*.    ETSH   |  TSCHEC  |    Tickness of Scintillator (HAD)
*.    EBSZ   |  BSIZEC  |    Block Size
*.-----------------------------------------------------------------
*.
*.
*.	      |<---------------->| RO1EC
*.	      |              |<->| RI1EC
*.            |              |   | 
*.	      ----------------   |   ---------------        ------
*.	     /     EM        |   |   |              \  DEMEC |  |
*.	    / -------------- |   |   |-------------- \      --- | 
*.	   /                 |   |   |                \         | BLEC 
*.	  /       HAD        |   |   |                 \        | 
*.       /                   |   |   |                  \       |
*.	----------------------   |   ---------------------   ------
*. 	 |                   |   |
*.	 |                   |<->| RI2EC
*.	 |<--------------------->| RO2EC
*.	
*.*********************************************************************
      IMPLICIT NONE

*--   Common for user
#include "jmdet.inc"
#include "ecgeo.inc"
*
      SWITEC = 2
      RI1EC =  45.
      RO1EC = 230.
      RI2EC =  45.
      RO2EC = 300.
      ZIEC  = 300.
      BLEC  = 140.
      DEMEC =  20.
      TSCEEC = 0.1
      TSCHEC = 0.2
      BSIZEC = 20.

      IF (LUNMJD(IDETEC).LE.0) GOTO 999

*--   Set optional values
      CALL FFSET('LINP', LUNMJD(IDETEC))

*--   Define private data records
      CALL FFKEY('ECSW', SWITEC , 1, 'INT' )
      CALL FFKEY('ERI1', RI1EC  , 1, 'REAL')
      CALL FFKEY('ERO1', RO1EC  , 1, 'REAL')
      CALL FFKEY('ERI2', RI2EC  , 1, 'REAL')
      CALL FFKEY('ERO2', RO2EC  , 1, 'REAL')
      CALL FFKEY('EZI ', ZIEC   , 1, 'REAL')
      CALL FFKEY('EBL ', BLEC   , 1, 'REAL')
      CALL FFKEY('EDEM', DEMEC  , 1, 'REAL')
      CALL FFKEY('ETSE', TSCEEC , 1, 'REAL')
      CALL FFKEY('ETSH', TSCHEC , 1, 'REAL')
      CALL FFKEY('EBSZ', BSIZEC , 1, 'REAL')

*--   Read data cards
      CALL FFGO

  999 CONTINUE
      RETURN
      END
