      SUBROUTINE ECGEOM
*.
*...EBGEOM   Define the electromagnetic barrel calorimeter
*.           geometry and tracking media.
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCFLAG GCONST UCTMED ECGEO
*. CALLS     : GSVOLU GSPOS  GSDVN  GSDET  GSDETH GSDETD GPSETS
*. CALLED    : UGEOM
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 02-May-1994
*. LAST MOD  : 04-Feb-1999
*.
*. MODIFICATION LOG
*. 04-Feb-1999 : Koji ISHII
*.               setup for BIRK
*. 24-May-1994 N.HOSODA, Replace CHARACTER statement before DATA 
*.           statement to fix ANSI warning
*.
*.**********************************************************************
*.
*. Fundamental Parameters
*.
*.   DATA CARD | VARIAVLE |   
*.   ---------------------------------------------------------------
*.      ERI1   |  RI1EC   |  
*.      ERO1   |  RO1EC   |  
*.      ERI2   |  RI2EC   |  
*.      ERO2   |  RO2EC   |  
*.      EZI    |  ZIEC    |    Z Positoin of EC Front Face.
*.      EBL    |  BLEC    |    Block Length ( cm )
*.      EDEM   |  DEMEC   |    Depth of EM part ( cm )
*.      ETSE   |  TSCEEC  |    Tickness of Scintillator (EM)
*.      ETSH   |  TSCHEC  |    Tickness of Scintillator (HAD)
*.      EBSZ   |  BSIZEC  |    Block Size
*.   ----------------------------------------------------------------
*.
*.	      |<---------------->| RO1EC
*.	      |              |<->| RI1EC
*.            |              |   | 
*.	      ----------------   |   ---------------        ------
*.	     /     EM        |   |   |              \  DEMEC |  |
*.	    / -------------- |   |   |-------------- \      --- | 
*.	   /                 |   |   |                \         | BLEC 
*.	  /       HAD        |   |   |                 \        | 
*.       /                   |   |   |                  \       |
*.	----------------------   |   ---------------------   ------
*. 	 |                   |   |
*.	 |                   |<->| RI2EC
*.	 |<--------------------->| RO2EC
*.	
*.*********************************************************************
      IMPLICIT NONE

*-- Include GEANT common block
#include "jmmat.inc"
#include "jmmed.inc"
#include "jmdet.inc"
#include "ecgeo.inc"
#include "ecmed.inc"

      IF (ISIMJD(IDETEC).EQ.ISKPJD) RETURN
      
      ILEDEC = NMEDJM*IDETEC+1
      CALL GSTMED(ILEDEC, 'LEAD', IMLEAD, ISENS, IFIELD, FIELDM,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL, STMIN, UBUF, NWBUF)
      
      ISCIEC = NMEDJM*IDETEC+2
      CALL GSTMED(ISCIEC, 'SCINTI', IMSCIN, ISENS, IFIELD, FIELDM,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL, STMIN, UBUF, NWBUF)

CKI set for BIRK
      CALL GSTPAR(ISCIEC,'BIRK1',1.)
      CALL GSTPAR(ISCIEC,'BIRK2',0.013)
      CALL GSTPAR(ISCIEC,'BIRK3',9.6E-6)
CKI end

      IF (SWITEC .EQ. 1) THEN
         CALL ECSUB1
      ELSEIF (SWITEC .EQ. 2) THEN
         CALL ECSUB2
      ENDIF

      RETURN
      END
