      SUBROUTINE ECHTFL(CDET)
*.
*...ECHTSM   EC Hit routine with FuLl mode
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Koji ISHII
*. VERSION   : 1.00
*. CREATED   : 14-Feb-1999
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*. 03-Mar-1999 : K.Ishii Added 20 ns TOF cut 
*. 19-Feb-1999 : K.Ishii Bug fixed for EM ID
*. 14-Feb-1999 : K.Ishii
*.               Convert from ECHITS
*. 09-Feb-1999 : K.Ishii
*.               Add BIRK correction
*. 06-Mar-1996 : K.Ishii
*.               Modified the calculation of size parameters
*.
*.**********************************************************************
      IMPLICIT NONE

*-- include files
#include "geant321/gckmax.inc"
#include "geant321/gcsets.inc"
#include "geant321/gctrak.inc"
#include "geant321/gcking.inc"
#include "geant321/gckine.inc"
#include "geant321/gccuts.inc"
#include "geant321/gcvolu.inc"
#include "geant321/gctmed.inc"
#include "geant321/gconst.inc"
#include "pdparm.inc"
#include "jmdet.inc"
#include "ecgeo.inc"
#include "echit.inc"

*-- input argement
      CHARACTER*2 CDET

      REAL TOFCUT
      PARAMETER (TOFCUT = 2.0E-8)
      
      REAL XMAST(3)
      REAL HITS(NDHTEC),LOR(4)

      INTEGER IRAD0
      REAL EDEP

      REAL CORZ,RHALF,RPOS,PPOS,PHALF
      REAL ECDEG6

      INTEGER IHIT

      INTEGER NHSUM
      PARAMETER (NHSUM=4)

      INTEGER I

*-- return if no energy deposition
      IF (DESTEP.LE.0.) RETURN 

*-- return if track TOF is more than 20 ns
      IF (TOFG.GT.TOFCUT) RETURN 

*-- Initialize Position related value
      DO 310 I=1,4
         LOR(I) = 0.
 310  CONTINUE

*-- Get Current Position in the Daughter Flame (ET**)
      IRAD0 = NUMBER(3)

      XMAST(1) = VECT(1)
      XMAST(2) = VECT(2)
      XMAST(3) = VECT(3)
  
*-- Calculate Size Parameters

      RPOS = SQRT(XMAST(1)**2+XMAST(2)**2)
      CORZ = (ABS(XMAST(3))-ZIEC)*(RO2EC-RO1EC)/BLEC      
      RHALF = (RO1EC-RI1EC+CORZ)/NDREC*(IRAD0-.5)+RI1EC

      PPOS = RADDEG*ATAN2(XMAST(2),XMAST(1))
      IF(PPOS.LE.0.) PPOS = PPOS + 360.

      ECDEG6=SIZEC(6,IRAD0)
      PHALF = ANINT(PPOS/ECDEG6)*ECDEG6
            
*-- Case EM  
*--   Deposite Energy is Detected by One of the 
*--   four subdevided EM Modules According to its position.
      IF (CDET.EQ.'EE') THEN
               
*-- Get Left or Right in the Scintillator
         IF (RPOS.LE.RHALF) THEN
            IF (PPOS.GE.PHALF) THEN
               LOR(1) = 1.
            ELSE
               LOR(2) = 1.
            ENDIF
         ELSE
            IF (PPOS.GE.PHALF) THEN
               LOR(3) = 1.
            ELSE
               LOR(4) = 1.
            ENDIF
         ENDIF
               
*-- Case HAD
*--   Deposite Energy is devided into two PMT
*--   Accordinge to the Position.

      ELSEIF (CDET.EQ.'EH') THEN
         LOR(1) = 0.5-(PPOS-PHALF)/SIZEC(6,IRAD0)
         LOR(2) = 0.5+(PPOS-PHALF)/SIZEC(6,IRAD0)
         DO 320 I=1,2
            IF (LOR(I).LT.0.) LOR(I)=0.
            IF (LOR(I).GT.1.) LOR(I)=1.
 320     CONTINUE
      ELSE
         GO TO 999          
      ENDIF
            
*-- Birk Correction
      CALL GBIRK(EDEP)

*-- Store HIT Information into Bank JHITS.
      HITS(1) = TOFG
      HITS(2) = EDEP*LOR(1)
      HITS(3) = EDEP*LOR(2)
      HITS(4) = EDEP*LOR(3)
      HITS(5) = EDEP*LOR(4)
      CALL GSCHIT(ISET,IDET,ITRA,NUMBV,HITS,NHSUM,IHIT)

 999  CONTINUE

      RETURN 
      END
