      SUBROUTINE GESPAR
*.
*...GESPAR   Saves GEANT parameters
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. COMMON    : GCCUTS GCPHYS
*. CALLS     : nom
*. CALLED    : JMSAVP
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 10-May-1995
*.
*. MODIFICATION LOG
*.      23-Aug-1996 Y. Fujii ; Bank name was wrong in KZPUT. Corrected.
*.
*.*********************************************************************
*.                                                                    *
*.     +-------------------------+                                    *
*.     | Bank Name  :  MCGEPAR   |                                    *
*.     +-------------------------+                                    *
*.                                                                    *
*.     Contents    : Information of GEANT Parameters are stored.      *
*.     Record Type : 1-dim. fixed length segment                      *
*.     Version     : Release 1.0  1995-May-10                         *
*.                                                                    *
*.*********************************************************************
*.
*.(1) Contents in the Master Segment
*.----------------------------------
*.
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. IDATA(1)   GEANT Version #
*. IDATA(2)   Control Variable for the e-pair production. 
*. IDATA(3)   Control Variable for the Compton scattering
*. IDATA(4)   Control Variable for the photoelectric effect
*. IDATA(5)   Control Variable for the gamma induced nuclear fission 
*. IDATA(6)   Control Variable for the delta-ray producton process
*. IDATA(7)   Control Variable for the positoron annichilation prosecc
*. IDATA(8)   Control Variable for the bremsstrahlung process
*. IDATA(9)   Control Variable for the hadronic interaction process
*. IDATA(10)  Control Variable for the mu-nuclear interaction process
*. IDATA(11)  Control Variable for the decay in flight process
*. IDATA(12)  Control Variable for the energy loss process
*. IDATA(13)  Control Variable for the energy loss process
*. RDATA(14)  Kinetic Energy cut Threshold for gamma
*. RDATA(15)  Kinetic Energy cut Threshold for electron
*. RDATA(16)  Kinetic Energy cut Threshold for newtral hadron
*. RDATA(17)  Kinetic Energy cut Threshold for charged hadron
*. RDATA(18)  Kinetic Energy cut Threshold for muon
*. RDATA(29)  Kinetic Energy cut Threshold for electron brems.
*. RDATA(20)  Kinetic Energy cut Threshold for muon brems.
*. RDATA(21)  Kinetic Energy cut Threshold for electron delta ray
*. RDATA(22)  Kinetic Energy cut Threshold for muon or hadron delta ray
*. RDATA(23)  Total Energy cut Threshold for e-pair production by muon
*. RDATA(24)  TOF cut 
*.
*.**********************************************************************
      IMPLICIT NONE

#include "geant321/gccuts.inc"
#include "geant321/gcphys.inc"

      INTEGER NPDATA
      PARAMETER (NPDATA=24)
      INTEGER IDATA(NPDATA)
      REAL    RDATA(NPDATA)
      EQUIVALENCE (IDATA(1),RDATA(1))

      INTEGER IERR

*-- Create ZBS Bank MCGEPAR
      IDATA(1)  = 321
      IDATA(2)  = IPAIR
      IDATA(3)  = ICOMP
      IDATA(4)  = IPHOT
      IDATA(5)  = IPFIS
      IDATA(6)  = IDRAY
      IDATA(7)  = IANNI
      IDATA(8)  = IBREM
      IDATA(9)  = IHADR
      IDATA(10) = IMUNU
      IDATA(11) = IDCAY
      IDATA(12) = ILOSS
      IDATA(13) = IMULS
      RDATA(14) = CUTGAM
      RDATA(15) = CUTELE
      RDATA(16) = CUTNEU
      RDATA(17) = CUTHAD
      RDATA(18) = CUTMUO
      RDATA(19) = BCUTE
      RDATA(20) = BCUTM
      RDATA(21) = DCUTE
      RDATA(22) = DCUTM
      RDATA(23) = PPCUTM
      RDATA(24) = TOFMAX

      CALL KZBCR1('MCGEPAR',NPDATA,'13I 11F',0,0,' ',IERR)
      CALL KZPUT1('MCGEPAR',0,0,NPDATA,IDATA)

      RETURN
      END
