      SUBROUTINE GUFLD(VECT,F)
*.
*...GUFLD   Calculate the value of magnetic field
*.
*. INPUT     : VECT= array of 3 with the position in space where the
*.             field has to be returned
*.             VECT(1)= x (cm)
*.             VECT(2)= y (cm)
*.             VECT(3)= z (cm)
*. OUTPUT    : F= array of 3 with the magnetic field in VECT, in
*.             kilo-Gauss units
*.             F(1)= Bx (KG)
*.             F(2)= By (KG)
*.             F(3)= Bz (KG)
*.
*. SEQUENCE  :
*. COMMON    : 
*. CALLS     : 
*. CALLED    : GHELIX GRKUTA
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 25-Mar-1994
*. LAST MOD  : 25-Mar-1994
*.
*. MODIFICATION LOG
*. 15-Jul-1999 A.Miyamoto, 
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Common
#include "mchead.inc"
#include "jmbfld.inc"      

      REAL VECT(3),F(3)
      REAL FS(3), FQ(3)
      REAL R

      R=SQRT(VECT(1)**2+VECT(2)**2)

      IF (IFMPJM.EQ.1 .AND. R.LT.16.0) THEN
        CALL GUFLDS(VECT, FS)
        CALL GUFLDQ(VECT, FQ)
        F(1)=FS(1)+FQ(1)
        F(2)=FS(2)+FQ(2)
        F(3)=FS(3)+FQ(3)
      ELSEIF (R.LE.425.0 .AND. ABS(VECT(3)).LE.500.0) THEN
        F(1)=0.0
        F(2)=0.0
        F(3)=BKGMC
      ELSE
        F(1)=0.0
        F(2)=0.0
        F(3)=0.0
      ENDIF

      RETURN
      END
