      SUBROUTINE GUKINE
*.
*...GUKINE   GEANT3 user routine
*.           Generates kinematics of primary tracks
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCFLAG GCONST GCKINE 
*. CALLS     : GPKINE GPVERT KI**** GRNDMQ LUGIVE LUEDIT LUHEPC
*.             GSVERT GSKINE JLP2GP
*. CALLED    : GTRIG
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : N.Hosoda
*. VERSION   : 1.00
*. CREATED   : 11-Mar-1994
*. LAST MOD  : 29-Jul-1994
*.
*. MODIFICATION LOG
*. 19-Jan-1999  I.Nakamura add JMEINI for evnet initializaion
*. 29-Jul-1994  N.Hosoda Use JLP2GP
*. 13-Jul-1994  I.Nakamura add KIFILE read Event from FILE.
*. 18-May-1994  replace geant common by INCLUDE
*. 17-Mar-1994  Introduce SWITCH to Generate Various Event.
*.
*.**********************************************************************
      IMPLICIT NONE

*-- Common for GEANT
#include "geant321/gcflag.inc"
#include "geant321/gconst.inc"
#include "geant321/gckine.inc"

#include "jetset.inc"
#include "pythia.inc"
#include "hepevt.inc"

      INTEGER ID,IT

      EXTERNAL LUDATA
      EXTERNAL PYDATA


*-- Initialize Random Number Generator

      IF (IEVENT.EQ.1) THEN

*-- Get Date & Time
         CALL DATIME(ID,IT)

*-- Initialize Randum Number using Date & Time
C         CALL GRNDMQ(ID,IT,1,'S')
C         MRLU(1)=ID+IT

      ENDIF
      
*-- Before starting event processing,    
*-- delete (ZDROP'S and one ZGARB) all existing banks 
*-- and clear bank directory
      CALL KZECLR
      
*-- Kinematic generators may be selected according to the
*-- first variable (IKINE) on the KINE data card.
*-- IKINE  Generator routine
*--
*--     1  KILUND  Generates e+e- --> Hadrons with the LUND generator.
*--                CMS Energy is set by 2nd variable on KINE data card.
*--
*--     2  KITOP   Generates a TOP quark event with LUND generator.
*--                TOP MASS is set at 174 GeV.
*--
*--     3  KIHIGS  Generates a HIGGS event. (Yet Available)
*--
*--     4  KISING  Call single particle generator (useful for 
*--                debugging and testing) 
*--
*--     5  KIFILE  Reads Event from FILE Specified in 'input.dat'
*--
*--     6  KIMULT  Call multi-particle generator (useful for 
*--                debugging and testing) 
*--
*--     7  KIOPAL  Read OPAL-specific four-vector files
*--
*--     8  KIXFIL  Reads Event from FILE in old ZBS format
*--
*-- In these subroutines unstables or undetectables are included.

      IF (IKINE.EQ.1) THEN
         CALL KILUND
      ELSEIF (IKINE.EQ.2) THEN
         CALL KITOP
      ELSEIF (IKINE.EQ.3) THEN
         CALL KIHIGS
      ELSEIF (IKINE.EQ.4) THEN
         CALL KISING
      ELSEIF (IKINE.EQ.5) THEN
         CALL KIFILE
      ELSEIF (IKINE.EQ.6) THEN
         CALL KIMULT
      ELSEIF (IKINE.EQ.7) THEN
         CALL KIOPAL
      ELSEIF (IKINE.EQ.8) THEN
         CALL KIXFIL
      ELSE
         CALL KILUND
      ENDIF

      IF (IKINE.NE.5 .AND. IKINE.NE.8) THEN
         CALL MCBFHD
      ENDIF

*-- List Particles 

      IF (ISWIT(3).GE.1) THEN
         CALL LULIST(1)
      ENDIF

*-- Fill the JVERTX and JKINE and Create and Fill MCVERTEX and MCTRAK

      CALL JMVTKI

*-- For Debug Prints Initial Track Parameters

      IF (IDEBUG.EQ.1 .AND. ISWIT(3) .GE. 1) THEN
         CALL GPVERT(0)
         CALL GPKINE(0)
      ENDIF

CCCCC WRITE(6,*) 'Now Processing >>> ',IEVENT, ' /',NEVENT

      RETURN
      END
