      SUBROUTINE GUSTEP
*.
*...GUSTEP   GEANT3 user routine
*.           User routine called at the end of each tracking step
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCFLAG GCKING GCTRAK GCSETS MCHEAD
*. CALLS     : GDCXYZ GPCXYZ GDEBUG GSKING UHTOC
*.             CTHITS EBHITS EEHITS HBHITS HEHITS VXHITS 
*. CALLED    : GTVOL
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 11-Mar-1994
*. LAST MOD  : 04-Mar-1999
*.
*. MODIFICATION LOG
*. 04-Mar-1999 Nakamura; add ITHITS
*. 14-Feb-1999  K.Ishii ; Modification for the smearing mode
*. 09-Feb-1999  K.Ishii ; Drop EM cutoff for secondary tracks. (time loss?)
*. 24-Jan-1999 J.Kanzaki,  Added AMHITS
*. 11-Jan-1998, Y.Fujii ; Added BMHITS and 'higzpa.inc'.
*. 09-SEP-1998, Y.FUJII ; Surpress display of low-energy gamma.
*. 29-AUG-1996, Y.FUJII ; Call xxhit routines only when DESTEP>0.
*. 13-Apr-1994  Add HITS subroutine
*. 18-May-1994 replace geant common by INCLUDE
*.
*.**********************************************************************
      IMPLICIT NONE

*-- commons for GEANT
#include "geant321/gcflag.inc"
#include "geant321/gckmax.inc"
#include "geant321/gcking.inc"
#include "geant321/gctrak.inc"
#include "geant321/gckine.inc"
#include "geant321/gcsets.inc"
#include "geant321/gccuts.inc"
#include "geant321/gctmed.inc"

*-- commons for JIM
#include "jmcntl.inc"
#include "jmdet.inc"
#include "jmstep.inc"
#include "mchead.inc"
#include "pdparm.inc"
#include "bcmed.inc"
#include "ecmed.inc"

      CHARACTER*4 CUSET,CUDET

      INTEGER MEDIUM,NCOUNT,IFPLOT,IFLAG
      SAVE NCOUNT,IFPLOT
      REAL MMM
      REAL RRR,AAA,THET,PPP,THETCT,RCT
      REAL VMOD

      INTEGER I

      INTEGER IP
      REAL E

*--   Get SET & DET name of current step
      CALL UHTOC(IHSET,4,CUSET,4)
      CALL UHTOC(IHDET,4,CUDET,4)

*--   Draw one step to the current active graphic device
      IF (IDEBUG.EQ.1 .AND. ISWIT(4).GE.1) THEN
         IF (VECT(7).GE.0.01 .AND.   
     &       (IPART.NE.1 .OR. VECT(7).GE.0.1)  .AND.
     &       VECT(3).LE.850 .AND. VECT(3).GE.-850 ) THEN
             CALL GDCXYZ
             IF (JMPPJM.EQ.1) CALL GSXYZ
         ENDIF    
      ENDIF
      
*--   Print the tracking and physics parameters after the current step
*     IF (IDEBUG.EQ.1 .AND. ISWIT(3) .GE. 1) THEN
*     CALL GPCXYZ
*     CALL GDEBUG
*     ENDIF

*--   Accumulate deposit energy
*--   for histograms
C      IF (DESTEP .GT. 0.0) THEN
C         RMCENG=RMCENG+DESTEP
C      ENDIF
*-- check particle trap etc.
      MEDIUM=NUMED
      CALL JMDISC(IPART,IGNEXT,NSTEP,ISTOP,STEP,
     &     MEDIUM,IFLAG)

      IF (NSTEP.LE.1) THEN
         IFPLOT=0
         NCOUNT = 0
      ENDIF
      
      IF (IFLAG.GE.5) THEN
         IF (IFPLOT.EQ.0) THEN
           MMM=0.0
           IF (IPART.EQ.13 .OR. IPART.EQ.14 .OR. IPART.EQ.45 .OR.
     &          IPART.EQ.46 .OR. IPART.EQ.47 .OR. IPART.EQ.49 .OR.
     &          IPART.EQ.3) THEN
             MMM=AMASS
           ELSEIF(IPART.EQ.2) THEN
             MMM=-AMASS
           ENDIF
           IF (GETOT.LE.0.005) THEN
              DESTEP=DESTEP+GETOT-MMM
           ENDIF
           ISTOP = 4
           IFPLOT = 1
           NCOUNT = NCOUNT + 1
         ENDIF
      ELSEIF (IFPLOT.NE.0) THEN
         IFPLOT = 0
         NCOUNT = 0
      ENDIF      

CKI   Stores secondary tracks generated by the present step
CKI   (just initialise to store all particles)
      DO 10 I=1,NGKINE
         IFLGK(I) = 0
 10   CONTINUE

*--   Store HITS for each detector only when DESTEP>0.0
c      print *,'gustep;cuset = ',cuset
      IF     (CUSET .EQ. 'CT  ') THEN
         CALL CTHITS
      ELSEIF (CUSET .EQ. 'VX  ') THEN
         CALL VXHITS
      ELSEIF (CUSET .EQ. 'BC  ') THEN
         CALL BCHITS
      ELSEIF (CUSET .EQ. 'EC  ') THEN
         CALL ECHITS
      ELSEIF (CUSET .EQ. 'BM  ') THEN
         CALL BMHITS
      ELSEIF (CUSET .EQ. 'AM  ') THEN
         CALL AMHITS
      ELSEIF (CUSET .EQ. 'MU  ') THEN
         CALL MUHITS
      ELSEIF (CUSET .EQ. 'LM  ') THEN
         CALL LMHITS
      ELSEIF (CUSET .EQ. 'IT  ') THEN
         CALL ITHITS

*--   If SMEAR mode is used with calorimeter (BC and EC), 
*        SMEAR routine should also be caleed for Pb and WLS.

      ELSE
         IF (ISIMJD(IDETBC).EQ.ISMRJD) THEN
            IF (NUMED.EQ.ILEDBC) THEN
               CALL BCHTSM
            ELSEIF (NUMED.EQ.ISCIBC) THEN
               CALL BCHTSM
            ENDIF
         ENDIF      
         IF (ISIMJD(IDETEC).EQ.ISMRJD) THEN
            IF (NUMED.EQ.ILEDEC) THEN
               CALL ECHTSM
            ELSEIF (NUMED.EQ.ISCIEC) THEN
               CALL ECHTSM
            ENDIF
         ENDIF      
      ENDIF

*-- Neutrino will always be discarded
      IF (IPART.EQ.4) THEN
         ISTOP=4
      ENDIF      

      IF (IFWCJM.EQ.1) THEN
*-- Acceptance cut for BEAM PIPE (only chrged particle)

         PPP=SQRT((VECT(4)*VECT(7))**2+(VECT(5)*VECT(7))**2)
         RRR=SQRT(VECT(1)**2+VECT(2)**2)
         IF (PPP.LE.PTFWJM .AND. RRR.LE.RDFWJM .AND. CHARGE.NE.0) THEN
            ISTOP=4
         ENDIF
         
*-- discard particle with far forward direction
         THETCT = ACOS(ABS(VECT(6)))
         RCT = VMOD(VECT(1),2)
         IF (THETCT.LT.THFWJM.AND.RCT.LT.RDFWJM) THEN
            ISTOP = 4
         ENDIF

      ENDIF

*--   Save in the stack one or all particles generated during the
*--   current step
      
c      print *,'gustep;ngkine = ',ngkine
      CALL GSKING(0)

c      print *,'gustep;end'
      RETURN
      END
