      SUBROUTINE ITDIGI
*.
*...ITDIGI   Compute and store DIGIts for Si vertex detector
*.
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 04-Mar-1999
*. LAST MOD  : 04-Mar-1999
*.
*. MODIFICATION LOG
*. 04-Mar-1999 Nakamura; creation
*.
*.**********************************************************************
*-- 
*-- Bnak structure of MCITHIT
*-- Master Segment #1  Number of Hits
*-- Data Segment   #1  Track Number (Kine Bank)
*--                #2  Layer Number 
*--                #3  X position
*--                #4  Y position
*--                #5  Z position
*--                #6  PX
*--                #7  PY
*--                #8  PZ
*--                #9  Energy deposit
*--
      IMPLICIT NONE

*--   Common
#include "geant321/gcnum.inc"

#include "itgeo.inc"
#include "ithit.inc"

      INTEGER NUMBV(NWHIIT),ITRA(NWHIIT)
      REAL    HITS(NHIT,NWHIIT)
*
*-- length of data segment
      INTEGER NDATMX
      PARAMETER (NDATMX=9)
      INTEGER   IDATA(NDATMX)
      REAL      RDATA(NDATMX)
      EQUIVALENCE (IDATA(1), RDATA(1))
*
      INTEGER NUMHIT,IHIT,NHITS
      INTEGER IHT

      CHARACTER*80 CMSG
      INTEGER LNBLNK

      INTEGER ILAY,J,IERR

*--   Initialize
      NUMHIT=0
*-- loop over detector hits to count number of Hits      
      DO 20 ILAY=1,NLAYIT
         CALL GFHITS('IT  ',VNAMIT(ILAY),NVIT,NHIT,NWHIIT,0,0,
     &        ITRA,NUMBV,HITS,NHITS)
         IF (NHITS.GT.NWHIIT) THEN
            WRITE(CMSG,'(''Nhits overflow for layer '',I1)') ILAY
            CALL MSGOUT('ITDIGI',CMSG(1:LNBLNK(CMSG)),NWHIIT)
            NHITS = NHITS-1
         ENDIF    
         NUMHIT = NUMHIT+NHITS
 20   CONTINUE

*-- Create new ZBS bank with the 1-dim. fixed length segment.
      CALL KZBCR1('MCITHIT',1,'1I',NUMHIT,9,'2I 7F', IERR)
*      
      IHIT = 0
      DO 100 ILAY=1,NLAYIT
         CALL GFHITS('IT  ',VNAMIT(ILAY),NVIT,NHIT,NWHIIT,0,0,
     &        ITRA,NUMBV,HITS,NHITS)
         IF (NHITS.GT.NWHIIT) THEN
            NHITS = NWHIIT
         ENDIF    
         
*-- Loop of hit in this detector name
         DO 110 IHT=1,NHITS
            IHIT = IHIT+1
            IDATA(1) = ITRA(IHT)
            IDATA(2) = NUMBV(IHT)
            CALL UCOPY(HITS(1,IHT),RDATA(3),7)
            CALL KZPUT1('MCITHIT',IHIT,0,NDATMX,IDATA)
*            WRITE (*,'(3I5,7F10.3)') 
*     +           IHIT,(IDATA(J),J=1,2),(RDATA(J),J=3,9)
 110     CONTINUE

 100  CONTINUE

*-- Put data words into the master segment of the bank
      IDATA(1) = NUMHIT
      CALL KZPUT1('MCITHIT',0,0,1,IDATA)

      RETURN
      END
