      SUBROUTINE ITFFRD
*.
*...ITFFRD   Read IT geometry data
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 04-May-1999
*. LAST MOD  : 04-May-1999
*.
*. MODIFICATION LOG
*. 25-Oct-1999 J.Kanzaki; default number of layers is changed 
*.                      ; from 3 to 5 according to Dr.Hongjoo's 
*.                      ; scheme
*. 01-Apr-1999 J.Kanzaki; numbering scheme of layers is reversed
*.                      ; from inside to outside
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Common for user
#include "jmdet.inc"
#include "itgeo.inc"
*
*-- set default value
*-- number of layer is 5
      NLAYIT = 5
C     NLAYIT = 3
*-- Radius of Layers
*-- zero all the layers      
      CALL VZERO(RIT,MLAYIT)
*-- Radii
      RIT(1) = 10.
      RIT(2) = 17.
      RIT(3) = 24.
      RIT(4) = 31.
      RIT(5) = 38.
C      RIT(1) = 28.
C      RIT(2) = 33.
C      RIT(3) = 38.
*-- Z half length of Layers
*-- zero all the layers (covers |cos(theta)|<0.9)
      CALL VZERO(ZLIT,MLAYIT)
      ZLIT(1) = 21.
      ZLIT(2) = 35.
      ZLIT(3) = 50.
      ZLIT(4) = 64.
      ZLIT(5) = 79.
C      ZLIT(1) = 65.
C      ZLIT(2) = 75.
C      ZLIT(3) = 85.
*
*-- thickness of layers (in micron)
      THIKIT = 300.
*
*-- skip if everything is default
      IF (LUNMJD(IDETIT).LE.0) RETURN

*--   Set optional values
      CALL FFSET('LINP', LUNMJD(IDETIT))

*--   Define private data records
      CALL FFKEY('ITTK', THIKIT , 1, 'REAL')
      CALL FFKEY('ITNL', NLAYIT , 1, 'INTEGER')
      CALL FFKEY('RIT ', RIT    , MLAYIT, 'REAL')
      CALL FFKEY('ZLIT', ZLIT   , MLAYIT, 'REAL')

*--   Read data cards
      CALL FFGO
*
  999 CONTINUE
*
      RETURN
      END
