      SUBROUTINE JGP2LP (IGPC,ILPC,IERR)
*.
*...JGP2LP   Convert GEANT particle code to LUND74 particle code
*.
*. INPUT     : IGPC  GEANT particle code
*. OUTPUT      ILPC  LUND74 particle code
*.             IERR  Error code =0 ok,=1 no coressponding p.code
*.
*. SEQUENCE  :
*. COMMON    : 
*. CALLS     : IUCOMP
*. CALLED    : 
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 29-Jul-1994
*. LAST MOD  : 29-Jul-1994
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
      IMPLICIT NONE

      INTEGER ILPC,IGPC,IERR

      INTEGER NSEL
      PARAMETER (NSEL=41)
      INTEGER ISEL(NSEL),JSEL(NSEL)
      DATA ISEL/
     &        22,  -11,   11,  -12,   12,  -13,   13,  -14,   14,  -16,
     &        16,  211, -211,  321, -321,  310,  130, 2212,-2212, 2112,
     &     -2112, 3222,-3112, 3112, 3222, 3322,-3322, 3312,-3312, 3122,
     &     -3122, 3334,-3334,   15,  -15, 3212,-3212,  221, -221,  111, 
     &      -111/
      DATA JSEL/
     &         1,    2,    3,    4,    4,    5,    6,    4,    4,    4,
     &         4,    8,    9,   11,   12,   16,   10,   14,   15,   13,
     &        25,   19,   27,   21,   29,   22,   30,   23,   31,   18,
     &        26,   24,   32,   34,   33,   20,   28,   17,   17,    7,
     &         7/

      INTEGER IUCOMP,IPC

      IERR=0
      IPC=IUCOMP(IGPC,JSEL,NSEL)
      IF (IPC .EQ.0) THEN
        IERR=1
      ELSE
        ILPC = ISEL(IPC)
      ENDIF

      RETURN
      END
