      SUBROUTINE KIOPAL
*.
*...  KIOPAL Gets Event from File in OPAL specific four vector files
*.      File name is specified in 'input.dat'
*.
*. SEQUENCE  : ........
*. CALLS     : KZFILE KZREAD KZNSEG KZGET1 KZECLR
*. CALLED    : GUKINE
*.
*     . AUTHOR    : Junichi Kanzaki
*. VERSION   : 1.00
*. CREATED   : 03-Nov-1998
*. LAST MOD  : 03-Nov-1998
*.
*. Modification Log.
*.
*.*********************************************************************
      IMPLICIT NONE
      
#include "geant321/gcflag.inc"
#include "geant321/gckine.inc"

#include "jetset.inc"
#include "hepevt.inc"
      
#include "jmcntl.inc"
#include "jmfile.inc"
#include "fvevnt.inc"
#include "mchead.inc"
      

      REAL ERECM
      LOGICAL DIQRK
      INTEGER IDKMPS(6),IID,IFIND
      
      INTEGER LNBLNK,LUCHGE
      REAL PP,COSTH,PHI
      CHARACTER*16 CNAME

      LOGICAL LEXIST
      
      INTEGER IFORM
      PARAMETER (IFORM=0)
      CHARACTER*80 CMSG

      INTEGER I,J,IERR


*-- OPEN File 

      IF (IEVENT.EQ.1) THEN

         IF (LUNMJM(IFILFI).LE.0) THEN
            CALL MSGOUT('KIOPAL','Logical unit number is wrong',
     &           LUNMJM(IFILFI))
            STOP
         ENDIF

         INQUIRE(FILE=FNAMJM(IFILFI)(:LNBLNK(FNAMJM(IFILFI))),
     &        EXIST=LEXIST)

         IF (.NOT.LEXIST) THEN
            WRITE(CMSG,
     &           '(''Specified file does not exist for '',A4, 
     &           '':'',A)') CTAGJM(I),
     &           FNAMJM(IFILFI)(:LNBLNK(FNAMJM(IFILFI)))
            CALL MSGOUT('KIOPAL',CMSG(:LNBLNK(CMSG)),1)
            STOP
         ELSE
            CALL JUALLC(LUNMJM(IFILFI),
     &           FNAMJM(IFILFI)(:LNBLNK(FNAMJM(IFILFI))),
     &           IFORM,IERR)
            IF (IERR.NE.0) THEN
               CALL MSGOUT('KIOPAL','File allocation error',IERR)
               STOP
            ENDIF
            
         ENDIF

c         print *,'kiopal: file allocation ierr = ',ierr
c         print *,'      : fname = ',fnamjm(ifilfi)
c         WRITE(6,*)
c         WRITE(6,*) 'Event Data is read from >>> ',FNAMJM(IFILFI)
c         WRITE(6,*)

         IF (NSKPJM.GE.1) THEN
            DO I=1,NSKPJM
               CALL EVWRIT (NTRAK,ITKDM,MXTRK,PTRAK,IDTRAK,IHSTRY,
     &              VTX,IERRUN,IEREVT,IDUMM,LUNMJM(IFILFI),'R',IERR)
               IF (IERR.NE.0) THEN
                  IEORUN = 1
                  RETURN
               ENDIF
            ENDDO
         ENDIF

      ENDIF
      
      CALL EVWRIT (NTRAK,ITKDM,MXTRK,PTRAK,IDTRAK,IHSTRY,
     &     VTX,IERRUN,IEREVT,IDUMM,LUNMJM(IFILFI),'R',IERR)
      IF (IERR.NE.0) THEN
         IEORUN = 1
         RETURN
      ENDIF
      
      NHEP = MIN(NTRAK,MXTRK)
c      print *,'kiopal;nhep = ',nhep
      ERECM = 0.
      DO 100 I=1,NHEP
         IDHEP(I) = IDTRAK(I)
         IID = IABS(IDHEP(I))
         JMOHEP(1,I) = IHSTRY(I)
         CALL LUNAME(IDHEP(I),CNAME)
c         print *,'i,id,name,imoth = ',i,idhep(i),cname,jmohep(1,i)
         DO 110 J=1,5
            PHEP(J,I) = PTRAK(J,I)
 110     CONTINUE
         DO 120 J=1,3
            VHEP(J,I) = VTX(J)
 120     CONTINUE
c         print *,'ptrak = ',(ptrak(j,i),j=1,5)
         DIQRK = .FALSE.
         CALL IDECOD (IID,IDKMPS)
         IF (IDKMPS (2).EQ.0 .AND. IDKMPS (4).NE.0) DIQRK = .TRUE.
         IF ((IID.LE. 8 .OR. IID.EQ.21 .OR. DIQRK).OR.
     &       (IID.EQ.91 .OR. IID.EQ.92 .OR. IID.EQ.95 .OR. IID.EQ.93))
     &        THEN
            ISTHEP(I) = 2
         ELSE
            CALL KISTBL (NHEP,I,IHSTRY,IFIND)
            IF (IFIND.EQ.1) THEN
               ERECM = ERECM + PTRAK (4,I)
               PP = SQRT(PTRAK(1,I)**2+PTRAK(2,I)**2+PTRAK(3,I)**2)
               ISTHEP(I) = 1
               IF (LUCHGE(IID).NE.0) THEN
                  COSTH = PTRAK(3,I)/PP
C                  phi   = 180./pi*atan2(ptrak(2,i),ptrak(1,i))
c                  print *,'i,name,p = ',i,' ',cname(:lnblnk(cname)),
c     &                 ' ',pp,costh,phi
               endif
            ELSE
               ISTHEP(I) = 2
            ENDIF
         ENDIF
 100  CONTINUE
      
      EBMMC = 0.5*ERECM
c     print *,'ecm = ',erecm

      RETURN
      END
