      SUBROUTINE KISING
*.
*...GUKINE   GEANT3 user routine
*.           Generates kinematics of primary tracks
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCFLAG GCONST GCKINE
*. CALLS     : GSVERT GFPART GSKINE GPKINE GRNDM JLP2GP
*. CALLED    : GUKINE
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 17-Jun-1994
*. LAST MOD  : 29-JUL-1994
*.
*. MODIFICATION LOG
*. 10-Nov-1998 J.Kanzaki Modify to give the angle limit by PKINE(3).
*. 29-Jul-1994 N.HOSODA Use JLP2GP
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Common for GEANT
#include "geant321/gcflag.inc"
#include "geant321/gconst.inc"
#include "geant321/gckine.inc"

#include "hepevt.inc"

      REAL UB(10),RNDM(2)
      INTEGER NWB
      CHARACTER*20 NAMPRT

      REAL THETA,PHI
      INTEGER IERR
      INTEGER IPN,IPNGEA

      REAL VETO


      NEVHEP   =1
      NHEP     =1
      ISTHEP(1)=1
      JMOHEP(1,1)=0
      JMOHEP(2,1)=0
      JDAHEP(1,1)=0
      JDAHEP(2,1)=0

*--   Define vertex
      VHEP(1,1)=   0.0
      VHEP(2,1)=   0.0
      VHEP(3,1)=   0.0
      VHEP(4,1)=   0.0

*--   Stores vertex parameters

*--   PKINE(2)<=1000: fixed direction,
*--           >1000: random direction from 9deg. to 171deg.
*--           >2000: random direction from 40deg. to 140deg.
      IF (ABS(PKINE(2)) .LE. 1000) THEN

*--     Set particle type, IPN is LUND code.
        IPN=NINT(PKINE(2))

*--     Define direction
        THETA=PKINE(3)*DEGRAD
        PHI  =PKINE(4)*DEGRAD
      ELSE
         IPN=NINT(ABS(PKINE(2))-1000.)
         IPN = ISIGN(IPN,NINT(PKINE(2)))

         VETO=PKINE(3)/360.0*TWOPI

*--   Generate random number
         CALL GRNDM(RNDM,2)
         THETA=(PI-2*VETO)*RNDM(1)+VETO
         PHI  =TWOPI*RNDM(2)
      ENDIF

*--   Extracts the constants describing the particle from the data
*--   structure JPART
      CALL JLP2GP(IPN,IPNGEA,IERR)
      CALL GFPART(IPNGEA,NAMPRT,ITRTYP,AMASS,CHARGE,TLIFE,UB,NWB)
      IDHEP(1)=IPN

*--   Define momentum
      IF (PKINE(1).GT.0.) THEN

         PHEP(1,1)=PKINE(1)*SIN(THETA)*COS(PHI)
         PHEP(2,1)=PKINE(1)*SIN(THETA)*SIN(PHI)
         PHEP(3,1)=PKINE(1)*COS(THETA)
         PHEP(4,1)=SQRT(PHEP(1,1)**2+PHEP(2,1)**2+PHEP(3,1)**2+AMASS**2)
         PHEP(5,1)=AMASS

      ELSEIF (PKINE(1).LT.0.) THEN

         PHEP(1,1)=ABS(PKINE(1))*COS(PHI)
         PHEP(2,1)=ABS(PKINE(1))*SIN(PHI)
         PHEP(3,1)=ABS(PKINE(1))*COS(THETA)/SIN(THETA)
         PHEP(4,1)=SQRT(PHEP(1,1)**2+PHEP(2,1)**2+PHEP(3,1)**2+AMASS**2)
         PHEP(5,1)=AMASS

      ENDIF

      RETURN
      END
