      SUBROUTINE LMFFRD
*.
*...QCFFRD   Read LM parameters
*.
*. INPUT     : non
*. OUTPUT    : non
*.
*. SEQUENCE  :
*. COMMON    : GEFILE
*. CALLS     : FFSET  FFKEY  FFGO  GETDID JUALLC
*. CALLED    : UGINIT
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : T.Tauchi
*. VERSION   : 1.00
*. CREATED   : 4-Feb-1997
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
      IMPLICIT NONE

*-- Common for user
#include "jmfile.inc"
#include "jmdet.inc"
#include "lmgeo.inc"
*
*-- Luminomator geometry parameter
*--   theta1 of luminomater
      THETLM(1,1) = 0.050
*--   theta2 ...
      THETLM(2,1) = 0.150
*--   nearmost Z position
      ZLM(1,1) = 163.0
*--   farmost  ....
      ZLM(2,1) = 178.0
*--   # R division
      NRDLM    = 32
*-    # phi division
      NPDLM    = 16

*-- Luminomator support structure geometry parameter
*--   theta1 of support structure
      THETLM(1,2) = 0.050
*--   theta2 ....
      THETLM(2,2) = 0.150
*--   nearmost Z position
      ZLM(1,2) = 178.0
*--   farmost ...
      ZLM(2,2) = 180.0

*-- inner carbon mask geometry parameters
*--   theta1
      THETLM(1,3) = 0.0
*--   theta2
      THETLM(2,3) = 0.050
*--   nearmost z
      ZLM(1,3) = 50.0
*--   farmost z
      ZLM(2,3) = 70.0
*--   inner radius of mask 
      RMKLM = 2.0

*-- carbon mask in front of luminomator
      THETLM(1,4) = 0.050
      THETLM(2,4) = 0.150
      ZLM(1,4) = 163.0
      ZLM(2,4) = 163.0
      
*-- Find data file name
      IF (LUNMJD(IDETLM).LE.0) RETURN

*-- Set optional values
      CALL FFSET('LINP', LUNMJD(IDETLM))

*-- Define private data records

*-- Geometry Parameters:Luminosity Monitor
      CALL FFKEY('LMT1', THETLM(1,1) , 2, 'REAL')
      CALL FFKEY('LMZ1', ZLM(1,1) , 2, 'REAL')
      CALL FFKEY('LMNR', NRDLM , 1, 'INT')
      CALL FFKEY('LMNP', NPDLM , 1, 'INT')

*-- Support for Luminosity Monitor
      CALL FFKEY('LMT2', THETLM(1,2) , 2, 'REAL')
      CALL FFKEY('LMZ2', ZLM(1,2) , 2, 'REAL')

*-- Inner mask
      CALL FFKEY('LMT3', THETLM(1,3) , 2, 'REAL')
      CALL FFKEY('LMZ3', ZLM(1,3) , 2, 'REAL')
      CALL FFKEY('LMR3', RMKLM , 1, 'REAL')

*-- Carbon mask in front of Luminosity Monitor
      CALL FFKEY('LMT4', THETLM(1,4) , 2, 'REAL')
      CALL FFKEY('LMZ4', ZLM(1,4) , 2, 'REAL')

*-- Read data cards
      CALL FFGO

      IF (ISIMJD(IDETLM).EQ.ISMRJD) THEN
         NRDLM = 1
         NPDLM = 1
         CALL MSGOUT('LMFFRD',
     &        'LM smearing mode; NRDKN,NPDLM are set to 1',1)
      ENDIF

      RETURN
      END
