      SUBROUTINE LMHITS
*.
*...LMHITS   Store HITS for the beam profile monitor
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCSETS GCKINE GCTRAK
*. CALLS     : GSCHIT
*. CALLED    : GUSTEP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : T. Tauchi
*. VERSION   : 1.00
*. CREATED   : 29-Aug-1996
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*. 26-Apr-1999 T.Tauchi; add PCOD (IPART) in the first word.
*. 03-Mar-1999 Nakamura; add semaring mode (very quick)
*. 10-Feb-1997 T.Tauchi; add parameters of origin;IPAOLD,VERT(3),PVERT(3).
*. 28-Jan-1997 T.Tauchi; add Px,Py,Pz in hits.
*.
*.**********************************************************************
*
*--   HITS(1): IPART
*--   HITS(2): X position
*--   HITS(3): Y position
*--   HITS(4): Z position
*--   HITS(5): Momentum of the particle
*--   HITS(6): Px of the particles
*--   HITS(7): Py of the particles
*--   HITS(8): Pz of the particles
*--   HITS(9): Energy deposite
      
      IMPLICIT NONE

*--   Common for GEANT
#include "geant321/gcsets.inc"
#include "geant321/gckine.inc"
#include "geant321/gctrak.inc"
#include "geant321/gctmed.inc"
#include "geant321/gcvolu.inc"
      
#include "jmdet.inc"
#include "lmhit.inc"
#include "lmsmdt.inc"
*      
      INTEGER IHIT

      REAL HITS(NDHTLM)

*
*-- check skip flag
      IF (ISIMJD(IDETLM).EQ.ISKPJD) THEN 
*-- skip                   
         GOTO 999
      ELSE IF (ISIMJD(IDETLM).EQ.ISMRJD) THEN 
*-- smearing mode
         IF (NLMSMH.GE.MXHTLM) THEN
            CALL MSGOUT('LMHITS','LM buffer is full',NLMSMH)
C           WRITE(*,*) 'LM buffer full'
            GOTO 999
         ENDIF
         NLMSMH = NLMSMH + 1
         ILMSMH(1,NLMSMH) = IPART
         ILMSMH(2,NLMSMH) = ITRA
         RLMSMH(1,NLMSMH) = VECT(1)
         RLMSMH(2,NLMSMH) = VECT(2)
         RLMSMH(3,NLMSMH) = VECT(3)
         RLMSMH(4,NLMSMH) = VECT(7)
         RLMSMH(5,NLMSMH) = VECT(7)*VECT(4)
         RLMSMH(6,NLMSMH) = VECT(7)*VECT(5)
         RLMSMH(7,NLMSMH) = VECT(7)*VECT(6)
*-- terminate transport
         ISTOP = 1
      ELSE
*--  return unless energy loss
         IF (DESTEP.LE.0.) GOTO 999
*-- full simulation mode store hits
         HITS(1)=IPART
         HITS(2)=VECT(1)
         HITS(3)=VECT(2)
         HITS(4)=VECT(3)
         HITS(5)=VECT(7)
         HITS(6)=VECT(7)*VECT(4)
         HITS(7)=VECT(7)*VECT(5)
         HITS(8)=VECT(7)*VECT(6)
         HITS(9)=DESTEP
         CALL GSCHIT(ISET,IDET,ITRA,NUMBV,HITS,1,IHIT)
      ENDIF
*
  999 CONTINUE
      RETURN
      END
