            SUBROUTINE MUFFRD
*.
*...MUFFRD   Read muon chamber parameters
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GEFILE
*. CALLS     : FFSET  FFKEY  FFGO 
*. CALLED    : UGINIT
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Junichi Kanzaki
*. VERSION   : 1.00
*. CREATED   : 26-Jan-1999
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
      IMPLICIT NONE

*-- Common for user
#include "jmdet.inc"
#include "irgeo.inc"
#include "mugeo.inc"

      INTEGER I
      
      DO 100 I=1,NSECMU
         BLNGMU(I) = 1600.
         BTHKMU(I) = 20.
         IF (MOD(I,2).EQ.1) THEN
            BWIDMU(I) = 700.
         ELSE
            BWIDMU(I) = 540.
         ENDIF
 100  CONTINUE
      
      BRADMU = 720.
      WCELMU = 5.

      NLAYMU = 4

      IF (LUNMJD(IDETMU).LE.0) RETURN

*-- Set optional values
      CALL FFSET('LINP', LUNMJD(IDETMU))

*-- Define private data records

*-- Length, width, thickness of muon module
      CALL FFKEY('MULN', BLNGMU , NSECMU, 'REAL')
      CALL FFKEY('MUWD', BWIDMU , NSECMU, 'REAL')
      CALL FFKEY('MUTK', BTHKMU , NSECMU, 'REAL')

      CALL FFKEY('MURD', BRADMU , 1, 'REAL')
      CALL FFKEY('MUCE', WCELMU , 1, 'REAL')
      CALL FFKEY('MULY', NLAYMU , 1, 'INTE')

*-- Read data cards
      CALL FFGO

  999 CONTINUE
      RETURN
      END
