      SUBROUTINE SMFALL(IPART0,AMASS,EK0,P,X0,FLAG,
     &           MAXLX,MAXLY,MAXV,VENE,VWORK1,VWORK2)
      IMPLICIT NONE

      INTEGER IPART0,IPART
      REAL    AMASS,EK0,P(*),X0(*)
      INTEGER MAXLX,MAXLY,MAXV
      REAL    TOTDEP
      REAL    VENE(MAXLX,MAXLY,MAXV)
      REAL    VWORK1(MAXLX,MAXLY,MAXV)
      REAL    VWORK2(MAXLX,MAXLY,MAXV)
      REAL    P1(3),P2(3),P3(3),RM(3,3),PTOT
      REAL    ELEAK,ALLENE

      INTEGER IV,IX,IY,FLAG
      REAL    ELOTOT,ESHTOT,ESHWER
      INTEGER ISTOP,INUCLI
      REAL    U

      REAL    EVALUE

      REAL    TEMP1,TEMP2

*-- normalisation factor for initial summention (To be tuned !)
      REAL    CFELOS,CFEHAD,CFEEM
      PARAMETER ( CFELOS = 1.0, CFEHAD = 1.0, CFEEM = 1.0 )

*-- correction factor for hadron relative to electron  
*-- Tuned with JIM Full simulation of 10 GeV gamma and pion+
*-- (Koji ISHII 03-Mar-1999)
      REAL    CORHAD
      PARAMETER (CORHAD = 0.81795/0.9006)

*-- CAL sampling rate (Tune up parameter to be same as Full simulation)
*-- Tuned with JIM Full simulation of 10 GeV gamma
*-- (Koji ISHII 02-Mar-1999)
      REAL    SAMPLE
      PARAMETER (SAMPLE = 0.028015/0.9968)  

      CHARACTER*80 CMSG
      INTEGER LNBLNK

CKI
*     EM and HAD resolution
      REAL    EMRES,HADRES,RVEC(1),SCALEF
      PARAMETER (EMRES = 0.15)
      PARAMETER (HADRES = 0.40)

*   IMODE (only for EM)
*-- 0: for surface injection (shape generate also in radial direction)
*-- 1: for secondary inside volume (shape just in depth (momentum) direction)
      INTEGER IMODE
      IMODE = FLAG 
CKI (09.Feb.99)

*****************************************************************************

      IPART = IPART0
      IF ((IPART.GT.0.AND.IPART.LE.6).OR.IPART.EQ.8.OR.IPART.EQ.9.OR.
     &     IPART.EQ.10.OR.IPART.EQ.13.OR.IPART.EQ.14) THEN
         CONTINUE
      ELSEIF (IPART.EQ.7) THEN
         WRITE(CMSG,'(''Pi0 detected. use neutral hadron,'',
     &        ''temporary..BUT You should not'')')
         CALL MSGOUT('SMFALL',CMSG(:LNBLNK(CMSG)),1)
         IPART = 10
      ELSEIF (IPART.EQ.11) THEN
         IPART = 8
      ELSEIF (IPART.EQ.12) THEN
         IPART = 9
      ELSEIF (IPART.EQ.15) THEN  
*-- anti proton 
*-- use K0L as model. In real physics, the absorption makes ~ 2GeV, ignore
         IPART = 10
      ELSEIF (IPART.EQ.16) THEN
         IPART = 10
      ELSEIF (IPART.EQ.17) THEN  
*-- eta
         WRITE(CMSG,'(''Eta detected. use neutral hadron,'',
     &        ''temporary..BUT You should not'')')
         CALL MSGOUT('SMFALL',CMSG(:LNBLNK(CMSG)),2)
         IPART = 10
      ELSEIF (IPART.EQ.25) THEN  
*-- anti neutron
*-- use K0L as model. In real physics, the absorption makes ~ 2GeV, ignore
         IPART = 10
      ELSEIF (IPART.GE.18.AND.IPART.LE.32) THEN   
*-- (anti) strange baryons
         IPART = 10
      ELSEIF (IPART.EQ.45) THEN  
*-- deuteron
*-- as (HEAVY) proton
         IPART = 14   
      ELSEIF (IPART.EQ.46) THEN  
*-- tritium
*-- as (HEAVY) proton
         IPART = 14   
      ELSE
         WRITE(CMSG,'(''undefined particle ID detected.'')')
         CALL MSGOUT('SMFALL',CMSG(:LNBLNK(CMSG)),IPART0)
         DO 100 IV=1,MAXV
            DO 110 IY=1,MAXLY
               DO 120 IX=1,MAXLX
                  VENE(IX,IY,IV) = 0.
 120           CONTINUE 
 110        CONTINUE 
 100     CONTINUE 
         RETURN
      ENDIF

      PTOT=SQRT(P(1)**2+P(2)**2+P(3)**2)
      IF (PTOT.LE.0.) THEN      
         CALL MSGOUT('SMFALL','ZERO MOMENTUM detected',1)
         RETURN
      ENDIF

*----- Rotation Matrix calculation
      CALL SMGMTX(P,P1,P2,P3,RM)

*-- kinetic energy  (for e-, e+, gamma etc..)
      EVALUE = EK0 

      U = 0.
      IF (IPART.LE.3) THEN    
*-- EM
         IF (IMODE.EQ.0) THEN
            CALL SMFEM0(P,X0,MAXLX,MAXLY,MAXV,TOTDEP,VWORK1,RM)
         ELSE
            CALL SMFEM1(P,X0,MAXLX,MAXLY,MAXV,TOTDEP,VWORK1,RM)
         ENDIF
         DO 200 IV=1,MAXV
            DO 210 IX=1,MAXLX
               DO 220 IY=1,MAXLY
                  IF (TOTDEP.GT.0.) THEN
                     U = U + VWORK1(IX,IY,IV)
                     VENE(IX,IY,IV) = VWORK1(IX,IY,IV) / TOTDEP 
     &                    * EVALUE * CFEEM
                  ELSE
                     VENE(IX,IY,IV) = 0.0
                  ENDIF
 220           CONTINUE
 210        CONTINUE
 200     CONTINUE

         IF (TOTDEP.GT.0) THEN
            ELEAK = EK0 * (1.- U / TOTDEP)
         ELSE
            ELEAK = EK0
         ENDIF

         ALLENE = EK0
         
      ELSE 
C     IF (IMODE.EQ.0) THEN
C     CALL SMFHD0(P,X0,IPART,EK0,AMASS,MAXLX,MAXLY,MAXV,
C    &           ELOTOT,VWORK1,ESHTOT,ESHWER,VWORK2,ISTOP,INUCLI,RM)
C     ELSE
         CALL SMFHD1(P,X0,IPART,EK0,AMASS,MAXLX,MAXLY,MAXV,
     &        ELOTOT,VWORK1,ESHTOT,ESHWER,VWORK2,ISTOP,INUCLI,RM)
C     ENDIF
         
*-- ELOTOT, ESHWER(available kinetic energy) is GeV unit
         
         TEMP1 = 0
         TEMP2 = 0
         
         DO 300 IV=1,MAXV
            DO 310 IY=1,MAXLY
               DO 320 IX=1,MAXLX
                  TEMP1=TEMP1+VWORK1(IX,IY,IV)
                  TEMP2=TEMP2+VWORK2(IX,IY,IV)
                  VENE(IX,IY,IV) = ( VWORK1(IX,IY,IV) * CFELOS + 
     &                 VWORK2(IX,IY,IV) * CFEHAD ) * CORHAD
 320           CONTINUE
 310        CONTINUE
 300     CONTINUE
      ENDIF

*----- generate randam numbers (Gaussian-distributed Random Numbers)
*  22.Jan.99 Koji ISHII
      
      CALL GNORML(RVEC,1)
C      CALL RNORML(RVEC,1)
      IF(IPART.LE.3) THEN 
C EM
        SCALEF=1.0+EMRES/SQRT(EVALUE)*RVEC(1)
      ELSE
C HADRON
        SCALEF=1.0+HADRES/SQRT(EVALUE)*RVEC(1)
      ENDIF
      IF(SCALEF.LE.0.01) THEN
        SCALEF=0.01
      ELSEIF(SCALEF.GE.3.0) THEN
        SCALEF=3.0
      ENDIF
      SCALEF=SCALEF*SAMPLE
      
*---- now scaling for sampling rate 
      DO 400 IV=1,MAXV
         DO 410 IY=1,MAXLY
            DO 420 IX=1,MAXLX
               VENE(IX,IY,IV) = VENE(IX,IY,IV) * SCALEF
 420        CONTINUE
 410     CONTINUE
 400  CONTINUE
      
      RETURN
      END
