      SUBROUTINE SMFEM0(P,X0,MAXLX,MAXLY,MAXV,TOTDEP,VENE,RM)
*     3-dimensional (sllower than EM1, but consider also in radial width)
      IMPLICIT NONE

      REAL P(*)
      REAL X0(*)
      REAL PTOT,RM(3,3),TOTDEP,ZINTG0
      REAL XI,YI,ZI,POSI(3),POSV(3)      
      INTEGER NZ,NPHI,NR,IDVCUR,IDXCUR,IDYCUR,IPHI,IR,IZ,I,J,
     &        IDV,IDX,IDY
      REAL    ZMAX,RMAX,DPHI,DZ,DR,PHI,SINP,COSP,R,
     &        ZS1,ZS2,RWGT,ZINTG1,ZINTG2,ZZERO

      PARAMETER (NZ=25) 
      PARAMETER (ZMAX=25.0) 
      PARAMETER (NPHI=12)
      PARAMETER (NR=8)
      PARAMETER (RMAX=4.0)

      PARAMETER (DPHI=2.*3.141592/NPHI)
      PARAMETER (DZ  =ZMAX/NZ)
      PARAMETER (DR  =RMAX/NR)
      
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*----- RESULTS without rndm fluctuation
      INTEGER MAXV
      INTEGER MAXLX,MAXLY
      REAL  VENE(MAXLX,MAXLY,MAXV)
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      INTEGER IX,IY,IV


      TOTDEP = 0.

*-- first check
      PTOT = SQRT(P(1)**2+P(2)**2+P(3)**2)
      IF (PTOT.LE.0.) THEN
         CALL MSGOUT('SMFEM0','ZERO MOMENTUM detected',1)
C         write(*,*)' ZERO MOMENTUM detected '
         RETURN
      ENDIF

*-- initialyzation for loop
*-- current Volume like PS,EM,HC
      IDVCUR = 0
*-- current Block X-ID in each PS,EM,HC
      IDXCUR = 0
*-- current Block Y-ID in each PS,EM,HC
      IDYCUR = 0

*-- initialyse 0 energy deposit
C      CALL VZERO(VENE,MAXV*MAXLX*MAXLY)
      DO 100 IV=1,MAXV
         DO 110 IY=1,MAXLY
            DO 120 IX=1,MAXLX
               VENE(IX,IY,IV) = 0.
 120        CONTINUE
 110     CONTINUE
 100  CONTINUE

      ZINTG0 = 1.0

*-- Loop
*-- phi first for CPU time
      DO 200 IPHI=1,NPHI
*-- Phi center 
         PHI=(FLOAT(IPHI-1)+0.5)*DPHI
         SINP = SIN(PHI)
         COSP = COS(PHI)

         DO 210 IR=1,NR
*-- R center
            R=(FLOAT(IR-1)+0.5)*DR
            XI=R*COSP
            YI=R*SINP

*-- calculate R relative weight
            CALL SMIREM(R,RWGT)

            TOTDEP = TOTDEP + ZINTG0 * RWGT

            DO 220 IZ=1,NZ
*-- Z CENTER POS
C               ZI=(FLOAT(IZ)-0.5)*DZ
*-- Z POS (start from 0.)
               ZI=FLOAT(IZ)*DZ
*-- now position in shower cordinate has been done (XI,YI,ZI)
               POSI(1) = XI
               POSI(2) = YI
               POSI(3) = ZI
*-- Get sub-detector coordinate position
*-- 1st rotation with origin = shower origin
               CALL VZERO(POSV,3)
               DO 230 I=1,3
                  DO 240 J=1,3
*-- after debug SY
                     POSV(I)=POSV(I)+RM(J,I)*POSI(J)
 240              CONTINUE
 230           CONTINUE
*-- move parallel 
               DO 250 I=1,3
                  POSV(I)=POSV(I)+X0(I)
 250           CONTINUE
*-- determine the internal ID for detector coordinate
               
CKI               CALL SMPCAL(POSV,IDV,IDX,IDY)

*-- For endcap MAXLX = 128 (phi) and MAXLY = 20 (r)
               IF(MAXLX.EQ.128) THEN
                  CALL SMPEND(POSV,IDV,IDX,IDY)
*-- For barrel MAXLX = 16 (theta) and MAXLY = 16 (phi)
               ELSE
                  CALL SMPBAR(POSV,IDV,IDX,IDY)
               ENDIF

*-- examin start detector
               IF (IZ.EQ.1) THEN
                  IDVCUR=IDV
                  IDXCUR=IDX
                  IDYCUR=IDY
                  ZZERO=0.0
               ELSEIF (IDV.NE.IDVCUR.OR.IDX.NE.IDXCUR.OR.
     &                 IDY.NE.IDYCUR.OR.IZ.EQ.NZ) THEN
                  ZS1=ZZERO
                  ZS2=ZI-0.5*DZ
*-- calculate Z dependence deposit
                  CALL SMIZEM(PTOT,R,ZS1,ZINTG1)
                  CALL SMIZEM(PTOT,R,ZS2,ZINTG2)
                  IF (IDXCUR.GT.0.AND.IDYCUR.GT.0.AND.IDVCUR.GT.0) 
     &                 VENE(IDXCUR,IDYCUR,IDVCUR)=
     &                 VENE(IDXCUR,IDYCUR,IDVCUR)+
     &                 ABS(ZINTG1-ZINTG2)*RWGT
                  IF (IDV.NE.IDVCUR) IDVCUR=IDV
                  IF (IDX.NE.IDXCUR) IDXCUR=IDX
                  IF (IDY.NE.IDYCUR) IDYCUR=IDY
                  ZZERO=ZI-0.5*DZ
               ENDIF 
 220        CONTINUE
 210     CONTINUE
 200  CONTINUE
      
      RETURN
      END
