      SUBROUTINE SMFEM1(P,X0,MAXLX,MAXLY,MAXV,TOTDEP,VENE,RM)
*     3-dimensional but just in momentum (depth) direction
*     for secondary EM particles

      IMPLICIT NONE

      REAL P(*)
      REAL X0(*)
      REAL PTOT,RM(3,3),TOTDEP,ZINTG0
      REAL ZI,POSI(3),POSV(3)      
      INTEGER NZ,IDVCUR,IDXCUR,IDYCUR,IZ,I,
     &        IDV,IDX,IDY
      REAL    ZMAX,DZ,R,
     &        ZS1,ZS2,ZINTG1,ZINTG2,ZZERO

      PARAMETER (NZ=25) 
      PARAMETER (ZMAX=25.0) 
      PARAMETER (DZ  =ZMAX/NZ) 
      
      INTEGER MAXV
      INTEGER MAXLX,MAXLY
      REAL  VENE(MAXLX,MAXLY,MAXV)

      INTEGER IX,IY,IV


      TOTDEP = 0.

*-- first check
      PTOT = SQRT(P(1)**2+P(2)**2+P(3)**2)
      IF (PTOT.LE.0.) THEN      
C         write(*,*)' ZERO MOMENTUM detected '
         CALL MSGOUT('SMFEM1','ZERO MOMENTUM detected',1)
         RETURN
      ENDIF

*-- initialization for loop
*-- current Volume like PS,EM,HC
      IDVCUR = 0
*-- current Block X-ID in each PS,EM,HC
      IDXCUR = 0
*-- current Block Y-ID in each PS,EM,HC
      IDYCUR = 0
*-- initialyse 0 energy deposit
C      CALL VZERO(VENE,MAXV*MAXLX*MAXLY)
      DO 100 IV=1,MAXV
         DO 110 IY=1,MAXLY
            DO 120 IX=1,MAXLX
               VENE(IX,IY,IV) = 0.
 120        CONTINUE
 110     CONTINUE
 100  CONTINUE

      ZINTG0 = 1.0
      TOTDEP =  1.0
      R   =   0.
*-- Loop only in Z direction
      DO 200 IZ=1,NZ
*-- Z POS (start from 0.)
         ZI=FLOAT(IZ)*DZ
*-- now position in shower cordinate has been done (XI,YI,ZI)
         POSI(1) = 0.
         POSI(2) = 0.
*-- on particle trajectry (0 for X and Y)
         POSI(3) = ZI
*-- Get sub-detector coordinate 
         DO 210 I=1,3
            POSV(I)=X0(I)+RM(3,I)*POSI(3) 
 210     CONTINUE
*-- determine the internal ID for detector coordinate
         
CKI         CALL SMPCAL(POSV,IDV,IDX,IDY)

*-- For endcap MAXLX = 128 (phi) and MAXLY = 20 (r)
               IF(MAXLX.EQ.128) THEN
                  CALL SMPEND(POSV,IDV,IDX,IDY)
*-- For barrel MAXLX = 16 (theta) and MAXLY = 16 (phi)
               ELSE
                  CALL SMPBAR(POSV,IDV,IDX,IDY)
               ENDIF

*-- examin start detector
         IF (IZ.EQ.1) THEN
            IDVCUR =IDV
            IDXCUR=IDX
            IDYCUR=IDY
            ZZERO=0.0
         ELSEIF (IDV.NE.IDVCUR.OR.IDX.NE.IDXCUR.OR.
     &           IDY.NE.IDYCUR.OR.IZ.EQ.NZ) THEN
            ZS1=ZZERO
            ZS2=ZI-0.5*DZ
*-- calculate Z dependence deposit
            CALL SMIZEM(PTOT,R,ZS1,ZINTG1)
            CALL SMIZEM(PTOT,R,ZS2,ZINTG2)
            IF (IDXCUR.GT.0.AND.IDYCUR.GT.0.AND.IDVCUR.GT.0) 
     &           VENE(IDXCUR,IDYCUR,IDVCUR)=
     &           VENE(IDXCUR,IDYCUR,IDVCUR)+
     &           ABS(ZINTG1-ZINTG2)
            IF (IDV.NE.IDVCUR) IDVCUR=IDV
            IF (IDX.NE.IDXCUR) IDXCUR=IDX
            IF (IDY.NE.IDYCUR) IDYCUR=IDY
            ZZERO=ZI-0.5*DZ
         ENDIF
 200  CONTINUE

      RETURN
      END
