      SUBROUTINE SMFHD0(P,X0,IPART,EK0,AMASS,MAXLX,MAXLY,MAXV,
     &           DELOTO,VELOSS,DESHTO,ESHWER,VENE,ISTOP,INUCLI,RM)
* hadron shower shape simulation (NOT YET AVAILABLE)
*************************************************************************
      IMPLICIT NONE
*   IPART=13,14,8,9 available now  (neutron,proton,pi+-)
      INTEGER IPART
      REAL EK,AMASS,EK0,ESHWER
      REAL P(*)
      REAL X0(*)
      REAL PTOT,RM(3,3)
      REAL XI,YI,ZI,POSI(3),POSV(3)
      INTEGER NPHI,NR,IDVCUR,IDXCUR,IDYCUR,IPHI,IR,IZ,I,J,
     &     IDV,IDX,IDY
      REAL ZMIN,ZMAX,RMAX,DPHI,DZNUCL,DR,PHI,SINP,COSP,R,
     &     ZS1,ZS2,RWGT,ZZERO

      PARAMETER (ZMIN=-10.0)
      PARAMETER (ZMAX=40.0)
      PARAMETER (RMAX=40.0)
      PARAMETER (NPHI=16)
      PARAMETER (DPHI=2.*3.141592/NPHI)
C      PARAMETER (NZ=150)
C      PARAMETER (DZNUCL  =(ZMAX-ZMIN)/NZ)
C      PARAMETER (NR=80)
C      PARAMETER (DR  =RMAX/NR)
      
      REAL ZIPOS,RANGE,DE,DERNGE
      INTEGER ISTOP
      REAL DZELOS,ZLOMAX,PASSEL
      PARAMETER (DZELOS = 0.5, ZLOMAX = 200.0)
      INTEGER NZELOS

      REAL DELOTO,DESHTO,RDUM,DE2,DE1,ZINTG0,ZINTG
      INTEGER INUCLI,ICHRGE 

*-- almost always particle stop in Pb
*-- So just 10 % of Mass energy deposit
*-- if particle is not proton nor neutron
*-- no special treatment for nuclear absorption for pi-
      REAL     STOPPI
      PARAMETER (STOPPI = 0.1)

*-- for Z step size
      REAL INHC
      PARAMETER (INHC = 30)

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*----- RESULTS without rndm fluctuation
      INTEGER MAXV
      INTEGER MAXLX,MAXLY
      REAL  VENE(MAXLX,MAXLY,MAXV)
      REAL  VELOSS(MAXLX,MAXLY,MAXV)
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      
      INTEGER IX,IY,IV


      DELOTO = 0.
      DESHTO = 0.
      ESHWER   = 0.
      ISTOP = 0
      INUCLI= 0

*----- first check
      PTOT = SQRT(P(1)**2+P(2)**2+P(3)**2)
      IF (PTOT.LE.0.) THEN
C         write(*,*)' ZERO MOMENTUM detected '
         CALL MSGOUT('SMFHD0','ZERO MOMENTUM detected',1)
         RETURN
      ENDIF
      IF (IPART.NE.8.AND.IPART.NE.9.AND.
     &     IPART.NE.13.AND.IPART.NE.14) THEN
         CALL MSGOUT('SMFHD0','IPART not supported for this routine',
     &        IPART)
C         write(*,*)' IPART not supported for this routine',IPART
         RETURN
      ENDIF

*-- check charged or not
      IF (IPART.EQ.8.OR.IPART.EQ.9.OR.IPART.EQ.14) THEN
         ICHRGE = 1
      ELSE
         ICHRGE = 0
      ENDIF

*-- initialyse 0 energy deposit
C      CALL VZERO(VENE,MAXV*MAXLX*MAXLY)
C      CALL VZERO(VELOSS,MAXV*MAXLX*MAXLY)
      DO 110 IV=1,MAXV
         DO 120 IY=1,MAXLY
            DO 130 IX=1,MAXLX
               VENE(IX,IY,IV) = 0.
               VELOSS(IX,IY,IV) = 0.
 130        CONTINUE
 120     CONTINUE
 110  CONTINUE

*-- for hadron special treatment for the first interaction position
*-- to make big fluctuation in depth      

*-- initialization
*-- kinetic energy
      EK = EK0

*-- interaction position determination (random generator)
      CALL SMPGEN(EK,AMASS,IPART,ZIPOS)
      IF (ICHRGE.EQ.1) THEN 
         CALL SMIELO(EK,AMASS,ZIPOS, RANGE,DERNGE,ISTOP)
*-- total energy loss 
         DE    = DERNGE
*-- ! warning!! DELOTO is NOT actual Eloss
*-- in the detector. It is for normalisation
         DELOTO = DELOTO + DE
      ELSE
*-- neutron
         ISTOP = 0
*-- no range (neutron)
         RANGE = 1.E+10
         DE    = 0.0
         DELOTO = DE
      ENDIF

      IF (ISTOP.EQ.1) THEN
*-- just energy loss, hence we have to set ZIPOS to range.
         ZIPOS = RANGE
         EK    = 0.0
*-- no more hadron interaction
         INUCLI= 0

*-- check if stop position is inside detector or not
         POSI(1) = 0.
         POSI(2) = 0.
         POSI(3) = ZIPOS
*-- Get sub-detector coordinate position
         DO 200 I=1,3
*-- just for 3rd axis matrix calc(fast)
            POSV(I)=X0(I)+RM(3,I)*POSI(3)
 200     CONTINUE
*-- determine the internal ID for detector coordinate
         CALL SMPCAL(POSV,IDV,IDX,IDY)
         IF (IDV.LE.0) THEN
*-- OUT of boundary
*-- not stop
            ISTOP = 0
         ELSE
*-- stop inside detector
            ISTOP = 1
         ENDIF

*-- For pi+- pi mass energy deposit ???
         IF ((IPART.EQ.8.OR.IPART.EQ.9).AND.
     &        ISTOP.EQ.1.AND.IDX.GT.0.AND.IDY.GT.0) THEN
            VELOSS(IDX,IDY,IDV) = VELOSS(IDX,IDY,IDV) + 
     &           STOPPI * AMASS
            DELOTO = DELOTO + STOPPI * AMASS
         ENDIF

      ELSE
*-- interaction occur at (0,0,ZIPOS) in particle coordinate 
*--   (no multiple-scattering approximation)

*-- check if the interaction point is out of boundary or inside         
         
*-- now position in shower cordinate has been done (0,0,ZIPOS)
         POSI(1) = 0.
         POSI(2) = 0.
         POSI(3) = ZIPOS
*-- Get sub-detector coordinate position
         DO 210 I=1,3
*-- just for 3rd axis matrix calc(fast)
            POSV(I)=X0(I)+RM(3,I)*POSI(3)
 210     CONTINUE
*-- determine the internal ID for detector coordinate
         CALL SMPCAL(POSV,IDV,IDX,IDY)
         IF (IDV.LE.0) THEN
*== OUT of boundary
*-- no interaction
            INUCLI = 0
         ELSE
*-- interaction has occur (later shower generate)
            INUCLI = 1
         ENDIF

C*-- calculate energy loss from 0 to ZIPOS
C*-- Kinetic energy after Eloss
C         EK = EK - DERNGE

      ENDIF

*========= STEP by STEP filling for energyloss part

      IF (ICHRGE.NE.1) GOTO 777

*-- set 0 for total pass length
      PASSEL = 0.

*-- initialyzation for loop
*-- start position
      CALL SMPCAL(X0,IDV,IDX,IDY)
*-- current Volume like PS,EM,HC
      IDVCUR = IDV
*-- current Block X-ID in each PS,EM,HC
      IDXCUR= IDX
*-- current Block Y-ID in each PS,EM,HC
      IDYCUR= IDY
      
*-- first loop for energy loss (just for charged particles)
*-- Loop in Z step

      NZELOS = INT(MIN(ZIPOS,ZLOMAX)/DZELOS)

C      write(*,*)'ZIPOS = ',ZIPOS,NZELOS

      ZZERO=0.0
      DO 300 IZ=1,NZELOS
*-- Z POS (start from 0.  (next step))
         POSI(3)=FLOAT(IZ)*DZELOS
         ZI     =POSI(3)
*-- Get sub-detector coordinate position
         DO 310 I=1,3
*-- just for 3rd axis matrix calc(fast)
            POSV(I)=X0(I)+RM(3,I)*POSI(3)
 310     CONTINUE
*-- determine the internal ID for detector coordinate
         CALL SMPCAL(POSV,IDV,IDX,IDY)
         
*-- add length
         IF (IDV.GT.0) PASSEL = PASSEL + DZELOS

         IF ((IDV.NE.IDVCUR.OR.IDX.NE.IDXCUR.OR.
     &        IDY.NE.IDYCUR).OR.IZ.EQ.NZELOS) THEN
            ZS1=ZZERO
            ZS2=ZI-0.5*DZELOS
*-- calculate integrated Eloss from ZS1 to ZS2
            CALL SMIELO(EK0,AMASS,ZS2,RDUM,DE2,ISTOP)
            CALL SMIELO(EK0,AMASS,ZS1,RDUM,DE1,ISTOP)
            DE=ABS(DE2-DE1)
*-- calculate R relative weight
            IF (IDXCUR.GT.0.AND.IDYCUR.GT.0.AND.IDVCUR.GT.0) 
     &           VELOSS(IDXCUR,IDYCUR,IDVCUR)=
     &           VELOSS(IDXCUR,IDYCUR,IDVCUR)+DE
            
            IF (IDV.NE.IDVCUR) IDVCUR=IDV
            IF (IDX.NE.IDXCUR) IDXCUR=IDX
            IF (IDY.NE.IDYCUR) IDYCUR=IDY
            ZZERO=ZI-0.5*DZELOS
         ENDIF
         
 300  CONTINUE

      CALL SMIELO(EK0,AMASS,PASSEL,RDUM,DE,ISTOP)
*-- new energy
      EK = EK - DE

 777  CONTINUE

*-- 2nd loop for shower shape (just for interacted case)

      IF (INUCLI.NE.1)  GOTO 888
C*-- temp
C      IF (INUCLI.EQ.1)  GOTO 888

      ESHWER = EK

*-- current Volume like PS,EM,HC
      IDVCUR = 0
*-- current Block X-ID in each PS,EM,HC
      IDXCUR= 0
*-- current Block Y-ID in each PS,EM,HC      
      IDYCUR= 0

*-- primary calculation for Z integration for all integration region
      CALL SMIDEP(ZMIN,ZMAX,ZINTG0)
      ZINTG0 = ABS(ZINTG0)

*-- Loop
*-- phi first for CPU time
      DO 400 IPHI=1,NPHI
*-- Phi center 
         PHI=(FLOAT(IPHI-1)+0.5)*DPHI
         SINP = SIN(PHI)
         COSP = COS(PHI)

         DR=4.0
         NR=INT(RMAX/DR)

         DO 410 IR=1,NR
*-- R center
            R=(FLOAT(IR-1)+0.5)*DR
            XI=R*COSP
            YI=R*SINP

*-- calculate R relative weight
            CALL SMIRHD(R,RWGT)
*-- For total deposit
            DESHTO=DESHTO+ZINTG0*RWGT

*-- reset ZI
            ZI = ZMIN
            DZNUCL = 1.0

            IZ = 0
 100        CONTINUE
            IZ = IZ + 1
            
*-- XI YI ZI are in "shower" coordinate
*-- now position in shower cordinate has been done (XI,YI,ZI)
            POSI(1) = XI
            POSI(2) = YI
*-- Move from shwer to particle coordinate
            POSI(3) = ZI + ZIPOS
*-- Get sub-detector coordinate position
*-- 1st rotation with origin = shower origin
            CALL VZERO(POSV,3)
            DO 420 I=1,3
               DO 430 J=1,3
*-- after debug SY
                  POSV(I)=POSV(I)+RM(J,I)*POSI(J)
 430           CONTINUE
 420        CONTINUE
*-- move parallel 
            DO 440 I=1,3
               POSV(I)=POSV(I)+X0(I)
 440        CONTINUE
            
*-- determine the internal ID for detector coordinate
            
            CALL SMPCAL(POSV,IDV,IDX,IDY)

*-- next step size            
            IF (IDV.EQ.3.AND.POSV(3).GT.INHC) THEN
               DZNUCL = 4.0
            ELSE
               DZNUCL = 1.0
            ENDIF
            
*-- examin start detector
            
            IF (IZ.EQ.1) THEN
               IDVCUR =IDV
               IDXCUR=IDX
               IDYCUR=IDY
               ZZERO  =ZMIN
            ELSEIF ((IDV.NE.IDVCUR.OR.IDX.NE.IDXCUR.OR.
     &              IDY.NE.IDYCUR).OR.ZI+DZNUCL.GE.ZMAX) THEN
               ZS1=ZZERO
               ZS2=ZI
               IF (ZI+DZNUCL.GE.ZMAX) ZS2 = ZMAX
               
*-- calculate Z dependence deposit
               CALL SMIDEP(ZS1,ZS2,ZINTG)
               IF (IDXCUR.GT.0.AND.IDYCUR.GT.0.AND.IDVCUR.GT.0) 
     &              VENE(IDXCUR,IDYCUR,IDVCUR)=
     &              VENE(IDXCUR,IDYCUR,IDVCUR)+
     &              ABS(ZINTG)*RWGT
               
               IF (IDV.NE.IDVCUR) IDVCUR=IDV
               IF (IDX.NE.IDXCUR) IDXCUR=IDX
               IF (IDY.NE.IDYCUR) IDYCUR=IDY
               ZZERO=ZI
               
            ENDIF
            
*-- next Z POS
            ZI=ZI+DZNUCL
            IF (ZI.GE.ZMAX) GOTO 101
            
            GOTO 100
            
 101        CONTINUE
            
 410     CONTINUE
 400  CONTINUE 

 888  CONTINUE
      
      RETURN
      END
