      REAL FUNCTION SMRNGE(EK,M)
*---- Range calculation from EK (kinetic energy)
*---- unit : EK,M   GeV          RANGE  cm
*---- availabel upto beta*gamma=100
      
      IMPLICIT NONE
      REAL  EK,M 

      REAL CUT1,CUT2,CUT3,CUT4,CUT5
      PARAMETER (CUT1=0.45, CUT2=1.3, CUT3=3.0, CUT4=6.0, CUT5=10.0 ) 
      REAL P1(4),P2(3),P3(3),P4(3),P5(3),P6(3)
      SAVE P1,P2,P3,P4,P5,P6 
      DATA P1 /  -.11380E-01,  .34744,  -3.2177,  14.567 / 
      DATA P2 /  2.0607 ,  -11.715 ,  19.911 / 
      DATA P3 /  -20.785,  22.839,  6.9017 /
      DATA P4 /  -45.619,  47.789 ,  1.4004 / 
      DATA P5 /   -81.298,  63.920 ,  -.31014/
      DATA P6 /   -5.7157 ,  54.701,  -.55060E-01/ 

      REAL ETOT,PTOT,BTGM,RNORM

      
      ETOT=EK+M
      PTOT=SQRT(ETOT**2-M**2)
      BTGM=PTOT/M

      IF (BTGM.LT.CUT1) THEN
         RNORM=P1(1)+P1(2)*BTGM+P1(3)*BTGM**2+P1(4)*BTGM**3
      ELSEIF (BTGM.LT.CUT2) THEN
         RNORM=P2(1)+P2(2)*BTGM+P2(3)*BTGM**2
      ELSEIF (BTGM.LT.CUT3) THEN
         RNORM=P3(1)+P3(2)*BTGM+P3(3)*BTGM**2
      ELSEIF (BTGM.LT.CUT4) THEN
         RNORM=P4(1)+P4(2)*BTGM+P4(3)*BTGM**2
      ELSEIF (BTGM.LT.CUT5) THEN
         RNORM=P5(1)+P5(2)*BTGM+P5(3)*BTGM**2
      ELSE
         RNORM=P6(1)+P6(2)*BTGM+P6(3)*BTGM**2
      ENDIF
      SMRNGE=MAX(0.0,RNORM)*M

      RETURN
      END
