      SUBROUTINE UDRAW
*.
*...UDRAW   Initialize Drawing Package
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : HIGZPA GEFILE
*. CALLS     : HPLINT IGINIT IGSSE  GDINIT IGMETA 
*.           : GSATT  GDSPEC IRQST  ICLRWK GDRAWC GDAXIS GDTREE 
*.           : GDOPEN GDSCAL GDCLOS
*. CALLED    : UGINIT
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 12-Apr-1995
*. LAST MOD  : 11-May-1995
*.
*. MODIFICATION LOG
*. 16-May-1995 Y.Fujii,    Change metafile LUN 8=> LUNMJM(IDFILE).
*.                       Give initial values to STR.
*. 11-May-1995 Nakamura.I ,Replace DYALLC with JUALLC
*.
*.**********************************************************************
      IMPLICIT NONE

#include "jmfile.inc"
#include "higzpa.inc"

      CHARACTER*100 STR/'Hit return'/

      INTEGER LUNPS,LUN
      INTEGER ISTAT,L


*--   Initialize drawing routines(IGKTRM=72 for Tek4013,=1 for XWindow)
      IF (LUNMJM(IFILPS).GT.0) THEN
         LUNPS = LUNMJM(IFILPS)
      ELSE
         LUNPS = 0
      ENDIF

C      WRITE(6,*) 'ps file assigned to LUN=',LUNMJM(IFILPS),
C     &           '  NAME=',FNAMJM(IFILPS)

*--   Initialize HIGZ
      CALL HPLINT(4)
C     CALL IGINIT(0)

*--   Initialize the standard graphic package environment. (HIGZ)
C     IGKTRM=1
C     CALL IGSSE(6,IGKTRM)

*--   Initialize the GEANT drawing package
      CALL GDINIT

*--   Graphic output is screen and metafile
      LUN= LUNPS*IGPRNT
      CALL IGMETA(LUN,-111)

*--   Change the attribute of the volume called NAME to the value
*--   all volume set to seen
      CALL GSATT('MAST','SEEN',0)
      CALL GSATT('*   ','COLO',1)

*--   Draw a picture showing all specifications for a given volume.
      CALL GDSPEC('MAST')
      CALL IRQST(1, 1, ISTAT, L, STR)
      CALL ICLRWK(0,0)
*-- projection on x-z plane at IP
      CALL GDRAWC('MAST',2,0.0,10.0,10.0,0.03,0.3)
      CALL IRQST(1, 1, ISTAT, L, STR)
      CALL ICLRWK(0,0)
*-- projection on x-y plane in front of QC1
      CALL GDRAWC('MAST',3,200.5,10.0,10.0,1.0,1.0)
      CALL IRQST(1, 1, ISTAT, L, STR)
      CALL ICLRWK(0,0)
C
C     Output for geometry check
C      CALL GDRAWC('MAST',3,750.0,10.0,10.0,0.5,0.5)
C      CALL IRQST(1, 1, ISTAT, L, STR)
C      CALL ICLRWK(0,0)
C      CALL GDRAWC('MAST',2,0.0,10.0,10.0,0.009,0.3)
C      CALL IRQST(1, 1, ISTAT, L, STR)
C      CALL ICLRWK(0,0)
C      CALL GDRAWC('MAST',2,0.0,10.0,10.0,0.03,0.3)
C      CALL IRQST(1, 1, ISTAT, L, STR)
C      CALL ICLRWK(0,0)
C      CALL GDRAWC('BCP ',2, 0., 10.0, 10.0, 0.02, 0.02)
C      CALL GDAXIS(0.,0.,-200.,100.)
C      CALL IRQST(1, 1, ISTAT, L, STR)
C      CALL ICLRWK(0,0)
*
*--   Draw the tree of the volume data structure.
*
C      CALL GDTREE('MAST',0,101111)
C      CALL IRQST(1, 1, ISTAT, L, STR)
C      CALL ICLRWK(0,0)
*--   Open a view bank, used to store 2D graphics information coming
*--   from the interpretation of 3D structures.
      CALL GDOPEN(1)

*--   Draw a cut view of the volume with all its visible descandants,
*--   i.e. draws their intersection with the cut palne.

      CALL GDRAWC('MAST',IAX,GDCNTR,
     &     GDUV0(1),GDUV0(2),GDSUV(1),GDSUV(2))

*--   Draws a scale corresponding to the current viewing parameters.
      CALL GDSCAL(1.0, 1.0)

*--   Closes the current opened view bank.
      CALL GDCLOS
 999  CONTINUE
      
      RETURN
      END
