      SUBROUTINE UGEOM
*.
*...UGEOM    GEANT3 user routine
*.           Define the detector geometry and tracking media.
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : none
*. CALLS     : JMMATE GSVOLU HBGEOM EBGEOM CTGEOM VXGEOM HEGEOM EEGEOM
*.             GGCLOS  JMTMED
*. CALLED    : UGINIT
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 11-Mar-1994
*. LAST MOD  : 27-Jul-1994
*.
*. MODIFICATION LOG
*. 11-Jan-1999, Y.Fujii, Added BMGEOM and LMGEOM, which were made 
*.              by Tauchi-san.
*. 28-Aug-1996, Y.Fujii,  Redefined rotation matrix numbers in ct,bc,ec,mu.
*.                      Now definition is as follows.
*.                      vx=3xxx, bc=5xxx,ec=6xxx,mu=7xxx,IR=8xxx,ct>10000  
*. 12-May-1995, Y.Fujii,  Add mugeom
*. 28-Jul-1994, N.HOSODA, Add IOPTIM flag
*.
*.**********************************************************************
      IMPLICIT NONE

*-- Common for GEANT
#include "geant321/gcopti.inc"
#include "geant321/gcflag.inc"


*-- Set geometry optimization flag
*-- 2=all volumes are ordered along the best axis.
      IOPTIM=2 

*-- Define all material
      CALL JMMATE
      
*-- Define all tracking media
      CALL JMTMED
      
*-- Define rotation matrices
      CALL JMROTM
      
*-- Define a volume with a given name, shape, tracking medium number 
*-- and shape parameters

*-- Master volume
      CALL JMGEOM

*-- IR region
      CALL IRGEOM

*-- Sorenoid Region
      CALL SOGEOM

*-- MU: Muon chambers
      CALL MUGEOM

*-- Barrel Calorimeter
      CALL BCGEOM

*-- Endcap Calorimeter
      CALL ECGEOM

*-- CT: central tracker
      CALL CTGEOM

*-- VX: micro-vertex counter
      CALL VXGEOM

*-- BM: Beam profile monitor
      CALL BMGEOM

*-- LM: Luminosity monitor
      CALL LMGEOM

*-- IT: Intermediate Tracker
      CALL ITGEOM

*-- Close geometry bank
      CALL GGCLOS

      RETURN
      END
