      SUBROUTINE UGINIT
*.
*...UGINIT   GEANT3 user routine
*.           Initialize GEANT program and read data cards
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCFLAG GEFILE
*. CALLS     : GINIT  GZINIT GPART  GMATE  UGEOM  GPHYSI
*.           : GPMATE GPTMED GPVOLU GPPART HBOOK1 HIDOPT  
*.           : IGINIT IGSSE  GDINIT GSATT  GDSPEC GDOPEN GDRAWC
*.           : GDSCAL GDCLOS FFKEY  IGMETA IRQST  ICLRWK GDTREE
*.           : JMFFRD JGFFRD VXFFRD CTFFRD BCFFRD ECFFRD
*.           : JUALLC KZFILE JMSAVP
*. CALLED    : MAIN
*.
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 10-Mar-1994
*. LAST MOD  : 11-May-1995
*.
*. MODIFICATION LOG
*. 11-Jan-1999 Y.Fujii,    Added BMFFRD, LMFFRD, FFINIT.
*. 11-May-1995 Y.Fujii,    Add vxinit
*. 11-May-1995 Nakamura.I ,Replace DYALLC with JUALLC
*.  4-Aug-1994 Nakamura Isamu add JSTPAR 
*. 18-May-1994             replace geant common by INCLUDE
*. 24-May-1994 N.HOSODA    Add FFRD* subroutine & HIGZPA common
*. 25-May-1994 N.HOSODA    Add FFRDBC,FFRDEC,FFRCCT
*. 26-May-1994 N.HOSODA    Rename FFRD* to *FFRD
*. 28-Jun-1994 N.Hosoda,    Use not OPEN but DYALLC & Add ZBS initialise
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Common for GEANT
#include "geant321/gcflag.inc"

#include "gcbank.inc"
#include "pawc.inc"

*--   Common for user
#include "jmcntl.inc"
#include "jmfile.inc"
#include "jmtime.inc"
      
      INTEGER IFORM
      PARAMETER (IFORM=1)
      INTEGER IERR
      INTEGER LNBLNK
      
      
      LUSIJM = 5
      LUSOJM = 6
      LUERJM = 6

*--   Initializes dynamic memory for GEANT
      CALL GZEBRA(NGBANK)

*--   Initialize ZBS (bank system)
      CALL KZOPTN('NO-ZEBRA-INIT')
      CALL KZINIT

*--   Initializes dynamic memory for HBOOK
      CALL HLIMIT(-NHBOOK)

*--   Initialize the GEANT parameters
      CALL GINIT

*--   Initialize JIM specific parameters
      CALL JMINIT

*--   Initialization of ZABRA core divisions and link areas
      CALL GZINIT

*--   Creation of the particle data structure JPART
      CALL GPART

*--   Creation of the material data structure JMATE
      CALL GMATE

*--   Geometry and material description by user
      CALL UGEOM

*--   Preparation of cross-section and energy-loss tables for all 
*--   materials
      CALL GPHYSI

      IF (LUNMJM(IFILFO).GT.0) THEN
         
*--   Define file for data I/O
         CALL KZOPEN(LUNMJM(IFILFO),
     &        FNAMJM(IFILFO)(:LNBLNK(FNAMJM(IFILFO))),
     &        IERR)
         IF (IERR.NE.0) THEN
            CALL MSGOUT('UGINIT','File allocation error',IERR)
            STOP
         ENDIF

*--   Store Parameter Event into ZBS Bank
         CALL JMSAVP

      ENDIF

*--   For debug
      IF (ISWIT(3).GE.1) THEN

*--     Print the material constants
        CALL GPMATE(0)

*--     Print the tracking medium parameter
        CALL GPTMED(0)

*--     Print the volume parameters
        CALL GPVOLU(0)

*--     Print Rotation Matrix
        CALL GPROTM(0)

*--     Print the particle constants
        CALL GPPART(0)
      ENDIF

*--   Initialize drawing routines if used.
      IF (ISWIT(4).GE.1)  CALL UDRAW

      CALL JMHBK
C      CALL VXHBK
C      CALL CTHBK

*--   Set time = 0sec.
*--   Moved here to measure time to proces one event correctly
      CALL TIMED(T0JM)
      
      RETURN
      END
