      SUBROUTINE VXHITS
*.
*...VXHITS   Store HITS for the silicon vertex detector
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCSETS GCKINE GCTRAK
*. CALLS     : GSCHIT
*. CALLED    : GUSTEP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 19-Apr-1994
*. LAST MOD  : 27-Jul-1994
*.
*. MODIFICATION LOG
*. 15-Oct-1999 J.Kanzaki
*.             handle longer size of VXHIT banks which includes
*.             extensions below
*. 10-Feb-1997 T.Tauchi; add parameters of origin;IPAOLD,VERT(3),PVERT(3).
*. 28-Jan-1997 T.Tauchi; add Px,Py,Pz in hits.
*. 27-Aug-1996 Y.Fujii ; executed GSAHIT only when INWVOL=2.
*.                     Now execute GSCHIT regardless INWVOL.
*. 11-May-1995 Y.Fujii
*. 27-Jul-1994 N.HOSODA
*. 18-May-1994 replace geant common by INCLUDE
*.
*.**********************************************************************
*
*--   HITS(1): Particle code
*--   HITS(2): X position
*--   HITS(3): Y position
*--   HITS(4): X position
*--   HITS(5): Momentum of the particle
*--
*--   If "BSIZ 1" for short MCVXHIT bank,
*--   HITS(6): Deposited energy
*--
*--   If "BSIZ 2" for long MCVXHIT bank,
**** note required by GSCHIT
*--   HITS(16): Deposited energy
*--   HITS(6): Px of the particles
*--   HITS(7): Py of the particles
*--   HITS(8): Pz of the particles
*--   HITS(9): Particle code of previous track
*--   HITS(10): VERT(1) of current track
*--   HITS(11): VERT(2) of current track
*--   HITS(12): VERT(3) of current track
*--   HITS(13): PVERT(1) of current track
*--   HITS(14): PVERT(2) of current track
*--   HITS(15): PVERT(3) of current track

      IMPLICIT NONE

*--   Common for GEANT
#include "geant321/gcsets.inc"
#include "geant321/gckine.inc"
#include "geant321/gctrak.inc"
#include "geant321/gctmed.inc"
#include "geant321/gcvolu.inc"

#include "jmdet.inc"
#include "vxgeo.inc"
#include "vxsim.inc"
#include "vxhit.inc"

      REAL HITS(NPHTVX)

      INTEGER IHIT


      IF (ISIMJD(IDETVX).EQ.ISKPJD) RETURN

*--   When track is exiting current volume, do this routine
CCC      IF (INWVOL.NE.2) GOTO 999
      IF (DESTEP.LE.0.) RETURN

c      print *,'vxhits;set,det = ',cuset,cudet
c      print *,'      ;itra,istak,ipart,nstep   = ',itra,istak,ipart
c     &     ,nstep
c      print *,'      ;vect(1-3) = ',vect(1),vect(2),vect(3)
c      print *,'      ;getot,vect(7),tofg = ',getot,vect(7),tofg
      HITS(1)=IPART
      HITS(2)=VECT(1)
      HITS(3)=VECT(2)
      HITS(4)=VECT(3)
      HITS(5)=VECT(7)

      IF (IBNKVX.EQ.ISBKVX) THEN

         HITS(6)=DESTEP*1.E6

      ELSEIF (IBNKVX.EQ.ILBKVX) THEN

         HITS(16)=DESTEP*1.E6

C--add
         HITS(6)=VECT(7)*VECT(4)
         HITS(7)=VECT(7)*VECT(5)
         HITS(8)=VECT(7)*VECT(6)
C-- add informations of origin of current track
         HITS( 9)=IPAOLD
         HITS(10)=VERT(1)
         HITS(11)=VERT(2)
         HITS(12)=VERT(3)
         HITS(13)=PVERT(1)
         HITS(14)=PVERT(2)
         HITS(15)=PVERT(3)

      ENDIF

      CALL GSCHIT(ISET,IDET,ITRA,NUMBV,HITS,1,IHIT)

  999 CONTINUE
      RETURN
      END
