      SUBROUTINE JLGBCP(ICODE)

      IMPLICIT NONE

#include "buffer.inc"
#include "bcgeo.inc"
#include "calpos.inc"

      INTEGER ICODE,I,IT,IP,ISTART
      
      INTEGER ISEG,NDT

      REAL XE(2,THHDBC),YE(2,THHDBC),ZE(2,THHDBC)
      REAL XH(THHDBC)  ,YH(THHDBC)  ,ZH(THHDBC)
      REAL VPOS(6),DRDIST,DTHETA,ERAW,COST,ECOR(4)
      REAL PI,TWOPI
      PARAMETER (PI=3.14159265358979323846, TWOPI=PI*2)

      INTEGER LBANK

      CALL KZEFST

      ICODE = 0
      
      CALL KZBLOC('MCBCPAR',LBANK)
      IF (LBANK.LE.0) THEN
         CALL MSGOUT('JLGBCP','MCBCPAR does not exist',LBANK)
         ICODE = 1
         RETURN
      ENDIF
      
* Get informations from the JIM bank

      CALL KZGET('MCBCPAR',0, NBUFF, IBUFF )

      SWITBC(1) = IBUFF(1)
      NDTHBC = IBUFF(2)
      NDPHBC = IBUFF(3)
      ZLBC = RBUFF(4)
      ZIBC = RBUFF(5)
      TSCEBC = RBUFF(6)
      TSCHBC = RBUFF(7)
      BLBC = RBUFF(8)
      BSBC = RBUFF(9)
      DEMBC = RBUFF(10)
      TLGBC = RBUFF(11)
      PTLTBC = RBUFF(12)
      RINBC = RBUFF(13)

      CALL KZGET('MCBCPAR', 1, NDT, XE )
      CALL KZGET('MCBCPAR', 2, NDT, YE )

      ISEG = 0
      DO 50 I=1,NDTHBC
         ISEG = ISEG +2
         GPE1BC(ISEG-1) = XE(1,I)
         GPE1BC(ISEG)   = XE(2,I)
         GPE2BC(ISEG-1) = YE(1,I)
         GPE2BC(ISEG)   = YE(2,I)
 50   CONTINUE

      CALL KZGET('MCBCPAR', 3, NDT, ZE )
      ISEG = 0
      DO 60 I=1,NDTHBC
         ISEG = ISEG +2
         GPE3BC(ISEG-1) = ZE(1,I)
         GPE3BC(ISEG)   = ZE(2,I)
 60   CONTINUE
      
      CALL KZGET('MCBCPAR', 4, NDT, XH )
      CALL KZGET('MCBCPAR', 5, NDT, YH )

      ISEG = 0
      DO 65 I=1,NDTHBC
         ISEG = ISEG + 1
         GPH1BC(ISEG)   = XH(I)
         GPH2BC(ISEG)   = YH(I)
 65   CONTINUE
      
      CALL KZGET('MCBCPAR', 6, NDT, ZH )
      ISEG = 0
      DO 70 I=1,NDTHBC
         ISEG = ISEG + 1
         GPH3BC(ISEG)   = ZH(I)
 70   CONTINUE
            
* Calculation of CELL position and calibration factor

* Init.
      CALL VZERO(BCEPOS,6*NBETHE*NBEPHI)
      CALL VZERO(BCHPOS,6*NBHTHE*NBHPHI)
      CALL VZERO(BEFACT,4*NBETHE)
      CALL VZERO(BHFACT,4*NBHTHE)
      
* BE
      DO 101 IT=1,NBETHE
         IF(IT.GE.1.AND.IT.LE.2*NDTHBC) THEN
            VPOS(4) = GPE3BC(IT)
            VPOS(5) = GPE2BC(IT)
            VPOS(3) = VPOS(4)*COS(VPOS(5))
            ISTART = IT
        
* SMEAR extra block (overlap region)
      
         ELSEIF(IT.GE.81.AND.IT.LE.90) THEN
            DRDIST=ABS(GPE2BC(1)-GPE2BC(2))
            DTHETA=ABS(GPE3BC(1)-GPE3BC(2))
            VPOS(4) = GPE3BC(1)+(IT-80)*DRDIST
            VPOS(5) = GPE2BC(1)-(IT-80)*DTHETA            
            VPOS(3) = VPOS(4)*COS(VPOS(5))                     
            ISTART = 1
         ELSEIF(IT.GE.91.AND.IT.LE.100) THEN
            DRDIST=ABS(GPE2BC(69)-GPE2BC(70))
            DTHETA=ABS(GPE3BC(69)-GPE3BC(70))
            VPOS(4) = GPE3BC(70)+(IT-90)*DRDIST
            VPOS(5) = GPE2BC(70)+(IT-90)*DTHETA            
            VPOS(3) = VPOS(4)*COS(VPOS(5))
            ISTART = 70
         ELSE
            GOTO 101
         ENDIF            

* defined calibration factor
      
         ERAW=1.0
         COST=COS(VPOS(5))
         CALL CALIB(COST,ERAW,ECOR)
         BEFACT(1,IT)=ECOR(1)
         BEFACT(2,IT)=ECOR(2)
         BEFACT(3,IT)=ECOR(3)
         BEFACT(4,IT)=ECOR(4)
        
* PHI loop
      
         DO 102 IP=1,NBEPHI
            IF(IP.GE.1.AND.IP.LE.2*NDPHBC) THEN
               VPOS(6) = GPE1BC(ISTART)+PI/NDPHBC*(IP-1)
               VPOS(1) = VPOS(4)*SIN(VPOS(5))*COS(VPOS(6))
               VPOS(2) = VPOS(4)*SIN(VPOS(5))*SIN(VPOS(6))
               BCEPOS(1,IT,IP) = VPOS(1)
               BCEPOS(2,IT,IP) = VPOS(2)
               BCEPOS(3,IT,IP) = VPOS(3)
               BCEPOS(4,IT,IP) = VPOS(4)
               BCEPOS(5,IT,IP) = VPOS(5)
               BCEPOS(6,IT,IP) = ATAN2(VPOS(2),VPOS(1))               
            ENDIF
 102     CONTINUE
 101  CONTINUE
      
* BH
      DO 111 IT=1,NBHTHE
         IF(IT.GE.1.AND.IT.LE.NDTHBC) THEN
            VPOS(4) = GPH3BC(IT)
            VPOS(5) = GPH2BC(IT)
            VPOS(3) = VPOS(4)*COS(VPOS(5))
            ISTART = IT
        
* SMEAR extra block (overlap region)
         ELSEIF(IT.GE.41.AND.IT.LE.45) THEN
            DRDIST=ABS(GPH2BC(1)-GPH2BC(2))
            DTHETA=ABS(GPH3BC(1)-GPH3BC(2))
            VPOS(4) = GPH3BC(1)+(IT-40)*DRDIST
            VPOS(5) = GPH2BC(1)-(IT-40)*DTHETA            
            VPOS(3) = VPOS(4)*COS(VPOS(5))            
            ISTART = 1
         ELSEIF(IT.GE.46.AND.IT.LE.50) THEN
            DRDIST=ABS(GPH2BC(34)-GPH2BC(35))
            DTHETA=ABS(GPH3BC(34)-GPH3BC(35))
            VPOS(4) = GPH3BC(35)+(IT-45)*DRDIST
            VPOS(5) = GPH2BC(35)+(IT-45)*DTHETA            
            VPOS(3) = VPOS(4)*COS(VPOS(5))            
            ISTART = 35
         ELSE
            GOTO 111
         ENDIF            

* defined calibration factor
      
         ERAW=1.0
         COST=COS(VPOS(5))
         CALL CALIB(COST,ERAW,ECOR)
         BHFACT(1,IT)=ECOR(1)
         BHFACT(2,IT)=ECOR(2)
         BHFACT(3,IT)=ECOR(3)
         BHFACT(4,IT)=ECOR(4)
     
* PHI loop
      
         DO 112 IP=1,NBHPHI      
            IF(IP.GE.1.AND.IP.LE.NDPHBC) THEN
               VPOS(6) = GPH1BC(ISTART)+TWOPI/NDPHBC*(IP-1)
               VPOS(1) = VPOS(4)*SIN(VPOS(5))*COS(VPOS(6))
               VPOS(2) = VPOS(4)*SIN(VPOS(5))*SIN(VPOS(6))
               BCHPOS(1,IT,IP) = VPOS(1)
               BCHPOS(2,IT,IP) = VPOS(2)
               BCHPOS(3,IT,IP) = VPOS(3)
               BCHPOS(4,IT,IP) = VPOS(4)
               BCHPOS(5,IT,IP) = VPOS(5)
               BCHPOS(6,IT,IP) = ATAN2(VPOS(2),VPOS(1))
            ENDIF
 112     CONTINUE
 111  CONTINUE

      RETURN
      END
