************************************************************************
*     --------------------------
      SUBROUTINE LUCTAU(KF,CTAU)
*     --------------------------
*
*      (Purpose)
*         Returns c*tau for a given particles with PDG code of KF
*         for JETSET74
*
*      (Input)
*         KF    : Particle code in the PDG format
*
*      (Output)
*         CTAU       : c*tau for a given particle
*              = -2. : illegal particle code
*              = -1. : the particle is stable
*
*      (Creation Date)
*         Jul. 15, 1994 : First version created by J. Kanzaki
*
************************************************************************
      IMPLICIT NONE

#include "jetset.inc"
      
      INTEGER KF
      REAL CTAU
      
      INTEGER KC
      INTEGER IDC0,NDC,NDCAY,IDC

      INTEGER LUCOMP

      EXTERNAL LUDATA


      KC = LUCOMP(KF)

      IDC0 = MDCY(KC,2)
      NDC = MDCY(KC,3)

      NDCAY = 0
      DO 10 IDC=IDC0,IDC0+NDC-1
      IF(BRAT(IDC).GT.0.) NDCAY = NDCAY + 1
   10 CONTINUE

      IF(KC.LE.0) THEN

         CTAU = -2.

      ELSE IF(NDCAY.EQ.0) THEN

         CTAU = -1.

      ELSE

         CTAU = 0.1*PMAS(KC,4)

      END IF

      RETURN
      END
