C   12/10/84 608201345  MEMBER NAME  RNORM    (S)        M  FORTRAN
      SUBROUTINE RNORM(RVEC,LEN)
C     FUNCTION RNORM(DUMMY)
C
C     GENERATES RANDOM NUMBERS ACCORDING TO THE STANDARD NORMAL
C     DISTRIBUTION ( MEAN = 0 AND SIGMA = 1 )
C
C     AS FOR THE ALGORITHM USED IN THIS GENERATOR,
C     PLEASE REFER TO
C         J.H.AHRENS AND U.DIETER, COMM. ACM 15(1972)873.
C
C     CALLING SEQUENCE IS ...
C         RN = RNORM(DUM)
C     THEN VARIABLE "RN" OBEYS THE STANDARD NORMAL DISTRIBUTION.
C
C     USED PSEUDO UNIFORM RANDOM NUMBER GENERATOR IS
C         RNDM(DUM)
C     FROM CERNLIB AND IS INCLUDE IN
C         'TPPV.VENUS.KEKLIB.L'
C
C                                      84.10.16   J. KANZAKI
C
C-----------------------------------------------------------------------
C
C     Modified to GEANT use            99.03.03   J.Kanzaki
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

      REAL RVEC(*)
      INTEGER LEN

      REAL RVEC1(2),U,U0
      REAL RNORM0
      
      REAL Y,R,R0

      INTEGER I


      DO 100 I=1,LEN

         CALL RANMAR(RVEC1,2)

         U = RVEC1(1)
         U0 = RVEC1(2)

         IF (U.LT.0.9195444) THEN
            
            RNORM0=2.403758*(U0+0.8253393*U)-2.114028
            
         ELSE
            
            IF (U.GT.0.9654871) THEN
               
CCC30 Y=SQRT(4.469115-2.*ALOG(RNDM(DUM)))
 30            CONTINUE 
               CALL RANMAR(RVEC1,2)
               R0 = RVEC1(1)
               R  = RVEC1(2)
               IF (R0.EQ.0.) GO TO 30
               Y = SQRT(4.469115-2.*ALOG(R0))
               IF (Y*R.GT.2.114028) GO TO 30
               GO TO 90
               
            ELSE IF (U.GT.0.9499907) THEN
               
 50            CONTINUE 
               CALL RANMAR(RVEC1,2)
               R0 = RVEC1(1)
               R  = RVEC1(2)
               Y=1.840399+0.2736293*R0
               IF (0.3989423*EXP(-0.5*Y**2)-0.4432991+0.2096941*Y
     &              .LT. 0.0427026*R) GO TO 50
               GO TO 90
               
            ELSE IF (U.GT.0.9258523) THEN
               
 70            CONTINUE 
               CALL RANMAR(RVEC1,2)
               R0 = RVEC1(1)
               R  = RVEC1(2)
               Y=0.2897296+1.550669*R0
               IF (0.3989423*EXP(-0.5*Y**2)-0.4432991+0.2096941*Y
     &              .LT. 0.01597452*R) GO TO 70
               
               GO TO 90
               
            ELSE
               
 80            CONTINUE 
               CALL RANMAR(RVEC1,2)
               R0 = RVEC1(1)
               R  = RVEC1(2)
               Y=0.2897296*R0
               IF (0.3989423*EXP(-0.5*Y**2)-0.3825456
     &              .LT. 0.01639772*R) GO TO 80
               
            END IF
            
 90         CONTINUE 

            RNORM0 = Y
            IF (U0.GT.0.5) RNORM0 = -RNORM0
            
         ENDIF
         
         RVEC(I) = RNORM0
         
 100  CONTINUE 
      
      RETURN
      END
