      SUBROUTINE SWATCH(CKEY,CFUN,TIME1,TIME2)
*.
*...SWATCH emulate 50 stopwatches
*.
*.    CKEY*6:  Timer Name (50 timers can be allocated )
*.    CFUN*6:  Function Name 
*.              'INIT'    Initialize package (need onece)
*.              'START'   Start timer
*.              'STOP'    Stop timer
*.              'RESET'   Reset timer
*.              'SET'     Set(create) timer 
*.              'DUMP     Dump timer status
*.              'REPORT'  Report time consumption '*' means all
*.    TIME1:   Total Elapsed Time ('START','STOP','LAP')
*.    TIME2:   LAP time ('LAP')
*.
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input arguments
      CHARACTER*(*) CKEY,CFUN
      REAL TIME1,TIME2
*
*--
      CHARACTER*6 KEY,FUN
      INTEGER IKEY
*
*-- for error message
      CHARACTER*80 CMSG
      INTEGER LNBLNK            ! cernlib function M432
*
*-- copy input 
      KEY = CKEY
      FUN = CFUN
*
*-- Initialization
      TIME1 = 0.
      TIME2 = 0.
*
*-- Package Initialization
      IF (FUN(1:4).EQ.'INIT') THEN 
         NSWKEY = 0
         WRITE(*,*)
         WRITE(*,*) 'StopWatch is Initialized'
         WRITE(*,*)
*
*-- Set a timer
      ELSE IF (FUN(1:3).EQ.'SET') THEN
*
*-- check wheather KEY is exist or not
         CALL SWFIND(KEY,IKEY)
         IF (IKEY.NE.0) THEN    ! KEY is there 
*-- reset the KEY            
            CALL SWRSET(IKEY)
         ELSE                   ! KEY is not there, create
*-- create KEY
            CALL SWNEW(KEY,IKEY)
         ENDIF
*
*-- Start Timer
      ELSE IF (FUN(1:3).EQ.'STA') THEN
*
*-- find KEY
         CALL SWFIND(KEY,IKEY)
         IF (IKEY.EQ.0) THEN    ! KEY is not there, create
            CALL SWNEW(KEY,IKEY)
            IF (IKEY.LE.0) THEN
               WRITE(CMSG,'(''Cannot Create Key'',A6)') KEY
               CALL MSGOUT('SWATCH',CMSG(:LNBLNK(CMSG)),1)
               RETURN 
            ENDIF
         ENDIF 
*-- start timer
         CALL SWSTRT(IKEY,TIME1)
*
*-- STOP timer
      ELSE IF (FUN(1:3).EQ.'STO') THEN
*
*-- find KEY
         CALL SWFIND(KEY,IKEY)
         IF (IKEY.EQ.0) THEN
            WRITE(CMSG,'(''Cannot find Key'',A6)') KEY
            CALL MSGOUT('SWATCH',CMSG(:LNBLNK(CMSG)),2)
            RETURN 
         ENDIF
*--
         CALL SWSTOP(IKEY,TIME1)
*
*-- LAP timer
      ELSE IF (FUN(1:3).EQ.'LAP') THEN
*
*-- find KEY
         CALL SWFIND(KEY,IKEY)
         IF (IKEY.EQ.0) THEN
            WRITE(CMSG,'(''Cannot find Key'',A6)') KEY
            CALL MSGOUT('SWATCH',CMSG(:LNBLNK(CMSG)),3)
            RETURN 
         ENDIF
*--
         CALL SWLAP(IKEY,TIME1,TIME2)
*
*-- reset Timer
      ELSE IF (FUN(1:3).EQ.'RES') THEN
*
*-- check wheather KEY is exist or not
         CALL SWFIND(KEY,IKEY)
         IF (IKEY.NE.0) THEN    ! KEY is there 
*-- reset the KEY            
            CALL SWRSET(IKEY)
         ELSE
            WRITE(CMSG,'(''Cannot find Key'',A6)') KEY
            CALL MSGOUT('SWATCH',CMSG(:LNBLNK(CMSG)),4)
            RETURN 
         ENDIF
*
*-- dump timer
      ELSE IF (FUN(1:3).EQ.'DUM') THEN
*
*-- find KEY
         IF (KEY(1:1).EQ.'*') THEN
            CALL SWDMP(0)
         ELSE
            CALL SWFIND(KEY,IKEY)
            IF (IKEY.GT.0) CALL SWDMP(IKEY)
         ENDIF
*
*-- report timer
      ELSE IF (FUN(1:3).EQ.'REP') THEN
         IF (KEY(1:1).EQ.'*') THEN
            CALL SWREP(0)
         ELSE
            CALL SWFIND(KEY,IKEY)
            IF (IKEY.GT.0) CALL SWREP(IKEY)
         ENDIF
      ENDIF
*      
      RETURN 
      END
*
      SUBROUTINE SWFIND(CKEY,IKEY)
*.
*... SWFIND return position of KEY 
*.
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      CHARACTER*6 CKEY
      INTEGER IKEY
*
*--
      INTEGER I
*
*-- Initialization
      IKEY = 0
*
*-- Loop over KEYS
      DO 10 I=1,NSWKEY
         IF (CSWKEY(I).EQ.CKEY) THEN
            IKEY = I
            RETURN 
         ENDIF
 10   CONTINUE 
*
      RETURN 
      END
*
      SUBROUTINE SWSET(IKEY)
*.
*... SWSET reset IKEY
*.
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      INTEGER IKEY
*
*-- for error message
      CHARACTER*80 CMSG
      INTEGER LNBLNK            ! cernlib function M432
*
*-- check the KEY is there or not
      IF (IKEY.LE.0.OR.IKEY.GT.NSWKEY) THEN
         WRITE(CMSG,'(''Cannot find Key'',A6)') IKEY
         CALL MSGOUT('SWSET ',CMSG(:LNBLNK(CMSG)),1)
         RETURN 
      ENDIF
*
*-- reset the KEY
      SSWKEY(IKEY) = .FALSE.    ! timer not working
*
*-- done
      RETURN 
      END
*
      SUBROUTINE SWNEW(CKEY,IKEY)
*.
*... SWNEW set new KEY
*.
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      CHARACTER*6 CKEY
      INTEGER IKEY
*
*--
      INTEGER IKY
*
*-- for error message
      CHARACTER*80 CMSG
      INTEGER LNBLNK            ! cernlib function M432
*
*-- Initialization
      IKEY = 0
*
*-- check KEY is exist or not
      CALL SWFIND(CKEY,IKY)
      IF (IKY.NE.0) THEN
         WRITE(CMSG,'(''Key already exist'',A6)') CKEY
         CALL MSGOUT('SWNEW ',CMSG(:LNBLNK(CMSG)),1)
         IKEY = IKY
         RETURN 
      ENDIF
*
*-- check buffer is full or not
      IF (NSWKEY.GE.MXKEY) THEN
         CMSG =  'KEY buffer full'
         CALL MSGOUT('SWNEW ',CMSG(:LNBLNK(CMSG)),2)
         IKEY = -1
         RETURN 
      ENDIF
*-- create new KEY
      NSWKEY = NSWKEY + 1
*
*-- KEY number
      IKEY = NSWKEY
*
*-- KEY name
      CSWKEY(IKEY) = CKEY
*
*-- stopwatch is down
      SSWKEY(IKEY) = .FALSE. 
*
*-- stopwatch is NEW
      FSWKEY(IKEY) = .TRUE. 
*
*-- message
      WRITE(CMSG,'(''Timer '',A6,'' created'')') CKEY
      CALL MSGOUT('SWNEW ',CMSG(:LNBLNK(CMSG)),0)
*
*-- done
      RETURN 
      END
*
      SUBROUTINE SWSTRT(IKEY,STIME)
*.      
*... SWSTRT start stopwatch
*.      
*.    IKEY :  KEY number
*.    STIME:  Start Time
*.      
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      INTEGER IKEY
      REAL STIME
*
*--
      REAL TNOW,OFFSET
*
*-- for error message
      CHARACTER*80 CMSG
      INTEGER LNBLNK            ! cernlib function M432
*
*-- Initialization
      STIME = 0.
*
*-- check the KEY is there or not
      IF (IKEY.LE.0.OR.IKEY.GT.NSWKEY) THEN
         WRITE(CMSG,'(''Cannot find KEY '',I3)') IKEY
         CALL MSGOUT('SWSTRT',CMSG(:LNBLNK(CMSG)),1)
         RETURN 
      ENDIF
*
*-- case first time
      IF (FSWKEY(IKEY).AND.(.NOT.SSWKEY(IKEY))) THEN
*
*-- what time is it now?
         CALL TIMEX(TNOW)
*-- set T0 of the stopwatch         
         RSWKEY(1,IKEY) = TNOW
*-- set time for LAP timer
         RSWKEY(2,IKEY) = TNOW
*-- set time for T0 calculation
         RSWKEY(3,IKEY) = -1.
*-- unset first time bit        
         FSWKEY(IKEY) = .FALSE. 
*-- timer is up
         SSWKEY(IKEY) = .TRUE. 
*-- reset counter
         ISWKEY(1,IKEY) = 1
         ISWKEY(2,IKEY) = 0
*-- return value
         STIME = 0.
*
*-- case stopwatch is up
      ELSE IF ((.NOT.FSWKEY(IKEY)).AND.SSWKEY(IKEY)) THEN
*-- do nothing         
         RETURN 
*
*-- case stopwatch is down
      ELSE IF ((.NOT.FSWKEY(IKEY)).AND.(.NOT.SSWKEY(IKEY))) THEN
*
*-- what time is it now?
         CALL TIMEX(TNOW)
*--
         IF (RSWKEY(3,IKEY).LE.0.) THEN
            CMSG = 'Funny .....'
            CALL MSGOUT('SWSTRT',CMSG(:LNBLNK(CMSG)),2)
         ENDIF
*
*-- calculate offset
         OFFSET = TNOW - RSWKEY(3,IKEY)
*
*-- advance T0 and LAP timer
         RSWKEY(1,IKEY) = RSWKEY(1,IKEY) + OFFSET
         RSWKEY(2,IKEY) = RSWKEY(2,IKEY) + OFFSET
*
*- increment counter
         ISWKEY(1,IKEY) = ISWKEY(1,IKEY) + 1
*
*-- set stopwatch is up
         SSWKEY(IKEY) = .TRUE. 
*
         STIME = TNOW - RSWKEY(1,IKEY) 
*
      ELSE
         CMSG = 'Logical Error.....'
         CALL MSGOUT('SWSTRT',CMSG(:LNBLNK(CMSG)),3)
         RETURN 
      ENDIF 
*-- done
      RETURN 
      END
*
      SUBROUTINE SWSTOP(IKEY,STIME)
*.      
*... SWSTOP stop stopwatch
*.      
*.    IKEY :  KEY number
*.    STIME:  STOP time
*.      
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      INTEGER IKEY
      REAL STIME
*
*-- 
      REAL TNOW
*
*-- for error message
      CHARACTER*80 CMSG
      INTEGER LNBLNK            ! cernlib function M432
*
*-- Initialization
      STIME = 0.
*
*-- check the KEY is there or not
      IF (IKEY.LE.0.OR.IKEY.GT.NSWKEY) THEN
         WRITE(CMSG,'(''Cannot find KEY '',I3)') IKEY
         CALL MSGOUT('SWSTOP',CMSG(:LNBLNK(CMSG)),1)
         RETURN 
      ENDIF
*
*-- case timer is down
      IF (.NOT.SSWKEY(IKEY)) THEN
         RETURN 
      ELSE
*
*-- what time is it now?
         CALL TIMEX(TNOW)
*--
         RSWKEY(3,IKEY) = TNOW
*-- set return value
         STIME = TNOW - RSWKEY(1,IKEY)
*-- timer is down
         SSWKEY(IKEY) = .FALSE. 
      ENDIF
      RETURN 
      END
*
      SUBROUTINE SWLAP(IKEY,ETIME,LTIME)
*.      
*... SWSTOP stop stopwatch
*.      
*.    IKEY :  KEY number
*.    ETIME:  elapsed time
*.    LTIME:  LAP time
*.      
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      INTEGER IKEY
      REAL ETIME,LTIME
*
*--
      REAL TNOW
*
*-- for error message
      CHARACTER*80 CMSG
      INTEGER LNBLNK            ! cernlib function M432
*
*-- Initialization
      ETIME = 0.
      LTIME = 0.
*
*-- check the KEY is there or not
      IF (IKEY.LE.0.OR.IKEY.GT.NSWKEY) THEN
         WRITE(CMSG,'(''Cannot find KEY '',I3)') IKEY
         CALL MSGOUT('SWSTOP',CMSG(:LNBLNK(CMSG)),1)
         RETURN 
      ENDIF
*
*-- case timer is down
      IF (.NOT.SSWKEY(IKEY)) THEN
         RETURN 
      ELSE
*
*-- what time is it now?
         CALL TIMEX(TNOW)
*-- elapsed time
         ETIME = TNOW - RSWKEY(1,IKEY)
*-- LAP time
         LTIME = TNOW - RSWKEY(2,IKEY)
*-- set LAP time buffer
         RSWKEY(2,IKEY) = TNOW
*- increment counter
         ISWKEY(2,IKEY) = ISWKEY(2,IKEY) + 1
*
      ENDIF
*--
      RETURN 
      END
      
*
      SUBROUTINE SWRSET(IKEY)
*.      
*... SWRSET reset timer
*.      
*.    IKEY :  KEY number
*.      
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      INTEGER IKEY
*
*-- for error message
      CHARACTER*80 CMSG
      INTEGER LNBLNK            ! cernlib function M432
*
*-- check the KEY is there or not
      IF (IKEY.LE.0.OR.IKEY.GT.NSWKEY) THEN
         WRITE(CMSG,'(''Cannot find KEY '',I3)') IKEY
         CALL MSGOUT('SWRSET',CMSG(:LNBLNK(CMSG)),1)
         RETURN 
      ENDIF
*
*--
      IF (SSWKEY(IKEY)) THEN
         CMSG =  'Timer is up, do nothing'
         CALL MSGOUT('SWRSET',CMSG(:LNBLNK(CMSG)),2)
         RETURN 
      ELSE
         SSWKEY(IKEY) = .FALSE. 
         FSWKEY(IKEY) = .TRUE. 
      ENDIF
*
      RETURN 
      END
*
      SUBROUTINE SWDMP(IKEY)
*.      
*... SWDMP dump current timer status
*.      
*.    IKEY :  KEY number
*.      
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      INTEGER IKEY
*
*--
      INTEGER I,NDMP,IDMP(MXKEY)
      REAL TNOW
      CHARACTER*4 UPDOWN
      CHARACTER*3 OLDNEW
*
*-- check the KEY is there or not
      IF (IKEY.LT.0.OR.IKEY.GT.NSWKEY) THEN
         WRITE(*,*) 'IKEY ',IKEY,' not exist'
         RETURN 
      ENDIF
*
      IF (IKEY.NE.0) THEN
         NDMP = 1
         IDMP(1) = IKEY
      ELSE
         NDMP = NSWKEY
         DO 10 I=1,NSWKEY
            IDMP(I) = I
 10      CONTINUE 
      ENDIF
*
*-- what time is it now?
      CALL TIMEX(TNOW)
*      
      DO 20 I=1,NDMP
         IF (SSWKEY(IDMP(I))) THEN
            UPDOWN = 'up  '
         ELSE
            UPDOWN = 'down'
         ENDIF
*
         IF (FSWKEY(IDMP(I))) THEN
            OLDNEW = 'new'
         ELSE
            OLDNEW = 'old'
         ENDIF
*
         WRITE (*,1000) CSWKEY(IDMP(I)),UPDOWN,OLDNEW,
     +        RSWKEY(1,IDMP(I)),TNOW,RSWKEY(3,IDMP(I)),
     +        ISWKEY(1,IDMP(I)),ISWKEY(2,IDMP(I))
 20   CONTINUE 
*
 1000 FORMAT (A6,' -- ','Status >',A5,' Oldnew > ',A5,
     +     ' T0 >',F10.3,' Tnow >',F10.3,' Tstop >',F10.3,
     +     ' #Start >',I8,' #LAP >',I8)
*
      RETURN 
      END
*
      SUBROUTINE SWREP(IKEY)
*.      
*... SWREP report timer
*.      
*.    IKEY :  KEY number 0: all 
*.      
      IMPLICIT NONE
*
*-- include file
#include "swatch.inc"
*
*-- Input Argument
      INTEGER IKEY
*
*--
      REAL TNOW
      INTEGER I
*
*-- check the KEY is there or not
      IF (IKEY.LT.0.OR.IKEY.GT.NSWKEY) THEN
         WRITE(*,*) 'IKEY ',IKEY,' not exist'
         RETURN 
      ENDIF
*
*-- what time is it now?
      CALL TIMEX(TNOW)
*
*--
      IF (IKEY.GT.0) THEN
         IF (SSWKEY(IKEY)) THEN
            WRITE (*,1000) CSWKEY(IKEY),ISWKEY(1,IKEY),ISWKEY(2,IKEY)
         ELSE
            WRITE (*,1001) CSWKEY(IKEY),RSWKEY(3,IKEY)-RSWKEY(1,IKEY),
     +           ISWKEY(1,IKEY),ISWKEY(2,IKEY)
         ENDIF
      ELSE
         DO 10 I=1,NSWKEY
            IF (SSWKEY(I)) THEN
               WRITE (*,1000) CSWKEY(I),ISWKEY(1,I),ISWKEY(2,I)
            ELSE
               WRITE (*,1001) CSWKEY(I),RSWKEY(3,I)-RSWKEY(1,I),
     +              ISWKEY(1,I),ISWKEY(2,I)
            ENDIF
 10      CONTINUE 
      ENDIF
*--
 1000 FORMAT (A6,' --  still up    ',10X,' #Start >',I8,' #LAP >',I8)
 1001 FORMAT (A6,' --  total time >',F10.3,' #Start >',I8,' #LAP >',I8)
      RETURN 
      END
