      SUBROUTINE GETCLS
C
C     THIS SUBROUTINE IS CALLED BY MAIN
C     AND GET CAL CLUSTER DATA FROM BANKS.
C       
      IMPLICIT NONE
      
#include "jlcnst.inc"      
#include "trbuff.inc"
#include "buffer.inc"
#include "jlcylp.inc"
#include "cldata.inc"

      INTEGER IG

      REAL EDELTA,EFRAC
      REAL ESIG,THGTMP,DELTTH
      REAL R
      REAL COSTH,PHI

      INTEGER J,J1,J2


*-- Read barrel EM cluster data from 'MCBECLUS'
      CALL KZGET('MCBECLUS',0,NBUFF,IBUFF)
      NBECLS = IBUFF(1)
      EBECLS = RBUFF(5)
C      WRITE(6,7001) NBECLS,EBECLS
C 7001 FORMAT(//1H ,'<< Barrel EM Clusters ; ',I4,F7.1,' >>',
C     &     //1H ,'IC   Ex   Ey   Ez   E     cos   phi ',
C     &     '    x      y      z   cel trk'/)
      
      DO 101 J=1,NBECLS
         CALL KZGET('MCBECLUS',J,NBUFF,IBUFF)
         ETBECL(J) = RBUFF(1)
         EXBECL(J) = RBUFF(2)*RBUFF(1)
         EYBECL(J) = RBUFF(3)*RBUFF(1)
         EZBECL(J) = RBUFF(4)*RBUFF(1)
         XBECL(J) = RBUFF(2)*REMC(2)/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         YBECL(J) = RBUFF(3)*REMC(2)/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         ZBECL(J) = RBUFF(4)*REMC(2)/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         NBECEL(J) = IBUFF(5)
         NBETRK(J) = IBUFF(6)
         CALL KZGET('MCBECLUS',J,NBUFF,IBUFF)
         DO 102 J1=1,NBECEL(J)
            LBECEL(J1,J) = IBUFF(J1+6)
 102     CONTINUE
         DO 103 J2=1,NBETRK(J)
            LBETRK(J2,J) = IBUFF(J2+NBECEL(J)+6)
 103     CONTINUE

*-- Fill Energy Histo
C         IG = LBETRK(1,J)      
C         EDELTA = ( ETBECL(J) - ETGEN(IG) )
C         EFRAC  = EDELTA/ETGEN(IG)
C         ESIG   = EDELTA/ SQRT(ETGEN(IG))
C         THGTMP= ACOS(EZBECL(J)/ETBECL(J)) *180.0/XPI 
C         THGEN = ACOS(PZGEN(IG)/ETGEN(IG)) *180.0/XPI
C         DELTTH = THGTMP - THGEN 
C         COSTH = EZBECL(J)/ETBECL(J)
C         PHI   = 180./XPI*ATAN2(EYBECL(J),EXBECL(J))
C         WRITE(6,7002) J,EXBECL(J),EYBECL(J),EZBECL(J),ETBECL(J),
C     &        COSTH,PHI,
C     &        XBECL(J),YBECL(J),ZBECL(J),
C     &        NBECEL(J),NBETRK(J)
C 7002    FORMAT(1H ,I2,4F5.1,F7.3,F7.1,3F7.1,2I4)
 101  CONTINUE

*-- Read barrel HD cluster data from 'MCBHCLUS'
      CALL KZGET('MCBHCLUS',0,NBUFF,IBUFF)
      NBHCLS = IBUFF(1)
      EBHCLS = RBUFF(5)
C      WRITE(6,7003) NBHCLS,EBHCLS
C 7003 FORMAT(//1H ,'<< Barrel HAD Clusters ; ',I4,F7.1,' >>',
C     &     //1H ,'IC   Ex   Ey   Ez   E     cos   phi ',
C     &     '    x      y      z   cel trk'/)

      DO 201 J=1,NBHCLS
         CALL KZGET('MCBHCLUS',J,NBUFF,IBUFF)
         ETBHCL(J) = RBUFF(1)
         EXBHCL(J) = RBUFF(2)*RBUFF(1)
         EYBHCL(J) = RBUFF(3)*RBUFF(1)
         EZBHCL(J) = RBUFF(4)*RBUFF(1)
         XBHCL(J) = RBUFF(2)*RHAD(2)/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         YBHCL(J) = RBUFF(3)*RHAD(2)/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         ZBHCL(J) = RBUFF(4)*RHAD(2)/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         NBHCEL(J) = IBUFF(5)
         NBHTRK(J) = IBUFF(6)
         CALL KZGET('MCBHCLUS',J,NBUFF,IBUFF)
         DO 202 J1=1,NBHCEL(J)
            LBHCEL(J1,J) = IBUFF(J1+6)
 202     CONTINUE
         DO 203 J2=1,NBHTRK(J)
            LBHTRK(J2,J) = IBUFF(J2+NBHCEL(J)+6)
 203     CONTINUE  
         COSTH = EZBHCL(J)/ETBHCL(J)
         PHI   = 180./XPI*ATAN2(EYBHCL(J),EXBHCL(J))
C         WRITE(6,7002) J,EXBHCL(J),EYBHCL(J),EZBHCL(J),ETBHCL(J),
C     &        COSTH,PHI,
C     &        XBHCL(J),YBHCL(J),ZBHCL(J),
C     &        NBHCEL(J),NBHTRK(J)
 201  CONTINUE

*-- Read End-cap EM cluster data from 'MCEECLUS'
      CALL KZGET('MCEECLUS',0,NBUFF,IBUFF)
      NEECLS = IBUFF(1)
      EEECLS = RBUFF(5)
C      WRITE(6,7004) NEECLS,EEECLS
C 7004 FORMAT(//1H ,'<< End-cap EM Clusters ; ',I4,F7.1,' >>',
C     &     //1H ,'IC   Ex   Ey   Ez   E     cos   phi ',
C     &     '    x      y      z   cel trk'/)
      DO 301 J=1,NEECLS
         CALL KZGET('MCEECLUS',J,NBUFF,IBUFF)
         ETEECL(J) = RBUFF(1)
         EXEECL(J) = RBUFF(2)*RBUFF(1)
         EYEECL(J) = RBUFF(3)*RBUFF(1)
         EZEECL(J) = RBUFF(4)*RBUFF(1)
         IF(RBUFF(4).LT.0)  ZEECL(J) = ZEMC(1) 
         IF(RBUFF(4).GE.0)  ZEECL(J) = ZEMC(2) 
         R = SQRT(EXEECL(J)**2+EYEECL(J)**2)/EZEECL(J)*ZEECL(J)
         XEECL(J) = RBUFF(2)*R/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         YEECL(J) = RBUFF(3)*R/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         NEECEL(J) = IBUFF(5)
         NEETRK(J) = IBUFF(6)
         CALL KZGET('MCEECLUS',J,NBUFF,IBUFF)
         DO 302 J1=1,NEECEL(J)
            LEECEL(J1,J) = IBUFF(J1+6)
 302     CONTINUE
         DO 303 J2=1,NEETRK(J)
            LEETRK(J2,J) = IBUFF(J2+NEECEL(J)+6)
 303     CONTINUE

*-- Fill Energy Histo
C         IG = LEETRK(1,J)      
C         EDELTA = ( ETEECL(J) - ETGEN(IG) )
C         EFRAC  = EDELTA/ETGEN(IG)
C         ESIG   = EDELTA/SQRT(ETGEN(IG))
C         THGTMP= ACOS(EZEECL(J)/ETEECL(J)) *180.0/XPI 
C         THGEN = ACOS(PZGEN(IG)/ETGEN(IG)) *180.0/XPI
C         DELTTH = THGTMP - THGEN 
C         COSTH = EZEECL(J)/ETEECL(J)
C         PHI   = 180./XPI*ATAN2(EYEECL(J),EXEECL(J))
C         WRITE(6,7002) J,EXEECL(J),EYEECL(J),EZEECL(J),ETEECL(J),
C     &        COSTH,PHI,
C     &        XEECL(J),YEECL(J),ZEECL(J),
C     &        NEECEL(J),NEETRK(J)
 301  CONTINUE

*-- Read End-cap HD cluster data from 'MCEHCLUS'
      CALL KZGET('MCEHCLUS',0,NBUFF,IBUFF)
      NEHCLS = IBUFF(1)
      EEHCLS = RBUFF(5)
C      WRITE(6,7005) NEHCLS,EEHCLS
C 7005 FORMAT(//1H ,'<< End-cap HAD Clusters ; ',I4,F7.1,' >>',
C     &     //1H ,'IC   Ex   Ey   Ez   E     cos   phi ',
C     &     '    x      y      z   cel trk'/)
      DO 401 J=1,NEHCLS
         CALL KZGET('MCEHCLUS',J,NBUFF,IBUFF)
         ETEHCL(J) = RBUFF(1)
         EXEHCL(J) = RBUFF(2)*RBUFF(1)
         EYEHCL(J) = RBUFF(3)*RBUFF(1)
         EZEHCL(J) = RBUFF(4)*RBUFF(1)
         IF(RBUFF(4).LT.0)  ZEHCL(J) = ZHAD(1) 
         IF(RBUFF(4).GE.0)  ZEHCL(J) = ZHAD(2) 
         R = SQRT(EXEHCL(J)**2+EYEHCL(J)**2)/EZEHCL(J)*ZEHCL(J)
         XEHCL(J) =RBUFF(2)*R/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         YEHCL(J) =RBUFF(3)*R/SQRT(RBUFF(2)**2+RBUFF(3)**2)
         NEHCEL(J) = IBUFF(5)
         NEHTRK(J) = IBUFF(6)
         CALL KZGET('MCEHCLUS',J,NBUFF,IBUFF)
         DO 402 J1=1,NEHCEL(J)
            LEHCEL(J1,J) = IBUFF(J1+6)
 402     CONTINUE
         DO 403 J2=1,NEHTRK(J)
            LEHTRK(J2,J) = IBUFF(J2+NEHCEL(J)+6)
 403     CONTINUE
         COSTH = EZEHCL(J)/ETEHCL(J)
         PHI   = 180./XPI*ATAN2(EYEHCL(J),EXEHCL(J))
C         WRITE(6,7002) J,EXEHCL(J),EYEHCL(J),EZEHCL(J),ETEHCL(J),
C     &        COSTH,PHI,
C     &        XEHCL(J),YEHCL(J),ZEHCL(J),
C     &        NEHCEL(J),NEHTRK(J)
 401  CONTINUE

      RETURN
      END
      
