      SUBROUTINE VXCLS1(ICLSBF,RCLSBF,MXNCLS,NCLS,HIDXBF,MXHIBF,ETHRES)
*     --- create cluster-squares
      IMPLICIT NONE
*     === common ===
#include "vxgeo.inc"
#include "vxdata.inc"
#include "vxclsd.inc"
*     === arguments ===
      INTEGER ICLSBF(NCLELM,*)
      REAL    RCLSBF(NCLELM,*)
*     .         buffer to store the cluster properties.
      INTEGER MXNCLS
*     .         the length of iclsbf
      INTEGER NCLS
*     .         number of clusters
      INTEGER HIDXBF(*)
*     .         buffer to store the hit index links.
      INTEGER MXHIBF
*     .         the length of hidxbf
      REAL ETHRES
*     .         threshold in pickking up hits
*     === local ===
      INTEGER IHIT,JHIT
      INTEGER ICLS, JCLS, ICLSHT
      INTEGER ILAYI,IZCLI,IPCLI
      INTEGER ILAYJ
      INTEGER IZCLI1,IZCLI2,IPCLI1,IPCLI2
      INTEGER IZCLJ1,IZCLJ2,IPCLJ1,IPCLJ2
      LOGICAL LCOMBI
      REAL ELOSI
      CHARACTER*128 CMSG
      INTEGER LNBLNK
      INTEGER IERR

      IF (NHITVX .GT. MXHIBF) THEN
         CALL MSGOUT('VXCLS1','NHITVX > MXHITBF',NHITVX)
         NHITVX=MXHIBF
      ENDIF
      
      NCLS=0
      DO 100 IHIT=1,NHITVX
         
*       --- hit properties
         ILAYI = ILAYVX(IHIT)
         IZCLI = IZCLVX(IHIT)
         IPCLI = IPCLVX(IHIT)
         ELOSI = ELOSVX(IHIT)
         
*       --- check hit properties
         IERR=0
         IF (ILAYI .GT. NLAYVX) THEN
            CALL MSGOUT('VXCLS1','ILAYI > NLAYVX',ILAYI)
            IERR=IERR+1
         ENDIF
         IF (IZCLI .LT. 0     ) THEN
            CALL MSGOUT('VXCLS1','IZCLI < 0',IZCLI)
            IERR=IERR+1
         ENDIF
         IF (IZCLI .GT. NVPXZ(ILAYI)) THEN
            CALL MSGOUT('VXCLS1','IZCLI > NVPXZ',IZCLI)
            IERR=IERR+1
         ENDIF
         IF (IPCLI .LT. 0     ) THEN
            CALL MSGOUT('VXCLS1','IPCLI < 0',IPCLI)
            IERR=IERR+1
         ENDIF
         IF (IPCLI .GT. NVPXPH(ILAYI)) THEN
            CALL MSGOUT('VXCLS1','IPCLI > NVPXPH',IPCLI)
            IERR=IERR+1
         ENDIF
         IF (IERR .GT. 0) THEN
            WRITE(CMSG,'(''Error: IHIT,NHITVX = '',I5,'','',I5)')
     &           IHIT,NHITVX
            CALL MSGOUT('VXCLS1',CMSG(:LNBLNK(CMSG)),IERR)
            RETURN
         ENDIF
         
*       --- clusterization
        IF (ELOSI .GT. ETHRES) THEN
           DO 110 ICLS=1,NCLS
              IF ( ILAYI .EQ. ICLSBF(CLILAY,ICLS) .AND.
     &             IZCLI .GE. ICLSBF(CLIZMN,ICLS)-1 .AND.
     &             IZCLI .LE. ICLSBF(CLIZMX,ICLS)+1 ) THEN
                 IF ( IPCLI .GE. ICLSBF(CLIPMN,ICLS)-1 .AND.
     &                IPCLI .LE. ICLSBF(CLIPMX,ICLS)+1
     &                .OR.
     &                ICLSBF(CLIPMN,ICLS) .EQ. 1 .AND.
     &                IPCLI .EQ. NVPXPH(ILAYI)
     &                .OR.
     &                ICLSBF(CLIPMX,ICLS) .EQ. NVPXPH(ILAYI) .AND.
     &                IPCLI .EQ. 1
     &                .OR.
     &                ICLSBF(CLIPMN,ICLS) .GT. ICLSBF(CLIPMX,ICLS) .AND.
     &                ( IPCLI .GE. ICLSBF(CLIPMN,ICLS)-1
     &                .OR.
     &                IPCLI .LE. ICLSBF(CLIPMX,ICLS)+1 ) ) THEN
*               -- the hit is in the cluster region (square)
                    JHIT=ICLSBF(CLIHIT,ICLS)
                    DO 120 ICLSHT=2,ICLSBF(CLNHIT,ICLS)
                       JHIT=HIDXBF(JHIT)
 120                CONTINUE
                    HIDXBF(JHIT)=IHIT
                    ICLSBF(CLNHIT,ICLS)=ICLSBF(CLNHIT,ICLS)+1
                    IF ( ICLSBF(CLIZMN,ICLS) .GT. IZCLI ) THEN
                       ICLSBF(CLIZMN,ICLS)  =   IZCLI
                    ELSEIF ( ICLSBF(CLIZMX,ICLS) .LT. IZCLI ) THEN
                       ICLSBF(CLIZMX,ICLS)  =   IZCLI 
                    ENDIF
                    IF ( ICLSBF(CLIPMN,ICLS) .EQ.
     &                   MOD(IPCLI,NVPXPH(ILAYI))+1 ) THEN
                       ICLSBF(CLIPMN,ICLS) = IPCLI
                    ELSE
                       IF ( MOD(ICLSBF(CLIPMX,ICLS),NVPXPH(ILAYI))
     &                      .EQ. IPCLI-1 ) THEN
                          ICLSBF(CLIPMX,ICLS)  =   IPCLI
                       ENDIF
                    ENDIF
                    GOTO 105
                 ENDIF
              ENDIF
 110       CONTINUE
*         --- if icls > NCLS then the hit doesn't belong to any cluster
           IF (ICLS .GT. NCLS) THEN
*           --- new cluster
              IF (NCLS .GE. MXNCLS) THEN
                 CALL MSGOUT('VXCLS1',
     &                'Number of clusters exceeds buffer limit',NCLS)
              ELSE
                 NCLS=NCLS+1
                 ICLSBF(CLILAY,NCLS)=ILAYI
                 ICLSBF(CLIZMN,NCLS)=IZCLI
                 ICLSBF(CLIZMX,NCLS)=IZCLI
                 ICLSBF(CLIPMN,NCLS)=IPCLI
                 ICLSBF(CLIPMX,NCLS)=IPCLI
                 ICLSBF(CLIHIT,NCLS)=IHIT
                 ICLSBF(CLNHIT,NCLS)=1
              ENDIF
           ENDIF
 105       CONTINUE
        ENDIF
 100  CONTINUE
      
*     === combine side-by-side or overlapping cluster-squares ===
      DO 200 ICLS=1,NCLS
         ILAYI=ICLSBF(CLILAY,ICLS)
         IZCLI1=ICLSBF(CLIZMN,ICLS)
         IZCLI2=ICLSBF(CLIZMX,ICLS)
         IPCLI1=ICLSBF(CLIPMN,ICLS)
         IPCLI2=ICLSBF(CLIPMX,ICLS)
         DO 210 JCLS=ICLS+1,NCLS
            ILAYJ=ICLSBF(CLILAY,NCLS)
            IF ( ICLSBF(CLILAY,ICLS) .EQ. ICLSBF(CLILAY,JCLS) ) THEN
               IZCLJ1=ICLSBF(CLIZMN,JCLS)
               IZCLJ2=ICLSBF(CLIZMX,JCLS)
               IPCLJ1=ICLSBF(CLIPMN,JCLS)
               IPCLJ2=ICLSBF(CLIPMX,JCLS)
               IF ( IZCLJ2 .GE. IZCLI1-1 .AND.
     &              IZCLJ1 .LE. IZCLI2+1 ) THEN
*             --- two squares overlap in z ---
                  LCOMBI=.FALSE.
                  IF ( IPCLI1 .LE. IPCLI2 .AND. IPCLJ1 .LE. IPCLJ2 )
     &                 THEN
*               --- both squares aren't lying over phi=0 ---
                     IF ( IPCLJ1 .LE. IPCLI2+1 .AND.
     &                    IPCLJ2 .GE. IPCLI1-1) THEN
*                 --- two squares overlap in phi ---
                        LCOMBI=.TRUE.
                        IF (IPCLJ1 .LT. IPCLI1) ICLSBF(CLIPMN,ICLS)
     &                       =IPCLJ1
                        IF (IPCLJ2 .GT. IPCLI2) ICLSBF(CLIPMX,ICLS)
     &                       =IPCLJ2
                     ELSEIF (IPCLI1 .EQ. 1 .AND.
     &                       IPCLJ2 .EQ. NVPXPH(ILAYI)) THEN
                        LCOMBI=.TRUE.
                        ICLSBF(CLIPMN,ICLS)=IPCLJ1
                     ELSEIF (IPCLJ1 .EQ. 1 .AND.
     &                       IPCLI2 .EQ. NVPXPH(ILAYI)) THEN
                        ICLSBF(CLIPMX,ICLS)=IPCLJ2
                     ENDIF
                  ELSEIF ( IPCLI2 .LT. IPCLI1 ) THEN
                     IF (IPCLJ2 .LT. IPCLJ1) THEN
*                 --- both squares are lying over phi=0 ---
                        LCOMBI=.TRUE.
                        IF (IPCLJ1 .LT. IPCLI1) ICLSBF(CLIPMN,ICLS)
     &                       =IPCLJ1
                        IF (IPCLJ2 .GT. IPCLI2) ICLSBF(CLIPMX,ICLS)
     &                       =IPCLJ2
                     ELSEIF (IPCLJ2 .GE. IPCLI1-1) THEN
*                 --- square i is lying over phi=0 and j lies phi<2pi --
c -
                        lcombi=.TRUE.
                        IF (IPCLJ1 .LT. IPCLI1) ICLSBF(CLIPMN,ICLS)
     &                       =IPCLJ1
                     ELSEIF (IPCLJ1 .LE. IPCLI2+1) THEN
*                 --- square i is lying over phi=0 and j lies phi>0 ---
                        LCOMBI=.TRUE.
                        IF (IPCLJ2 .GT. IPCLI2) ICLSBF(CLIPMX,ICLS)
     &                       =IPCLJ2
                     ENDIF
                  ELSEIF ( IPCLJ2 .LT. IPCLJ1 ) THEN
*               --- square j is lying over phi=0 and i isn't ---
                     IF (IPCLI2 .GE. IPCLJ1-1) THEN
*                 --- square j is lying over phi=0 and i lies phi<2pi --
c -
                        LCOMBI=.TRUE.
                        IF (IPCLJ1 .LT. IPCLI1) ICLSBF(CLIPMN,ICLS)
     &                       =IPCLJ1
                     ELSEIF (IPCLI1 .LE. IPCLJ2+1) THEN
*                 --- square j is lying over phi=0 and i lies phi>0 ---
                        LCOMBI=.TRUE.
                        IF (IPCLJ2 .GT. IPCLI2) ICLSBF(CLIPMX,ICLS)
     &                       =IPCLJ2
                     ENDIF
                  ENDIF
                  IF (LCOMBI) THEN
                     IF (IZCLI1 .GT. IZCLJ1) ICLSBF(CLIZMN,ICLS)=IZCLJ1
                     IF (IZCLI2 .LT. IZCLJ2) ICLSBF(CLIZMX,ICLS)=IZCLJ2
                     IHIT=ICLSBF(CLIHIT,ICLS)
                     DO 220 ICLSHT=2,ICLSBF(CLNHIT,ICLS)
                        IHIT=HIDXBF(IHIT)
 220                 CONTINUE
                     HIDXBF(JHIT)=ICLSBF(CLIHIT,JCLS)
                     ICLSBF(CLNHIT,ICLS)=ICLSBF(CLNHIT,ICLS)
     &                    +ICLSBF(CLNHIT,JCLS)
                  ENDIF
               ENDIF
            ENDIF
 210     CONTINUE
 200  CONTINUE
      
      RETURN
      END
      
