      SUBROUTINE VXCLS3(ICLSBF,RCLSBF,NCLS,HIDXBF,MXHIBF,ETHRES)
*     analyse cluster shape ... weighted center and diviation in (phi,z)
      IMPLICIT NONE
*     === common ===
#include "jlcnst.inc"
#include "vxgeo.inc"
#include "vxdata.inc"
#include "vxclsd.inc"
*     === arguments ===
      INTEGER ICLSBF(NCLELM,*)
      REAL    RCLSBF(NCLELM,*)
*     .         buffer to store the cluster properties.
      INTEGER NCLS
*     .         number of clusters
      INTEGER HIDXBF(*)
*     .         buffer to store the hit indices.
      INTEGER MXHIBF
*     .         the length of hidxbf
      REAL ETHRES
*     .         threshold in pickking up hits
*     === local ===
      INTEGER IHIT, JHIT
      INTEGER ICLS, ICLSHT
      INTEGER ILAY
      REAL     ZCL, PCL, RCL, ZCLSG, PCLSG, RCLSG, ZCLSM, PCLSM
      REAL     ZCL1,PCL1
      REAL ELOS, ESUM

      DO 100 ICLS=1,NCLS
         ILAY=ICLSBF(CLILAY,ICLS)
         IF (ILAY .GT. NLAYVX) THEN
            CALL MSGOUT('VXCLS3','ILAY > NLAYVX',ILAY)
            STOP
         ENDIF
*       --- cluster width in phi,z directions
         IF (ICLSBF(CLIPMN,ICLS) .GT. ICLSBF(CLIPMX,ICLS)) THEN
*         -- the cluster lies over phi=0
            RCLSBF(CLWIDP,ICLS)
     &           =REAL(ICLSBF(CLIPMX,ICLS)
     &           -(ICLSBF(CLIPMN,ICLS)-NVPXPH(ILAY))+1)
         ELSE
            RCLSBF(CLWIDP,ICLS)
     &           =REAL(ICLSBF(CLIPMX,ICLS)-ICLSBF(CLIPMN,ICLS)+1)
         ENDIF
         RCLSBF(CLWIDZ,ICLS)=ICLSBF(CLIZMX,ICLS)-ICLSBF(CLIZMN,ICLS)
         RCLSBF(CLWIDP,ICLS)=RCLSBF(CLWIDP,ICLS)*PXCLVX
         RCLSBF(CLWIDZ,ICLS)=RCLSBF(CLWIDZ,ICLS)*PXCLVX
*       --- first scan ... cluster center, (phi,z)-diviations, cluster
*       --- energy
         ESUM=0.
         PCLSM=0.
         ZCLSM=0.
         RCLSG=0.
         PCLSG=0.
         ZCLSG=0.
         IHIT=ICLSBF(CLIHIT,ICLS)
         IF (IHIT.LE.0 .OR. IHIT.GT.MXHIBF) THEN
            CALL MSGOUT('VXCLS3','IHIT out of range',IHIT)
            GOTO 111
        ENDIF
        ZCL1=REAL(IZCLVX(IHIT))
        PCL1=REAL(IPCLVX(IHIT))
        ESUM=ELOSVX(IHIT)
        ICLSBF(CLITRK,ICLS)=ITRKVX(IHIT)
        JHIT=IHIT
        DO 110 ICLSHT=2,ICLSBF(CLNHIT,ICLS)
           JHIT=HIDXBF(JHIT)
           IF (JHIT .LE. 0 .OR. JHIT .GT. MXHIBF) THEN
              CALL MSGOUT('VXCLS3','JHIT out of range',JHIT)
              GOTO 111
           ENDIF
           IF ( ICLSBF(CLITRK,ICLS).NE.ITRKVX(JHIT) )
     &          ICLSBF(CLITRK,ICLS)=0
           ELOS=ELOSVX(JHIT)
           ESUM=ESUM+ELOS
           IF ( ICLSBF(CLIPMN,ICLS).NE.ICLSBF(CLIPMX,ICLS) ) THEN
              IF (IPCLVX(JHIT) .GT. ICLSBF(CLIPMX,ICLS)) THEN
*             -- the cluster lies over phi=0
                 PCL=REAL(IPCLVX(JHIT)-NVPXPH(ILAY))
              ELSE
                 PCL=REAL(IPCLVX(JHIT))
              ENDIF
              PCL=PCL-PCL1
              PCLSM=PCLSM+ELOS*PCL
              PCLSG=PCLSG+ELOS*PCL*PCL
           ENDIF
           IF ( ICLSBF(CLIZMN,ICLS).NE.ICLSBF(CLIZMX,ICLS) ) THEN
              ZCL=REAL(IZCLVX(JHIT))-ZCL1
              ZCLSM=ZCLSM+ELOS*ZCL
              ZCLSG=ZCLSG+ELOS*ZCL*ZCL
           ENDIF
 110    CONTINUE
 111    CONTINUE
        RCL=RVX(ILAY)
        RCLSG=0.
        IF ( ICLSBF(CLIPMN,ICLS).NE.ICLSBF(CLIPMX,ICLS) ) THEN
           PCLSM=PCLSM/ESUM
           PCLSG=SQRT(PCLSG/ESUM - PCLSM**2)
           PCLSM=PCLSM+PCL1
        ELSE
           PCLSM=ICLSBF(CLIPMN,ICLS)
        ENDIF
        IF ( ICLSBF(CLIZMN,ICLS).NE.ICLSBF(CLIZMX,ICLS) ) THEN
           ZCLSM=ZCLSM/ESUM
           ZCLSG=SQRT(ZCLSG/ESUM - ZCLSM**2)
           ZCLSM=ZCLSM+ZCL1
        ELSE
           ZCLSM=ICLSBF(CLIZMN,ICLS)
        ENDIF
        
*       -- rewrite values in real unit
        ZCLSM=-ZVX(ILAY) + (ZCLSM-0.5)*PXCLVX
        PCLSM=(PCLSM-0.5)*PXCLVX/RCL
        IF (PCLSM .GT. XPI) PCLSM=PCLSM-2.*XPI
C        IF (ICLS .EQ. 1)
C     &       PRINT '(A)','Icls, E    ,  Phi ,  Z   ,Phi-sg,Z-sg'
C        IF (ICLS.LE.5) PRINT 1000,ICLS,ESUM,PCLSM,ZCLSM,PCLSG,ZCLSG
 1000   FORMAT(I4,5F7.2)
        RCLSG=RCLSG*PXCLVX
        PCLSG=PCLSG*PXCLVX
        ZCLSG=ZCLSG*PXCLVX
        RCLSBF(CLESUM,ICLS)=ESUM
        RCLSBF(CLCOR,ICLS)= RCL
        RCLSBF(CLCOPH,ICLS)=PCLSM
        RCLSBF(CLCOZ,ICLS)= ZCLSM
        RCLSBF(CLSIGR,ICLS)=RCLSG
        RCLSBF(CLSIGP,ICLS)=PCLSG
        RCLSBF(CLSIGZ,ICLS)=ZCLSG
 100  CONTINUE

      RETURN
      END
      
