      SUBROUTINE VXCLS4(ICLSBF,RCLSBF,NCLS,HIDXBF,MXHIBF,ETHRES)
*     analyse cluster shape ... length, width and diviations in their dirs.
      IMPLICIT NONE
*     === common ===
#include "jlcnst.inc"
#include "vxgeo.inc"
#include "vxdata.inc"
#include "vxclsd.inc"
*     === arguments ===
      INTEGER ICLSBF(NCLELM,*)
      REAL    RCLSBF(NCLELM,*)
*     .         buffer to store the cluster properties.
      INTEGER NCLS
*     .         number of clusters
      INTEGER HIDXBF(*)
*     .         buffer to store the hit indices.
      INTEGER MXHIBF
*     .         the length of hidxbf
      REAL ETHRES
*     .         threshold in pickking up hits
*     === local ===
      INTEGER IHIT, JHIT, NHIT
      INTEGER ICLS, ICLSHT
      INTEGER ILAY
      REAL     ZCL, PCL, RCL, ZCLSG, PCLSG, RCLSG, ZCLSM, PCLSM, CLSG
      REAL     ZCL1,PCL1
      REAL ELOS, ESUM
      REAL RMAX, RI, PHI1, Z1, PHI2, Z2
      REAL     LCL, WCL, LCLSG, WCLSG, LCLC, WCLC
*     .         length, width, diviations in direction of l and w
*     .         center (l,w)
      REAL WMAX, WMIN, WDIS, LDIS
      

      DO 100 ICLS=1,NCLS
         ILAY=ICLSBF(CLILAY,ICLS)
         IF (ILAY .GT. NLAYVX) THEN
            CALL MSGOUT('VXCLS4','ILAY > NLAYVX',ILAY)
            RETURN
         ENDIF
*       --- cluster width in phi,z directions
         IF (ICLSBF(CLIPMN,ICLS) .GT. ICLSBF(CLIPMX,ICLS)) THEN
*         -- the cluster lies over phi=0
            RCLSBF(CLWIDP,ICLS)
     &           =REAL(ICLSBF(CLIPMX,ICLS)
     &           -(ICLSBF(CLIPMN,ICLS)-NVPXPH(ILAY))+1)
         ELSE
            RCLSBF(CLWIDP,ICLS)
     &           =REAL(ICLSBF(CLIPMX,ICLS)-ICLSBF(CLIPMN,ICLS)+1)
         ENDIF
         RCLSBF(CLWIDZ,ICLS)=ICLSBF(CLIZMX,ICLS)-ICLSBF(CLIZMN,ICLS)
         RCLSBF(CLWIDP,ICLS)=RCLSBF(CLWIDP,ICLS)*PXCLVX
         RCLSBF(CLWIDZ,ICLS)=RCLSBF(CLWIDZ,ICLS)*PXCLVX
*       --- first scan ... cluster center, (phi,z)-diviations, cluster
*       --- energy
         NHIT=ICLSBF(CLNHIT,ICLS)
         ESUM=0.
         PCLSM=0.
         ZCLSM=0.
         RCLSG=0.
         PCLSG=0.
         ZCLSG=0.
         IHIT=ICLSBF(CLIHIT,ICLS)
         IF (IHIT .LE. 0 .OR. IHIT .GT. MXHIBF) THEN
            CALL MSGOUT('VXCLS4','IHIT out of range',IHIT)
            GOTO 111
         ENDIF
         ZCL1=REAL(IZCLVX(IHIT))
         PCL1=REAL(IPCLVX(IHIT))
         ESUM=ELOSVX(IHIT)
         ICLSBF(CLITRK,ICLS)=ITRKVX(IHIT)
         JHIT=IHIT
         DO 110 ICLSHT=2,NHIT
            JHIT=HIDXBF(JHIT)
            IF (JHIT .LE. 0 .OR. JHIT .GT. MXHIBF) THEN
               CALL MSGOUT('VXCLS3','JHIT out of range',JHIT)
               GOTO 111
            ENDIF
            IF ( ICLSBF(CLITRK,ICLS) .NE. ITRKVX(JHIT) )
     &           ICLSBF(CLITRK,ICLS)=0
            ELOS=ELOSVX(JHIT)
            ESUM=ESUM+ELOS
            IF ( ICLSBF(CLIPMN,ICLS) .NE. ICLSBF(CLIPMX,ICLS) ) THEN
               IF (IPCLVX(JHIT) .GT. ICLSBF(CLIPMX,ICLS)) THEN
*             -- the cluster lies over phi=0
                  PCL=REAL(IPCLVX(JHIT)-NVPXPH(ILAY))
               ELSE
                  PCL=REAL(IPCLVX(JHIT))
               ENDIF
               PCL=PCL-PCL1
               PCLSM=PCLSM+ELOS*PCL
               PCLSG=PCLSG+ELOS*PCL*PCL
            ENDIF
            IF ( ICLSBF(CLIZMN,ICLS) .NE. ICLSBF(CLIZMX,ICLS) ) THEN
               ZCL=REAL(IZCLVX(JHIT))-ZCL1
               ZCLSM=ZCLSM+ELOS*ZCL
               ZCLSG=ZCLSG+ELOS*ZCL*ZCL
            ENDIF
 110     CONTINUE
 111     CONTINUE
         RCL=RVX(ILAY)
         RCLSG=0.
         IF ( ICLSBF(CLIPMN,ICLS) .EQ. ICLSBF(CLIPMX,ICLS) ) THEN
            PCLSM=ICLSBF(CLIPMN,ICLS)
         ELSE
            PCLSM=PCLSM/ESUM
            PCLSG=SQRT(PCLSG/ESUM - PCLSM**2)
            PCLSM=PCLSM+PCL1
         ENDIF
         IF ( ICLSBF(CLIZMN,ICLS) .EQ. ICLSBF(CLIZMX,ICLS) ) THEN
            ZCLSM=ICLSBF(CLIZMN,ICLS)
         ELSE
            ZCLSM=ZCLSM/ESUM
            ZCLSG=SQRT(ZCLSG/ESUM - ZCLSM**2)
            ZCLSM=ZCLSM+ZCL1
         ENDIF
         
*       --- second scan ... outermost cell, radial diviation
         RMAX=0.
         CLSG=0.
         IHIT=ICLSBF(CLIHIT,ICLS)
         JHIT=IHIT
         DO 120 ICLSHT=1,ICLSBF(CLNHIT,ICLS)
            ELOS=ELOSVX(JHIT)
            ZCL=REAL(IZCLVX(JHIT))
            IF (IPCLVX(JHIT) .GT. ICLSBF(CLIPMX,ICLS)) THEN
*           -- the cluster lies over phi=0
               PCL=REAL(IPCLVX(JHIT)-NVPXPH(ILAY))
            ELSE
               PCL=REAL(IPCLVX(JHIT))
            ENDIF
            RI=(ZCL-ZCLSM)*(ZCL-ZCLSM)+(PCL-PCLSM)*(PCL-PCLSM)
            IF (RI .GT. RMAX) THEN
               RMAX=RI
               PHI1=PCL
               Z1=ZCL
            ENDIF
            CLSG=CLSG+ELOS*RI*RI
            JHIT=HIDXBF(JHIT)
 120     CONTINUE
         CLSG=SQRT(CLSG/ESUM)
         
*       --- third scan ... opposite-side outermost cell, cluster length
         RMAX=0.
         IHIT=ICLSBF(CLIHIT,ICLS)
         JHIT=IHIT
         DO 130 ICLSHT=1,ICLSBF(CLNHIT,ICLS)
            ELOS=ELOSVX(JHIT)
            ZCL=REAL(IZCLVX(JHIT))
            IF (IPCLVX(JHIT) .GT. ICLSBF(CLIPMX,ICLS)) THEN
*           -- the cluster lies over phi=0
               PCL=REAL(IPCLVX(JHIT)-NVPXPH(ILAY))
            ELSE
               PCL=REAL(IPCLVX(JHIT))
            ENDIF
            IF ( (Z1-ZCLSM)*(ZCL-ZCLSM)+(PHI1-PCLSM)*(PCL-PCLSM)
     &           .LT. 0. ) THEN
               RI=(ZCL-ZCLSM)*(ZCL-ZCLSM)+(PCL-PCLSM)*(PCL-PCLSM)
               IF (RI .GT. RMAX) THEN
                  RMAX=RI
                  PHI2=PCL
                  Z2=ZCL
               ENDIF
            ENDIF
            JHIT=HIDXBF(JHIT)
 130     CONTINUE
         LCL=SQRT((Z1-Z2)*(Z1-Z2)+(PHI1-PHI2)*(PHI1-PHI2))
         
*       --- fourth scan ... cluster width, (l,w)-diviations
         LCLSG=0.
         WCLSG=0.
         IF ( NHIT .GT. 1 ) THEN
C            IF (LCL .EQ. 0.) PRINT *,' LCL=',LCL,' NHIT=',NHIT
            IHIT=ICLSBF(CLIHIT,ICLS)
            JHIT=IHIT
            DO 140 ICLSHT=1,NHIT
C               IF (LCL .EQ. 0.) PRINT *,'   IHIT=',JHIT
C     &              ,' P=',IPCLVX(JHIT),' Z=',IZCLVX(JHIT)
               ELOS=ELOSVX(JHIT)
               ZCL=REAL(IZCLVX(JHIT))
               IF (IPCLVX(JHIT) .GT. ICLSBF(CLIPMX,ICLS)) THEN
*             -- the cluster lies over phi=0
                  PCL=REAL(IPCLVX(JHIT)-NVPXPH(ILAY))
               ELSE
                  PCL=REAL(IPCLVX(JHIT))
               ENDIF
               LDIS=( (ZCL-Z1)*(Z2-Z1) + (PCL-PHI1)*(PHI2-PHI1) ) / LCL
               LCLSG=LCLSG + ELOS*LDIS*LDIS
               WDIS=( (ZCL-Z1)*(PHI2-PHI1) - (PCL-PHI1)*(Z2-Z1) ) / LCL
               WCLSG=WCLSG + ELOS*WDIS*WDIS
               IF (ICLSHT .EQ. 1) THEN
                  WMAX=WDIS
                  WMIN=WDIS
               ELSEIF (WDIS .GT. WMAX) THEN
                  WMAX=WDIS
               ELSEIF (WDIS .LT. WMIN) THEN
                  WMIN=WDIS
               ENDIF
               JHIT=HIDXBF(JHIT)
 140        CONTINUE
            LCLC=((ZCLSM-Z1)*(Z2-Z1)+(PCLSM-PHI1)*(PHI2-PHI1))/LCL
            WCLC=((ZCLSM-Z1)*(PHI2-PHI1)-(PCLSM-PHI1)*(Z2-Z1))/LCL
            LCLSG=(LCLSG/ESUM - LCLC*LCLC)
            IF (LCLSG .GT. 0) THEN
               LCLSG=SQRT(LCLSG)
            ELSE
               LCLSG=0
            ENDIF
            WCLSG=SQRT(WCLSG/ESUM - WCLC*WCLC)
            IF (WCLSG .GT. 0) THEN
               WCLSG=SQRT(WCLSG)
            ELSE
               WCLSG=0
            ENDIF
            LCL=LCL+1.
            WCL=WMAX-WMIN+1.
         ELSE
            LCL=1.
            WCL=1.
         ENDIF
         
*       -- rewrite values in real unit
         ZCLSM=-ZVX(ILAY) + (ZCLSM-0.5)*PXCLVX
         PCLSM=(PCLSM-0.5)*PXCLVX/RCL
         IF (PCLSM .GT. XPI) PCLSM=PCLSM-2.*XPI
C         IF (ICLS .EQ. 1)
C     &        print '(A)','Icls, E    ,  Phi ,  Z   ,'//
C     &        'Phi-sg,Z-sg  , Len  , Wid  ,'//
C     &        'Len-sg,Wid-sg,  sg'
C         IF (ICLS .LE. 5)
C     &        PRINT 1000,ICLS,ESUM,PCLSM,ZCLSM,PCLSG,ZCLSG,LCL,WCL
C     &        , LCLSG, WCLSG, CLSG
 1000    FORMAT(I4,10F7.2)
         CLSG=CLSG*PXCLVX
         RCLSG=RCLSG*PXCLVX
         PCLSG=PCLSG*PXCLVX
         ZCLSG=ZCLSG*PXCLVX
         LCL=LCL*PXCLVX
         WCL=WCL*PXCLVX
         LCLSG=LCLSG*PXCLVX
         WCLSG=WCLSG*PXCLVX
         RCLSBF(CLESUM,ICLS)=ESUM
         RCLSBF(CLCOR,ICLS)= RCL
         RCLSBF(CLCOPH,ICLS)=PCLSM
         RCLSBF(CLCOZ,ICLS)= ZCLSM
         RCLSBF(CLSIG,ICLS)= CLSG
         RCLSBF(CLSIGR,ICLS)=RCLSG
         RCLSBF(CLSIGP,ICLS)=PCLSG
         RCLSBF(CLSIGZ,ICLS)=ZCLSG
         RCLSBF(CLLEN,ICLS)= LCL
         RCLSBF(CLWID,ICLS)= WCL
         RCLSBF(CLSIGL,ICLS)=LCLSG
         RCLSBF(CLSIGW,ICLS)=WCLSG
 100  CONTINUE
      
      RETURN
      END
      
