************************************************************************
*     -----------------------------
      SUBROUTINE KZBCR0(CNAME,IERR)
*     -----------------------------
*
*     (Purpose)
*        Create a new ZBS bank of Type 0.
*
*     (Inputs)
*        CNAME  ; Name of the new bank ( <= 32 characters ).
*
*     (Output)
*        IERR      ; Error flag.
*             =  0 ; NORMAL RETURN
*
*     (Creation Date)
*        1991.12.25 : First version by J.Kanzaki.
*        1996.04.26 : Add declarations. J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbssys.inc"
#include "zbs.inc"

      CHARACTER*(*) CNAME
      INTEGER IERR

      INTEGER IPDIR
      INTEGER LDIR,LEXF,LSRT,LPNT,LIOF,LBIR,LDTR
      INTEGER IEXIF,IBANK,IERDTR

      INTEGER ITYPE
      PARAMETER (ITYPE=0)
      INTEGER NWMAST,NWSMST,NSEGM,LSEGM
      PARAMETER (NWMAST=0,NWSMST=0,NSEGM=0,LSEGM=0)


      CALL KZCRMH

C==== Search for a bank "CNAME" from the directory

      CALL KZPDIR(CNAME,IPDIR)

      LDIR = LZBS(IPDIRT)
      LEXF = LZBS(LDIR-ILBEXF)
      IEXIF = IZBS(LEXF+IPDIR)

      IF(IEXIF.NE.0) THEN
         IERR = 1
         RETURN
      END IF

C==== Store informations about the new bank into the directory

      LSRT = LZBS(LDIR-ILBSRT)

      LPNT = LZBS(LDIR-ILBPNT)
      LIOF = LZBS(LDIR-ILBIOF)

      IERR = 0

      IZBS(LEXF+IPDIR) = 1
      IZBS(LIOF+IPDIR) = 1

C==== Create bank records

      IBANK = IZBS(LPNT+IPDIR)

      CALL KZCRBN(ITYPE,IBANK,CNAME,NWMAST,NWSMST,NSEGM,LSEGM)

      CALL KZCRD0(IBANK,CNAME,LDTR,IERDTR)

      RETURN
      END
