************************************************************************
*     -----------------------------------------
      SUBROUTINE KZBCR1(CNAME,NWMAST,CFORMM,
     &                  NSEGM,LSEGM,CFORMS,IERR) 
*     -----------------------------------------
*
*     (Purpose)
*       Create new ZBS bank with the fixed length segment
*
*     (Input)
*       CNAME ; Name of the new bank ( <= 32 characters ).
*
*     (Output)
*       IERR     ; Error flag
*            = 0 ; Normal return
*            > 0 ; Error return
*
*     (Creation Date and Author)
*       1991.12.25 ; First version by J.Kanzaki
*       1996.04.26 : Add declarations. J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbssys.inc"
#include "zbs.inc"

      CHARACTER*(*) CNAME
      CHARACTER*(*) CFORMM,CFORMS
      INTEGER NWMAST,NWSMST,NSEGM,IERR
      PARAMETER (NWSMST=0)

      INTEGER LSEGM,IPDIR,IEXIF
      INTEGER LDIR,LEXF,LSRT,LPNT,LIOF
      INTEGER LIOX,LEVH
      INTEGER IBANK,IOX,IEVH,IEVH0,IERIOX
      
      INTEGER ITYPE
      PARAMETER (ITYPE=1)
      
      INTEGER IDATA(LEMBDT)


      CALL KZCRMH

      CALL KZPDIR(CNAME,IPDIR)

      LDIR = LZBS(IPDIRT)
      LEXF = LZBS(LDIR-ILBEXF)

      IEXIF = IZBS(LEXF+IPDIR)

      IF (IEXIF.NE.0) THEN
         IERR = 1
         RETURN
      END IF

*-- Store Informations on the New Bank into the Directory

      LSRT = LZBS(LDIR-ILBSRT)

      LPNT = LZBS(LDIR-ILBPNT)
      LIOF = LZBS(LDIR-ILBIOF)
      LIOX = LZBS(LDIR-ILBIOX)
      LEVH = LZBS(LDIR-ILBEVH)

      IERR = 0

      IZBS(LEXF+IPDIR) = 1
      IZBS(LIOF+IPDIR) = 1

*-- Create Bank Records

      IBANK = IZBS(LPNT+IPDIR)

      CALL KZCRBN(ITYPE,IBANK,CNAME,NWMAST,NWSMST,NSEGM,LSEGM)

      IOX = IZBS(LIOX+IPDIR)
      IEVH = IZBS(LEVH+IPDIR)

      CALL KZGETH(IDATA)

      IEVH0 = IDATA(1)

      IF (IOX.EQ.0 .OR. IEVH0.NE.IEVH) THEN

         CALL KZFORM(CNAME,CFORMM,CFORMS,IOX,IERIOX)

         IF (IERIOX.NE.0) THEN
            IERR = IERIOX
            RETURN
         END IF

         IZBS(LIOX+IPDIR) = IOX
         IZBS(LEVH+IPDIR) = IEVH0

      END IF

      CALL KZCRD1(IBANK,CNAME,NWMAST,NSEGM,LSEGM,IOX)

      RETURN
      END
