************************************************************************
*
*     ------------------------------
      SUBROUTINE KZDUMP(CNAME,IFLAG)
*     ------------------------------
*
*     (Purpose)
*       Print out contents of the specified bank.
*
*     (Input)
*       CNAME ; Name of the bank
*       IFLAG ; 
*
*     (Output)
*       none
*
*     (Creation Date and Author)
*       1992.12.18 ; First version by J.Kanzaki
*
************************************************************************


#include "zbssys.inc"
#include "zbs.inc"

      CHARACTER*(*) CNAME

      INTEGER*4 LBIR


      LDIR = LZBS(IPDIRT)
      LUN  = IZBS(LDIR+INLUN)

      CALL KZBLOC(CNAME, LBIR)

      IF(LBIR.LE.0) THEN
         WRITE(LUN,
     &   '(5(/),'' '',''<< KZDUMP ; Bank '',A,'' does not exist. >>'')')
     &    CNAME
         RETURN
      END IF

      WRITE(LUN,
     &'(5(/),'' '',''<< KZDUMP ; Bank '',A,'' dump list. >>'')')
     & CNAME

      ITYPE=IZBS(LBIR+IBKTYP)

C     free format bank

      IF(ITYPE.EQ.0) THEN

         CALL KZDMP0(LBIR,IFLAG)

C     fixed 1-dim. case

      ELSE IF(ITYPE.EQ.1) THEN

         CALL KZDMP1(LBIR,IFLAG)

C     fixed 2-dim. case

      ELSE IF(ITYPE.EQ.2) THEN

         CALL KZDMP2(LBIR,IFLAG)

      END IF

      RETURN
      END
