************************************************************************
*     -----------------
      SUBROUTINE KZMKDT
*     -----------------
*
*     (Purpose)
*       Create bank directory table for the current event
*
*     (Input)
*
*     (Output)
*
*     (Comment)
*
*     (Creation Date and Author)
*       1994.06.14 ; First version by J.Kanzaki
*       1996.04.26 : Add declarations. J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbssys.inc"
#include "zbs.inc"

      CHARACTER*32 CNAME

      INTEGER NLBIR,NSBIR,IOBIR
      PARAMETER (NLBIR=3,NSBIR=3,IOBIR=2)
      INTEGER NDBIR

      INTEGER NLNAME,NSNAME,IONAME
      PARAMETER (NLNAME=0,NSNAME=0,IONAME=5)
      INTEGER NDNAME
      PARAMETER (NDNAME=LBNAME)
      
      INTEGER INAME(LBNAME)

      INTEGER LEVC,LEMB,LEHD,LBIR,LNAME

      INTEGER LDIR,LEXF,LSRT,LPNT,LIOF

      INTEGER IPFIND,IPDIR,NBANK,IBANK

      INTEGER IXEVTD
      INTEGER LPUSH,NS,ND

      INTEGER KZNAME

      INTEGER I


***** Get pointers to the bank directory table
      LDIR = LZBS(IPDIRT)
      
      LEXF = LZBS(LDIR-ILBEXF)
      IF (LEXF.LE.0) RETURN
      
      NBANK = IZBS(LDIR+INBANK)
      IF (NBANK.GT.0) THEN
         
         DO 10 IBANK = 1,NBANK
            IZBS(LEXF+IBANK) = 0
 10      CONTINUE
         
      END IF
      
***** Get pointer to the event control bank
      
      LEVC = LZBS(IPEVC)
      
      LEMB = LZBS(LEVC-ILEMCR)
      LEHD = LZBS(LEMB-ILEHCR)
      
      LBIR = LZBS(LEHD-ILBILS)
      
      IF (LBIR.LE.0) RETURN
      
***** Read next record. This should be bank header or event trailer.
 100  CONTINUE

      NS = IZBS(LBIR-2)

      IF (ILNAME.GT.NS) THEN

         LPUSH = NLBIR-NS
         CALL MZPUSH(IXSTOR,LBIR,LPUSH,0,' ')
      
*-- Create space for bank names
         CALL UHTOC(IZBS(LBIR+1),4,CNAME,4*LBNAME)
         IXEVTD = IXDIV(2)
         CALL MZBOOK(IXEVTD,LNAME,LBIR,-ILNAME,
     &        CNAME(1:4),NLNAME,NSNAME,NDNAME,IONAME,0)
         
         IF (IFEXCN.EQ.0) THEN
            DO 110 I=1,LBNAME
               IZBS(LNAME+I) = IZBS(LBIR+I)
 110        CONTINUE
         ELSEIF (IFEXCN.EQ.1) THEN
            DO 115 I=1,LBNAME
               CALL KZEXCN(IZBS(LBIR+I),IZBS(LNAME+I))
 115        CONTINUE
         ENDIF

         ND = IZBS(LBIR-1)

         DO 120 I=1,ND-LBNAME
            IZBS(LBIR+I) = IZBS(LBIR+LBNAME+I)
 120     CONTINUE

         IF (ND.LT.LINDHD+LBNAME) THEN
            DO 125 I=ND+1-LBNAME,LINDHD
               IZBS(LBIR+I) = 0
 125        CONTINUE
         ENDIF

         LPUSH = ND-LINDHD
         CALL MZPUSH(IXSTOR,LBIR,0,-LPUSH,' ')
         
      ENDIF
      
      LNAME = LZBS(LBIR-ILNAME)
      DO 130 I=1,LBNAME
         INAME(I) = IZBS(LNAME+I)
 130  CONTINUE
      CALL UHTOC(INAME,4,CNAME,4*LBNAME)
      
***** Search for Bank "CNAME" from the Directory
      IPFIND = KZNAME(CNAME)
      IF (IPFIND.EQ.0) RETURN
      
***** Get Pointers to the System Mother Bank and the Bank Directory
      LDIR = LZBS(IPDIRT)
      
      LEXF = LZBS(LDIR-ILBEXF)
      IF (LEXF.LE.0) RETURN
      LSRT = LZBS(LDIR-ILBSRT)
      IF (LSRT.LE.0) RETURN
      
***** "CNAME" is found in the directory table.
      IF (IPFIND.GT.0) THEN
         
         IPDIR = IZBS(LSRT+IPFIND)
         
***** If Bank of Speicified Name "CNAME" is not Found in the Directory,
*     Create New Entry in the Bank Directory.
         
      ELSE
         
         CALL KZADDN(IPFIND,CNAME,IPDIR)
         
      END IF
      
***** Store Informations on the New Bank into the Directory
      
      LEXF = LZBS(LDIR-ILBEXF)
      LSRT = LZBS(LDIR-ILBSRT)
      
      LPNT = LZBS(LDIR-ILBPNT)
      IF (LPNT.LE.0) RETURN
      LIOF = LZBS(LDIR-ILBIOF)
      IF (LIOF.LE.0) RETURN
      
      IZBS(LEXF+IPDIR) = 1
      IZBS(LIOF+IPDIR) = 1
      
***** Pointer# to store the address of bank
      IBANK = IZBS(LPNT+IPDIR)
      
      LZBS(IBANK) = LBIR
      
      LBIR = LZBS(LBIR)
      
      IF (LBIR.GT.0) GO TO 100

      RETURN
      END
