************************************************************************
*     -----------------------------------------------
      SUBROUTINE KZREP2(CNAME,ISEGM,ISSEG,NDATA,IDATA)
*     -----------------------------------------------
*
*     (Purpose)
*       Put data words into the given segment of the bank.
*
*     (Input)
*       CNAME ; The name of the bank
*       ISEGM ; Segment#
*       ISSEG ; Sub-segment#
*       CFORM ; I/O format word in a character
*       NDATA ; Length of the data
*       IDATA ; Data words to be added
*
*     (Output)
*       none
*
*     (Creation Date and Author)
*       1991.12.25 ; First version by J.Kanzaki
*       1996.04.26 : Add declarations. J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbs.inc"
#include "zbssys.inc"

      CHARACTER*(*) CNAME
      INTEGER ISEGM,ISSEG,NDATA,IDATA(*)

      INTEGER LBIR,LDATA
      INTEGER ITYPE
      INTEGER NWMAST,NSEGM,NWSMST,LSEGM,LDAT,LSMST

      INTEGER I


      CALL KZBLOC(CNAME, LBIR)

      IF (LBIR.LE.0) RETURN

      LDATA = NDATA

      ITYPE = IZBS(LBIR+IBKTYP)

      IF (ITYPE.NE.2) RETURN

      NWMAST = IZBS(LBIR+INMAST)
      NSEGM  = IZBS(LBIR+INSEGM)
      NWSMST = IZBS(LBIR+INSMST)
      LSEGM  = IZBS(LBIR+ILSEGF)
      IF (ISEGM.LT.0) THEN
         CALL MSGOUT('KZREP2',
     &        'Illegal segment# is specified',1)
         RETURN
      END IF
      
*-- Check data size
      IF (ISEGM.GT.0 .AND. ISSEG.GT.0 .AND. NDATA.NE.LSEGM) THEN
         CALL MSGOUT('KZREP2',
     &        'DATA length is larger than pre-defined value',2)
         RETURN
      END IF
      
      IF (ISEGM.GT.0 .AND. ISSEG.EQ.0 .AND. NDATA.NE.NWSMST) THEN
         CALL MSGOUT('KZREP2',
     &        'DATA length is larger than pre-defined value',3)
         RETURN
      END IF

      IF (ISEGM.EQ.0 .AND. NDATA.NE.NWMAST) THEN
         CALL MSGOUT('KZREP2',
     &        'DATA length is larger than pre-defined value',4)
         RETURN
      END IF
      
      IF (ISEGM.GT.NSEGM) THEN
         CALL KZEXB2(LBIR,ISEGM)
      ENDIF
         
      IF (ISEGM.EQ.0 .OR. ISSEG.GT.0) THEN

         IF (ISEGM.GT.IZBS(LBIR+INSGMX)) THEN
            IZBS(LBIR+INSGMX) = ISEGM
         ENDIF
         
         CALL KZWPS2(CNAME,ISEGM,ISSEG,0,LSEGM, LDAT)
         
      ELSEIF (ISSEG.EQ.0) THEN

         IF (ISEGM.GT.IZBS(LBIR+INSGMX)) THEN
            IZBS(LBIR+INSGMX) = ISEGM
         ENDIF
                  
         LSMST = LZBS(LBIR-ILSMST)
         LDAT = LSMST+NWSMST*(ISEGM-1)
         
      ENDIF

      DO 200 I=1,NDATA
         IZBS(LDAT+I) = IDATA(I)
 200  CONTINUE
         
      RETURN
      END
